// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  16 setiembre 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//
// BSAS BabyShowerAnimalesSalvajes
// El archivo dibuja animales para BabyShower, en estereofon.
// Es poco flexible, pero permite cambiar la textura.
// La version original del conejo y ballena se creo en el
// programa Epspline.exe para Windows.
// Lamentablemente este archivo no es compatible con POVRay 3.1.
//
// Las macros no tienen parametros.
// #macro BSAS_Elefante() 
// #macro BSAS_Ballena() 
// #macro BSAS_CaraConejo() 
//                     
// Dibujan respectivamente un elefante, ballena y cara de conejo.
//
// Las caracteristicas de los objetos son: 
// Elefante
//      Altura                  : 151*L
//      Frente                  : 100*L
//      Grueso                  :  20*L
// Ballena
//      Altura                  :  80*L   
//      Frente                  : 303*L
//      Grueso                  :  20*L
// Conejo
//      Altura                  : 150*L
//      Frente                  :  95*L
//      Grueso                  :  20*L   
//
// La figura se coloca directamente sobre el plano XZ, casi centrado.
// El objeto es visible por ambos frentes Z+ y Z-.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare BSAS_DefaultTexturaEscarcha                 = texture  { ... }
//      La textura a aplicar a la escarcha.
// #declare BSAS_DefaultTexturaEstereofon               = texture  { ... } 
//      La textura a aplicar al estereofon.
// #declare BSAS_DefaultTexturaGloboOcular              = texture  { ... } 
//      La textura a aplicar al Globo Ocular.
// #declare BSAS_DefaultTexturaCornea                   = texture  { ... }
//      La textura a aplicar a la cornea.
// #declare BSAS_DefaultTexturaIris                     = texture  { ... }
//      La textura a aplicar al iris.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)  
// #declare BSAS_TexturaEscarcha                        = texture  { ... }
//      La textura a aplicar a la escarcha.
// #declare BSAS_TexturaEstereofon                      = texture  { ... } 
//      La textura a aplicar al estereofon.
// #declare BSAS_TexturaGloboOcular                     = texture  { ... } 
//      La textura a aplicar al Globo Ocular.
// #declare BSAS_TexturaCornea                          = texture  { ... }
//      La textura a aplicar a la cornea.
// #declare BSAS_TexturaIris                            = texture  { ... }
//      La textura a aplicar al iris.  
// #declare BSAS_Semilla                                = 1000;
//      Semilla para la aleatoriedad del elefante.
// #declare BSAS_Semilla2                               = 2000;
//      Semilla para la aleatoriedad de la ballena.      
// #declare BSAS_Semilla3                               = 3000;
//      Semilla para la aleatoriedad de la cara de conejo.
//
// 
// Para colocarlo simplemente
// #include "BSAS.inc"
// object        { BSAS_Elefante() }
//
// Otro ejemplo con modificador
// #include "BSAS.inc"
// #declare BSAS_DefaultTexturaEstereofon        = texture       {
//   average
//   texture_map        {
//     [ 0.5 BSAS_TexturaEstereofon ]
//     [ 0.5 Rust                   ]
//   }                              
// }
// object        {
//   BSAS_Elefante( 0,0,0,0 )
// }
//

#declare BSAS_Semilla                   = 1000;
#declare BSAS_Semilla2                  = 2000;      
#declare BSAS_Semilla3                  = 3000;      

#declare BSAS_PerimetroBallena_USE_NORMAL_TRANSFORM     = on;  
#declare BSAS_ConejoPerimetro_USE_NORMAL_TRANSFORM      = on;
#include "BSAS_AU1.inc"                                      
#include "BSAS_AU2.inc"


#declare BSAS_DefaultTexturaEscarcha    =
  texture               {
    pigment         {
      granite
      pigment_map   {
        [ 0 Silver ] 
        [ 0.25 Red*0.9+White*0.1 ]
        [ 0.5 Clear ]
        [ 1 Clear  ]
      }
    }
  }                  
  
#declare BSAS_TexturaEscarcha           =
  texture       { BSAS_DefaultTexturaEscarcha }  

#declare BSAS_DefaultTexturaEstereofon  = 
      texture                {
        pigment                 {
          crackle form <-1,1.25,0.1>        
          metric 1.10
          scale 2
          pigment_map           {
            [ 0 Cyan ]
            [ 1 Cyan*0.90+Blue*0.10 ]                  
          }
        }     
        normal                  {  
          facets    
          coords  0.30
          size    1
        } 
      }                                   

#declare BSAS_TexturaEstereofon         =
    texture     { BSAS_DefaultTexturaEstereofon }
    
#declare BSAS_DefaultTexturaGloboOcular =
    texture                             {
      pigment           { 
        White 
      } 
      normal            {
        wood 
        sine_wave
        turbulence      0.1   
        scale           2
      }
    }                           
    
#declare BSAS_TexturaGloboOcular        =
    texture             { BSAS_DefaultTexturaGloboOcular }
    
#declare BSAS_DefaultTexturaCornea      =
    texture                             {
      pigment           { White transmit 0.90 }
    }                                        
    
#declare BSAS_TexturaCornea             =
    texture             { BSAS_DefaultTexturaCornea }
    
#declare BSAS_DefaultTexturaIris        =
   texture                              {
     pigment            { Gray10 }
   }                             
   
#declare BSAS_TexturaIris               =
   texture              { BSAS_DefaultTexturaIris }   
      
#macro BSAS_Ojos(S)
  union                         { 
   
    cylinder                    {
      0, -0.025*z, 1    
      scale             <1,1.0,1>
      texture                   {
        BSAS_TexturaGloboOcular 
        translate                  0.2*(rand(S)-0.5)*<1,1,10>
      }
    }                       
    difference                  {
      sphere                    {
        0, 0.95                   
        scale           <1,1.0,0.5>
      }      
      sphere                    {
        0, 0.94                 
        scale           <1,1.0,0.5>
      }  
      plane                     {
        -z, 0
      }        
      texture                   {
        BSAS_TexturaCornea
      }
    }                               
    cylinder                    {
      0, -0.1*z,  0.50
      rotate            25*y*( rand(S)-0.5 ) 
      rotate            25*z*( rand(S)-0.5 )       
      translate         +0.50*y 
      translate         -0.20*z
      translate         -0.80*y-0.10*(rand(S)-0.5)+0.45*x*( rand(S)-0.5 )  
      texture                   {
        BSAS_TexturaIris
      }
    }
  }  // union
#end  // #macro BSAS_Ojos      
 

   
#macro BSAS_Ballena() 
  union                 { 
    #local S            = seed( BSAS_Semilla2 );
    object              {
      BSAS_PerimetroBallena 
      rotate            -90*x
      scale             < 1,1,0.05> 
      texture           {
        BSAS_TexturaEstereofon   
        scale           0.025
      }
    } 
    #local C            = 0;
    #while ( C < 2 )          
      union             {  
        #local RR       = 16;
        intersection    {  
          object                {
            BSAS_PerimetroBallena
            rotate      -90*x
            scale       < 1,1,0.10>
          }                           
          union                 {
          sphere_sweep          {
            cubic_spline,
            BSAS_TotalPerimetroBallena,
            #local D            = 0;
            #while ( D < BSAS_TotalPerimetroBallena )
              <BSAS_ArregloBallena[D].x,0,BSAS_ArregloBallena[D].y>,RR
              #local D          = D+1;
            #end            
            transform           {
              BSAS_PerimetroBallena_NORMAL_TRANSFORM
            }   
            rotate              -90*x
            scale       <1,1,0.0001>
          }      
          #local RR             = RR/2;
          sphere_sweep          {
            cubic_spline,
            BSAS_AletaBallena_ARRAY_COUNT,
            #local D            = 0;
            #while ( D < BSAS_AletaBallena_ARRAY_COUNT )
              <BSAS_AletaBallena[D].x,0,BSAS_AletaBallena[D].y>,RR
              #local D          = D+1;
            #end            
            transform           {
              BSAS_PerimetroBallena_NORMAL_TRANSFORM
            }   
            rotate              -90*x
            scale       <1,1,0.0001>
          }
          sphere_sweep          {
            cubic_spline,
            BSAS_GuiaColaHorizontal_ARRAY_COUNT,
            #local D            = 0;
            #while ( D < BSAS_GuiaColaHorizontal_ARRAY_COUNT )
              <BSAS_GuiaColaHorizontal[D].x,0,BSAS_GuiaColaHorizontal[D].y>,RR
              #local D          = D+1;
            #end            
            transform           {
              BSAS_PerimetroBallena_NORMAL_TRANSFORM
            }   
            rotate              -90*x
            scale       <1,1,0.0001>
          }
          } 
          texture       {       
            BSAS_TexturaEscarcha   
            scale               0.01
          }
        }      
        object          {
          BSAS_Ojos(S)
          scale         0.0375
          translate     0.35*x+0.05*y
        }
        translate       -0.050*z
        #if ( C = 0 ) 
          scale         <1,1,-1>
        #end
      }
      #local C          = C+1;
    #end  //  #while ( C < 2 )
    translate           0.130*y 
    scale               0.6*1/4  
    scale               <2,2,1>
  }
#end

#macro BSAS_ConejoInterno(Conteo, MyArreglo, RR)
  sphere_sweep          {
            cubic_spline,
            Conteo,
            #local D            = 0;
            #while ( D < Conteo )
              <MyArreglo[D].x,0,MyArreglo[D].y>,RR
              #local D          = D+1;
            #end            
            transform           {
              BSAS_ConejoPerimetro_NORMAL_TRANSFORM  
            }   
            rotate              -90*x
            scale       <1,1,0.0001> 
  }                                        
#end

#macro BSAS_Elefante()
  union                 {  
    #local S            = seed( BSAS_Semilla );
    #local ObjetoPrism  =
    prism               {  
      cubic_spline
      0, -1, 53,
      <-1,-19>,
      <0,-20>,
      <2,-20.9>,
      <5,-20>, 
      <6,-19.5>,
      <10,-18>,
      <+11.75,-15>,
      <+11.5,-14>,
      <+12,-12>,
      <9,-9>,     
      <7.6,-4>,
      <5.5,0>, 
      <6.75,3>,
      <7,5>, 
      <8.75,6>,    
      <9,7>,
      <11.3,8>,
      <12,10>,  
      <12.8,11>,
      <13,12>, 
      <8.5,15.5>,
      <5,12>,  
      <4,15>,
      <0.5,19>, 
      <0.6,19.5>,
      <0,20>,  
      <-2,20>,
      <-1.5,22.7>,
      <-3,20>, 
      <-5,18.75>, 
      <-6,18>,
      <-6,17>,  
      <-7.3,12>,
      <-7.1,7.6>,
      <-10,8.4>,
      <-12,8>, 
      <-14,6>,
      <-14,2>, 
      <-12,2>,
      <-11,0>,
      <-12.6,-2.5>,
      <-10,-4>,  
      <-7,-3.7>,  
      <-8.8,-8>, 
      <-11.2,-11>,
      <-12,-14>, 
      <-11,-17>,
      <-6.6,-20>,
      <-6,-19.5>,  
      <-3,-21.25>,
      <-1,-21>,
      <0,-20>,  
      <1,-19>   
      rotate        -90*x
    }
    object                      {
      ObjetoPrism      
      scale             5*z
      texture                   {  
        BSAS_TexturaEstereofon
      }
    }
    #local C                    = 0;
    #while ( C < 2 )  
      union                     {
        intersection                { 
          object                    {
            ObjetoPrism
            translate               -0.5*z
            scale                   2*z
          }
          #local RR                 = 1; 
          union                 {                      
          sphere_sweep              {   
            cubic_spline
      53,
      <-1,-19,0>,RR,
      <0,-20,0>,RR,
      <2,-20.9,0>,RR,
      <5,-20,0>,RR, 
      <6,-19.5,0>,RR,
      <10,-18,0>,RR,
      <+11.75,-15,0>,RR,
      <+11.5,-14,0>,RR,
      <+12,-12,0>,RR,
      <9,-9,0>,RR,     
      <7.6,-4,0>,RR,
      <5.5,0,0>,RR, 
      <6.75,3,0>,RR,
      <7,5,0>,RR, 
      <8.75,6,0>,RR,    
      <9,7,0>,RR,
      <11.3,8,0>,RR,
      <12,10,0>,RR,  
      <12.8,11,0>,RR,
      <13,12,0>,RR, 
      <8.5,15.5,0>,RR,
      <5,12,0>,RR,  
      <4,15,0>,RR,
      <0.5,19,0>,RR, 
      <0.6,19.5,0>,RR,
      <0,20,0>,RR,  
      <-2,20,0>,RR,
      <-1.5,22.7,0>,RR,
      <-3,20,0>,RR, 
      <-5,18.75,0>,RR, 
      <-6,18,0>,RR,
      <-6,17,0>,RR,  
      <-7.3,12,0>,RR,
      <-7.1,7.6,0>,RR,
      <-10,8.4,0>,RR,
      <-12,8,0>,RR, 
      <-14,6,0>,RR,
      <-14,2,0>,RR, 
      <-12,2,0>,RR,
      <-11,0,0>,RR,
      <-12.6,-2.5,0>,RR,
      <-10,-4,0>,RR,  
      <-7,-3.7,0>,RR,  
      <-8.8,-8,0>,RR, 
      <-11.2,-11,0>,RR,
      <-12,-14,0>,RR, 
      <-11,-17,0>,RR,
      <-6.6,-20,0>,RR,
      <-6,-19.5,0>,RR,  
      <-3,-21.25,0>,RR,
      <-1,-21,0>,RR,
      <0,-20,0>,RR,  
      <1,-19,0>,RR  
        scale           0.1*z  
        texture         { 
          BSAS_TexturaEscarcha
        }                     
            }  // sphere_sweep  
            #local RR           = RR/2;
            sphere_sweep              {   
              cubic_spline
              7,   
              <-10,-4,0>,RR,
              <-7,-3.7,0>,RR,  
              <-4.9,-4.8,0>,RR,
              <-1,-6,0>,RR,  
              <3.50,0,0>,RR,
              <4.30,5.5,0>,RR,
              <4,10,0>,RR
              scale           0.20*z  
              texture           {
                BSAS_TexturaEscarcha
              }  
            }  // sphere_sweep  
            sphere_sweep        { 
              cubic_spline  
              5,           
              <-12.6,-2.5,0>,RR,
              <-11,0,0>,RR,     
              <-5,-0.5,0>,RR,
              <-3.5,0.5,0>,RR,
              <-3.5,3,0>,RR
              scale             0.20*z
              texture           {
                BSAS_TexturaEscarcha
              }
            } 
            sphere_sweep        {  
              cubic_spline
              5,
              <-4.9,0,0>,RR,
              <-4.9,-4.8,0>,RR,
              <-3,-10,0>,RR,
              <0,-14,0>,RR,
              <3,-16,0>,RR
              scale     0.20*z
              texture           {
                BSAS_TexturaEscarcha
              }
            } 
            sphere_sweep                {
              cubic_spline
              5,   
              <5,-3,0>,RR,                 
              <2.1,-8.1,0>,RR,
              <0,-14,0>,RR,
              <0,-20,0>,RR,
              <1,-26,0>,RR
              scale     0.20*z
              texture                   {
                BSAS_TexturaEscarcha
              }
            }       
            sphere_sweep                {
              cubic_spline
              6, 
              <-6,-1,0>,RR,
              <-6.3,-4.9,0>,RR,
              <-6,-10.6,0>,RR,
              <-5.3,-12.5,0>,RR,
              <-6,-19.5,0>,RR,
              <-5,-23,0>,RR
              scale     0.20*z
              texture                   {
                BSAS_TexturaEscarcha
              }
            }
            sphere_sweep                {
              cubic_spline
              4,
              <-4,-13,0>,RR,
              <-6,-10.6,0>,RR,
              <-8.8,-8,0>,RR,
              <-10,-8,0>,RR
              scale     0.20*z
              texture                   {
                BSAS_TexturaEscarcha
              }
            } 
            sphere_sweep                {
              cubic_spline
              5,
              <-3,-15,0>,RR,
              <-5.3,-12.5,0>,RR,
              <-9,-13,0>,RR,
              <-8,-19,0>,RR,
              <-6,-23,0>,RR              
              scale     0.20*z
              texture                   {
                BSAS_TexturaEscarcha
              }
            }
            sphere_sweep                {
              cubic_spline
              6,
              <5,-6.2,0>,RR,
              <6.2,-6.2,0>,RR,
              <6.3,-9.3,0>,RR,
              <5.7,-12.7,0>,RR,
              <6,-19.5,0>,RR,
              <6.5,-22,0>,RR
              scale     0.20*z
              texture                   {
                BSAS_TexturaEscarcha
              }
            }
            sphere_sweep                {
              linear_spline
              2,
              <6.3,-9.3,0>,RR,
              <9,-7,0>,RR
              scale     0.20*z
              texture                   {
                BSAS_TexturaEscarcha
              }
            }
            sphere_sweep                {
              cubic_spline
              6,
              <0,-20,0>,RR,
              <5.9,-12.7,0>,RR,  
              <8,-13,0>,RR,
              <9.2,-15.8,0>,RR,
              <8,-19.2,0>,RR,
              <6,-23,0>,RR
              scale     0.20*z
              texture                   {
                BSAS_TexturaEscarcha
              }
            }
            sphere_sweep                {
              linear_spline
              2,
              <5.7,10.4,0>,RR,
              <10,14.3,0>,RR
              scale     0.20*z
              texture                   {
                BSAS_TexturaEscarcha
              }
            }
            sphere_sweep                {
              linear_spline
              2,
              <-7.8,5.3,0>,RR,
              <-12.9,6.8,0>,RR
              scale     0.20*z
              texture                   {
                BSAS_TexturaEscarcha
              }
            }
            sphere_sweep                {
              linear_spline
              7,
              <-6,17.2,0>,RR, 
              <-4,17,0>,RR,
              <-4,15,0>,RR,
              <-2.5,17,0>,RR,
              <-1,16,0>,RR, 
              <-1,18,0>,RR,
              <0.25,17.75,0>,RR
              scale     0.20*z
              texture                   {
                BSAS_TexturaEscarcha
              }
            }
            sphere_sweep                {
              linear_spline
              3,
              <1.5,-21,0>,RR,
              <2.75,-16.8,0>,RR,
              <3,-21,0>,RR
              scale     0.20*z
              texture                   {
                BSAS_TexturaEscarcha
              }
            }
            sphere_sweep                {
              linear_spline
              2,
              <4,-21,0>,RR,
              <5.25,-16.2,0>,RR
              scale     0.20*z
              texture                   {
                BSAS_TexturaEscarcha
              }
            }
            sphere_sweep                {
              linear_spline
              3,
              <-1.5,-21,0>,RR,
              <-2.75,-16.8,0>,RR,
              <-3,-21,0>,RR
              scale     0.20*z
              texture                   {
                BSAS_TexturaEscarcha
              }
            }
            sphere_sweep                {
              linear_spline
              2,
              <-4,-21,0>,RR,
              <-5.25,-16.2,0>,RR
              scale     0.20*z
              texture                   {
                BSAS_TexturaEscarcha
              }
            }
            sphere_sweep                {
              linear_spline
              3,
              <5,12,0>,RR,
              <7,9,0>,RR,
              <7,5,0>,RR
              scale     0.20*z
              texture                   {
                BSAS_TexturaEscarcha
              }
            }
            sphere_sweep                {
              linear_spline
              3,
              <-7.1,7.6,0>,RR,
              <-7.75,4,0>,RR,
              <-6.9,1,0>,RR
              scale     0.20*z
              texture                   {
                BSAS_TexturaEscarcha
              }
            }          
            object                      {
              BSAS_Ojos(S) 
              scale             2
              translate         <-4,10,0>
            }  
            object                      {
              BSAS_Ojos(S) 
              scale             2
              translate         <1,11,0>
            }  
          } // union     
        } // intersection
        #if ( C = 0 )  
          scale                 <1,1,-1>
          translate             +5*z
        #end
      }  // union
    #local C            = C+1;
    #end    
    translate                   2.5*z
    scale         0.020   
    translate   -0.1*z+0.425*y
    scale        <0.9,0.9,0.7>
    scale       1/5    
    translate   +0.002*x
  }
#end 

#macro BSAS_CaraConejo() 
  union                 { 
    #local S            = seed( BSAS_Semilla3 );
    object              {
      BSAS_ConejoPerimetro 
      rotate            -90*x
      scale             < 1,1,0.05> 
      texture           {
        BSAS_TexturaEstereofon   
        scale           0.025
      }
    }   
    
    #local C            = 0;
    #while ( C < 2 )          
      union             {  
        #local RR       = 12;
        intersection    {  
          object                {
            BSAS_ConejoPerimetro
            rotate      -90*x
            scale       < 1,1,0.10>
          }                           
          union                 {
          sphere_sweep          {
            cubic_spline,
            BSAS_TotalConejoPerimetro,
            #local D            = 0;
            #while ( D < BSAS_TotalConejoPerimetro )
              <BSAS_ArregloConejo[D].x,0,BSAS_ArregloConejo[D].y>,RR
              #local D          = D+1;
            #end            
            transform           {
              BSAS_ConejoPerimetro_NORMAL_TRANSFORM
            }   
            rotate              -90*x
            scale       <1,1,0.0001>
          texture       {       
            BSAS_TexturaEscarcha   
            scale               0.01
          } 
          } 
          union                 {     
            #local RR             = RR/2; 
            object                {
              BSAS_ConejoInterno(BSAS_ConejoBoca_ARRAY_COUNT,
                                 BSAS_ConejoBoca,RR)
            }
            object                {
              BSAS_ConejoInterno(BSAS_ConejoMarcaFrente_ARRAY_COUNT,
                                 BSAS_ConejoMarcaFrente,RR)
            }
            object                {
              BSAS_ConejoInterno(BSAS_OrejaInterna1_ARRAY_COUNT,
                                 BSAS_OrejaInterna1,RR)
            }
            object                {
              BSAS_ConejoInterno(BSAS_OrejaInterna2_ARRAY_COUNT,
                                 BSAS_OrejaInterna2,RR)
            }
            object                {
              BSAS_ConejoInterno(BSAS_ConejoOjoIzquierdo_ARRAY_COUNT,
                                 BSAS_ConejoOjoIzquierdo,RR)
            }
            object                {
              BSAS_ConejoInterno(BSAS_ConejoOjoDerecho_ARRAY_COUNT,
                                 BSAS_ConejoOjoDerecho,RR)
            }
            object                {
              BSAS_ConejoInterno(BSAS_ConejoBigoteIzquierdo_ARRAY_COUNT,
                                 BSAS_ConejoBigoteIzquierdo,RR)
            }
            object                {
              BSAS_ConejoInterno(BSAS_ConejoBigoteDerecho_ARRAY_COUNT,
                                 BSAS_ConejoBigoteDerecho,RR)
            }                                            
            object                {
              BSAS_ConejoInterno(BSAS_ConejoNariz_ARRAY_COUNT,
                                 BSAS_ConejoNariz,RR)
            }            
          }
          texture       {       
            BSAS_TexturaEscarcha   
            scale               <0.01,0.01,0.10>
          }
          } 
        }  
           
        object          {
          BSAS_Ojos(S)
          scale         0.0375
          translate     0.125*x-0.125*y
        }
        object          {
          BSAS_Ojos(S)
          scale         0.0375
          translate     -0.125*x-0.150*y
        }
        translate       -0.050*z
        #if ( C = 0 ) 
          scale         <1,1,-1>
        #end
      }
      #local C          = C+1;
    #end  //  #while ( C < 2 )
    translate           0.500*y 
    scale               0.6*1/4
  }
#end


