// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  16 setiembre 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//
// BSAS BabyShowerAnimalesSalvajes
// El archivo dibuja animales para BabyShower, en estereofon.
// Es poco flexible, pero permite cambiar la textura.
// La version original del conejo y ballena se creo en el
// programa Epspline.exe para Windows.
// Lamentablemente este archivo no es compatible con POVRay 3.1.
//
// Las macros no tienen parametros.
// #macro BSAS_Elefante() 
// #macro BSAS_Ballena() 
// #macro BSAS_CaraConejo() 
//                     
// Dibujan respectivamente un elefante, ballena y cara de conejo.
//
// Las caracteristicas de los objetos son: 
// Elefante
//      Altura                  : 151*L
//      Frente                  : 100*L
//      Grueso                  :  20*L
// Ballena
//      Altura                  :  80*L   
//      Frente                  : 303*L
//      Grueso                  :  20*L
// Conejo
//      Altura                  : 150*L
//      Frente                  :  95*L
//      Grueso                  :  20*L   
//
// La figura se coloca directamente sobre el plano XZ, casi centrado.
// El objeto es visible por ambos frentes Z+ y Z-.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare BSAS_DefaultTexturaEscarcha                 = texture  { ... }
//      La textura a aplicar a la escarcha.
// #declare BSAS_DefaultTexturaEstereofon               = texture  { ... } 
//      La textura a aplicar al estereofon.
// #declare BSAS_DefaultTexturaGloboOcular              = texture  { ... } 
//      La textura a aplicar al Globo Ocular.
// #declare BSAS_DefaultTexturaCornea                   = texture  { ... }
//      La textura a aplicar a la cornea.
// #declare BSAS_DefaultTexturaIris                     = texture  { ... }
//      La textura a aplicar al iris.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)  
// #declare BSAS_TexturaEscarcha                        = texture  { ... }
//      La textura a aplicar a la escarcha.
// #declare BSAS_TexturaEstereofon                      = texture  { ... } 
//      La textura a aplicar al estereofon.
// #declare BSAS_TexturaGloboOcular                     = texture  { ... } 
//      La textura a aplicar al Globo Ocular.
// #declare BSAS_TexturaCornea                          = texture  { ... }
//      La textura a aplicar a la cornea.
// #declare BSAS_TexturaIris                            = texture  { ... }
//      La textura a aplicar al iris.  
// #declare BSAS_Semilla                                = 1000;
//      Semilla para la aleatoriedad del elefante.
// #declare BSAS_Semilla2                               = 2000;
//      Semilla para la aleatoriedad de la ballena.      
// #declare BSAS_Semilla3                               = 3000;
//      Semilla para la aleatoriedad de la cara de conejo.
//
// 
// Para colocarlo simplemente
// #include "BSAS.inc"
// object        { BSAS_Elefante() }
//
// Otro ejemplo con modificador
// #include "BSAS.inc"
// #declare BSAS_DefaultTexturaEstereofon        = texture       {
//   average
//   texture_map        {
//     [ 0.5 BSAS_TexturaEstereofon ]
//     [ 0.5 Rust                   ]
//   }                              
// }
// object        {
//   BSAS_Elefante( 0,0,0,0 )
// }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    
  
#include "BSAS.inc"
#local FactorAcercamiento       = 4.25;

union                           {  
  object                        {
    BSAS_Elefante( )
    translate           -0.135*x
  }
  object                        {
    BSAS_CaraConejo( )
    translate           +0.125*x+0.050*y
  }
  object                        {
    BSAS_Ballena( )      
    translate           0.075*x-0.050*y
  }                  
  translate             -0.075*y-0.020*x             
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
}
