// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 11 noviembre 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//                      
// BVPP BarcoVeleroParaPiscina
// El archivo dibuja un barco velero, basada en un juguete
// a control remoto.  Se modifico ligeramente, para mejorar su apariencia
// y poderlo exhibir en escenas de mayor realismo.  Aunque probablemente
// falle en el acercamiento.
// Incluye macro para modificar texturas.  Es compatible con POVRay 3.1.
//      
// La siguiente macro dibuja el objeto default: 
// #macro BVPP_Barco()    
//                                             
// Las dimensiones del objetos default son :  
//      Minimo                  : <-9.75, -3.3,-2.35>
//      Maximo                  : <+9.00, 22.5,+2.35>  
// En el plano XY se encuentra la base de baranda.
// El verdero piso se encuentra por debajo del plano. 
// 
// La siguiente macro permite modificar las texturas facilmente:                               
// #macro BVPP_BarcoVeleroParaPiscina(
//      MaterialCasco, MaterialCabina, MaterialBorde, MaterialPiso,
//      MaterialVentanas, MaterialBaranda,   MaterialMastil,
//      MaterialVelaPosterior, MaterialVelaDelantera, MaterialVelaMedia,
//      MaterialBandera, MaterialMetalizado, MaterialGrada )
//              MaterialCasco           : Material a aplicar al casco.
//              MaterialCabina          : Material principal de cabina.
//              MaterialBorde           : Material para el borde.
//              MaterialPiso            : Material para el piso.
//              MaterialVentanas        : Material para ventanas.
//              MaterialBaranda         : Material para barandas.
//              MaterialMastil          : Material para el mastil.
//              MaterialVelaPosterior   : Material de vela posterior.
//              MaterialVelaDelantera   : Material de vela delantera.
//              MaterialVelaMedia       : Material de vela media.
//              MaterialBandera         : Material de bandera.
//              MaterialMetalizado      : Material de zonas metalicas.
//              MaterialGrada           : Material para gradas.                                                         
//                                                          
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse.
// #declare BVPP_DefaultMaterialCasco           
//      Material a aplicar al casco.
// #declare BVPP_DefaultMaterialCabina          
//      Material principal de cabina.
// #declare BVPP_DefaultMaterialBorde           
//      Material para el borde.
// #declare BVPP_DefaultMaterialPiso            
//      Material para el piso.
// #declare BVPP_DefaultMaterialVentanas        
//      Material para ventanas.
// #declare BVPP_DefaultMaterialBaranda         
//      Material para barandas.
// #declare BVPP_DefaultMaterialMastil          
//      Material para el mastil.
// #declare BVPP_DefaultMaterialVelaPosterior   
//      Material de vela posterior.
// #declare BVPP_DefaultMaterialVelaDelantera   
//      Material de vela delantera.
// #declare BVPP_DefaultMaterialVelaMedia       
//      Material de vela media.
// #declare BVPP_DefaultMaterialBandera         
//      Material de bandera.
// #declare BVPP_MaterialMetalizado      
//      Material de zonas metalicas.
// #declare BVPP_MaterialGrada           
//      Material para gradas.                                                         
//   
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare BVPP_MaterialCasco                          = material { ... }        
//      Material a aplicar al casco.
// #declare BVPP_MaterialCabina                         = material { ... }          
//      Material principal de cabina.
// #declare BVPP_MaterialBorde                          = material { ... }          
//      Material para el borde.
// #declare BVPP_DefaultMaterialPiso                    = material { ... }            
//      Material para el piso.
// #declare BVPP_DefaultMaterialVentanas                = material { ... }       
//      Material para ventanas.
// #declare BVPP_DefaultMaterialBaranda                 = material { ... } 
//      Material para barandas.
// #declare BVPP_DefaultMaterialMastil                  = material { ... }
//      Material para el mastil.
// #declare BVPP_DefaultMaterialVelaPosterior           = material { ... }
//      Material de vela posterior.
// #declare BVPP_DefaultMaterialVelaDelantera           = material { ... } 
//      Material de vela delantera.
// #declare BVPP_DefaultMaterialVelaMedia               = material { ... }
//      Material de vela media.
// #declare BVPP_DefaultMaterialBandera                 = material { ... }
//      Material de bandera.
// #declare BVPP_MaterialMetalizado                     = material { ... }
//      Material de zonas metalicas.
// #declare BVPP_MaterialGrada                          = material { ... }
//      Material para gradas.
// #declare BVPP_POV3_1                                 = off;
//      Valor "on" activa simplificaciones para lograr
//      compatibilidad con POVRay 3.1.  En algunas versiones se
//      activara automaticamente.
//
// Para colocarlo simplemente
//
// #include "BVPP.inc"
//  object                  {
//    BVPP_Barco( ) 
//  }
//
//  o bien la misma figura con la macro detallada... 
//  #include "BVPP.inc"
//  object                  { 
//    BVPP_BarcoVeleroParaPiscina(  
//      BVPP_MaterialCasco, BVPP_MaterialCabina, BVPP_MaterialBorde, BVPP_MaterialPiso,
//      BVPP_MaterialVentanas, BVPP_MaterialBaranda, BVPP_MaterialMastil,
//      BVPP_MaterialVelaPosterior, BVPP_MaterialVelaDelantera, BVPP_MaterialVelaMedia,
//      BVPP_MaterialBandera, BVPP_MaterialMetalizado, BVPP_MaterialGrada ) 
//  }
//
//  o bien se puede redefinir alguna textura 
//  #include "BVPP.inc"                     
//  #declare BVPP_MaterialCasco = material{ { Texture { PinkAlabaster } } }
//  object                  {                                   
//    BVPP_Barco()
//  }
//

//  Persistence of Vision Raytracer V3.5
//  World definition file.
//
//  Contains 3 lights, 8 materials and 209 primitives.
//
//  This file was generated for POV-Ray V3.5 by
//  Moray V3.5 For Windows Copyright (c) 1993-2003 Lutz + Kretzschmar
//  fue modificado por Rafael para el uso de macros POV-Ray

//  Date : 10/28/2013    (28.10.2013)
//

/*
  The text between these two comments is in MorayPOV.INC and is
  automatically included in all POV files that Moray exports.
*/


/* // Scene Comment

This scene was created with Moray V3.4 Beta For Windows.

*/ // End Scene Comment

#if ( version < 3.2 )
  #ifndef( BVPP_POV3_1 )
    #declare BVPP_POV3_1        = on;
  #end
#else
  #ifndef( BVPP_POV3_1 )
    #declare BVPP_POV3_1        = off;
  #end
#end



#include "bvpp_au1.inc"


//
// ********  REFERENCED OBJECTS  *******
//



//
// ********  OBJECTS  *******
//

#macro BVPP_RoundePosterior( MaterialCabina )
merge {
  sphere { <0.4000, 0.4000, 0.4000>, 0.1000 }
  sphere { <0.4000, -0.4000, 0.4000>, 0.1000 }
  sphere { <-0.4000, -0.4000, 0.4000>, 0.1000 }
  sphere { <-0.4000, 0.4000, 0.4000>, 0.1000 }
  sphere { <0.4000, 0.4000, -0.4000>, 0.1000 }
  sphere { <0.4000, -0.4000, -0.4000>, 0.1000 }
  sphere { <-0.4000, -0.4000, -0.4000>, 0.1000 }
  sphere { <-0.4000, 0.4000, -0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, 0.4000>, <-0.4000, 0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, -0.4000, 0.4000>, <-0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, -0.4000, -0.4000>, <-0.4000, -0.4000, -0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, -0.4000>, <-0.4000, 0.4000, -0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, -0.4000>, <0.4000, 0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, -0.4000, -0.4000>, <0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <-0.4000, -0.4000, -0.4000>, <-0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <-0.4000, 0.4000, -0.4000>, <-0.4000, 0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, 0.4000>, <0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, -0.4000>, <0.4000, -0.4000, -0.4000>, 0.1000 }
  cylinder { <-0.4000, 0.4000, -0.4000>, <-0.4000, -0.4000, -0.4000>, 0.1000 }
  cylinder { <-0.4000, 0.4000, 0.4000>, <-0.4000, -0.4000, 0.4000>, 0.1000 }
  box { <-0.4000, -0.4000, -0.5000> <0.4000, 0.4000, 0.5000> }
  box { <-0.4000, -0.5000, -0.4000> <0.4000, 0.5000, 0.4000> }
  box { <-0.5000, -0.4000, -0.4000> <0.5000, 0.4000, 0.4000> }
  material {
    MaterialCabina
  }
  scale <0.15, 0.05, 0.2>
  rotate 20.2075*z
  translate  <-0.835039, -0.063306, 0.0>
}
#end        

#if ( BVPP_POV3_1 )
  #declare BVPP_DetalleVelaMedia = mesh {
     #local Punto0 = <1.1313695, -1.3612955, 1.1920159>;
     #local Punto1 = <1.1639590, -0.2444621, 1.1242456>;
     #local Punto2 = <1.0200720, 0.7992803, 0.9774099>;
     #local Punto3 = <1.6046772, -1.3412235, 1.0790654>;
     #local Punto4 = <1.3500004, -0.3412235, 1.0677703>;
     #local Punto5 = <1.3974835, -1.2408636, 1.2033109>;
     #local Punto6 = <1.2846061, -0.4032386, 1.1242456>;
     triangle { Punto6, Punto4, Punto2 }
     triangle { Punto4, Punto5, Punto3 }
     triangle { Punto6, Punto1, Punto0 }
     triangle { Punto4, Punto0, Punto5 }
     triangle { Punto4, Punto6, Punto0 }
     triangle { Punto1, Punto6, Punto2 }
    translate  <-0.825589, 1.41217, -1.005259>
  }
#else
  #declare BVPP_DetalleVelaMedia = mesh2 {
    vertex_vectors {
      7,
      <1.1313695, -1.3612955, 1.1920159>,
      <1.1639590, -0.2444621, 1.1242456>,
      <1.0200720, 0.7992803, 0.9774099>,
      <1.6046772, -1.3412235, 1.0790654>,
      <1.3500004, -0.3412235, 1.0677703>,
      <1.3974835, -1.2408636, 1.2033109>,
      <1.2846061, -0.4032386, 1.1242456>
    }
    normal_vectors {
      6,
      <0.5139188, 0.2144748, 0.8305950>,
      <0.5614665, 0.1521797, 0.8133860>,
      <0.0765488, 0.0581660, 0.9953678>,
      <-0.1063226, 0.1426456, 0.9840466>,
      <0.6833580, -0.0578179, 0.7277905>,
      <0.2175696, 0.1653213, 0.9619420>
    }
    uv_vectors {
      20,
      <0.2500000, 0.6666667>,
      <0.5000000, 0.6666667>,
      <0.5000000, 0.3333333>,
      <0.2500000, 0.3333333>,
      <0.2500000, 1.0000000>,
      <0.5000000, 1.0000000>,
      <0.2500000, 0.0000000>,
      <0.5000000, 0.0000000>,
      <0.0000000, 0.6666667>,
      <0.0000000, 0.3333333>,
      <0.7500000, 0.6666667>,
      <0.7500000, 0.3333333>,
      <1.0000000, 0.6666667>,
      <1.0000000, 0.3333333>,
      <0.5000000, 0.5000000>,
      <0.0000000, 0.0000000>,
      <0.3750000, 0.3333333>,
      <0.0000000, 0.0000000>,
      <0.3750000, 0.5833333>,
      <0.3750000, 0.5833333>
    }
    face_indices {
      6,   // 6 triangles and 0 quads
      <6, 4, 2>,
      <4, 5, 3>,
      <6, 1, 0>,
      <4, 0, 5>,
      <4, 6, 0>,
      <1, 6, 2>
    }
    normal_indices {
      6,   // from 6 triangles and 0 quads
      <0, 0, 0>,
      <1, 1, 1>,
      <2, 2, 2>,
      <3, 3, 3>,
      <4, 4, 4>,
      <5, 5, 5>
    }
    uv_indices {
      6,   // from 6 triangles and 0 quads
      <19, 14, 1>    <14, 16, 2>    <18, 0, 3>    <14, 3, 16>    <14, 18, 3>    <0, 19, 1>
    }
    translate  <-0.825589, 1.41217, -1.005259>
  }
#end

#if ( BVPP_POV3_1 )
  #declare BVPP_DetalleVelaDelantera = mesh {
     #local Punto0 = <0.5769087, -1.2408636, 1.0338852>;
     #local Punto1 = <0.7977004, -0.1441023, 0.8983445>;
     #local Punto2 = <1.2609356, 0.7792083, 0.9774099>;
     #local Punto3 = <0.8482012, -0.6989205, 0.9887049>;
     #local Punto4 = <0.9598561, -0.2207917, 1.0000000>;
     #local Punto5 = <0.6623750, -0.9397841, 1.0000000>;
     #local Punto6 = <0.8430227, -0.1824470, 0.9096396>;
     triangle { Punto6, Punto4, Punto2 }
     triangle { Punto4, Punto5, Punto3 }
     triangle { Punto6, Punto1, Punto0 }
     triangle { Punto4, Punto0, Punto5 }
     triangle { Punto4, Punto6, Punto0 }
     triangle { Punto1, Punto6, Punto2 }
    rotate 0.0*x
    translate  <-0.997188, 0.0, -0.928236>
    rotate <-180.0, 7.025232, -180.0>
    translate  <0.456865, 1.331882, 0.033885>
  }
#else
  #declare BVPP_DetalleVelaDelantera = mesh2 {
    vertex_vectors {
      7,
      <0.5769087, -1.2408636, 1.0338852>,
      <0.7977004, -0.1441023, 0.8983445>,
      <1.2609356, 0.7792083, 0.9774099>,
      <0.8482012, -0.6989205, 0.9887049>,
      <0.9598561, -0.2207917, 1.0000000>,
      <0.6623750, -0.9397841, 1.0000000>,
      <0.8430227, -0.1824470, 0.9096396>
    }
    normal_vectors {
      6,
      <-0.5617480, 0.1873344, 0.8058194>,
      <0.1297801, -0.0536962, 0.9900878>,
      <-0.1213630, 0.1457710, 0.9818461>,
      <0.6320798, -0.2615212, -0.7294394>,
      <-0.5463648, 0.2318467, 0.8048183>,
      <-0.2201874, 0.0269716, 0.9750846>
    }
    uv_vectors {
      20,
      <0.2500000, 0.6666667>,
      <0.5000000, 0.6666667>,
      <0.5000000, 0.3333333>,
      <0.2500000, 0.3333333>,
      <0.2500000, 1.0000000>,
      <0.5000000, 1.0000000>,
      <0.2500000, 0.0000000>,
      <0.5000000, 0.0000000>,
      <0.0000000, 0.6666667>,
      <0.0000000, 0.3333333>,
      <0.7500000, 0.6666667>,
      <0.7500000, 0.3333333>,
      <1.0000000, 0.6666667>,
      <1.0000000, 0.3333333>,
      <0.5000000, 0.5000000>,
      <0.0000000, 0.0000000>,
      <0.3750000, 0.3333333>,
      <0.0000000, 0.0000000>,
      <0.3750000, 0.5833333>,
      <0.3750000, 0.5833333>
    }
    face_indices {
      6,   // 6 triangles and 0 quads
      <6, 4, 2>,
      <4, 5, 3>,
      <6, 1, 0>,
      <4, 0, 5>,
      <4, 6, 0>,
      <1, 6, 2>
    }
    normal_indices {
      6,   // from 6 triangles and 0 quads
      <0, 0, 0>,
      <1, 1, 1>,
      <2, 2, 2>,
      <3, 3, 3>,
      <4, 4, 4>,
      <5, 5, 5>
    }
    uv_indices {
      6,   // from 6 triangles and 0 quads
      <19, 14, 1>    <14, 16, 2>    <18, 0, 3>    <14, 3, 16>    <14, 18, 3>    <0, 19, 1>
    }
    rotate 0.0*x
    translate  <-0.997188, 0.0, -0.928236>
    rotate <-180.0, 7.025232, -180.0>
    translate  <0.456865, 1.331882, 0.033885>
  }
#end

#if ( BVPP_POV3_1 )
  #declare BVPP_DetalleVelaPosterior = mesh {
     #local Punto0 = <0.1754693, -1.0000000, 1.0338852>;
     #local Punto1 = <0.5769087, -0.1039583, 0.8983445>;
     #local Punto2 = <1.0200720, 0.7189924, 0.9774099>;
     #local Punto3 =  <1.0890648, -0.9197121, 0.9887049>;
     #local Punto4 =  <0.9598561, -0.2207917, 1.0000000>;
     #local Punto5 = <0.6623750, -0.9397841, 1.0000000>;
     #local Punto6 = <0.7828068, -0.1423030, 0.9096396>;
     triangle { Punto6, Punto4, Punto2 }
     triangle { Punto4, Punto5, Punto3 }
     triangle { Punto6, Punto1, Punto0 }
     triangle { Punto4, Punto0, Punto5 }
     triangle { Punto4, Punto6, Punto0 }
     triangle { Punto1, Punto6, Punto2 }
    translate  <-0.825589, 1.41217, -1.005259>
  }
#else
  #declare BVPP_DetalleVelaPosterior = mesh2 {
    vertex_vectors {
      7,
      <0.1754693, -1.0000000, 1.0338852>,
      <0.5769087, -0.1039583, 0.8983445>,
      <1.0200720, 0.7189924, 0.9774099>,
      <1.0890648, -0.9197121, 0.9887049>,
      <0.9598561, -0.2207917, 1.0000000>,
      <0.6623750, -0.9397841, 1.0000000>,
      <0.7828068, -0.1423030, 0.9096396>
    }
    normal_vectors {
      6,
      <-0.4365095, 0.0495627, 0.8983335>,
      <0.0269853, -0.0111651, 0.9995735>,
      <-0.0243065, 0.1601577, 0.9867921>,
      <0.0731159, -0.0302515, 0.9968645>,
      <-0.3020528, 0.3427435, 0.8895454>,
      <-0.0658551, -0.0602288, 0.9960098>
    }
    uv_vectors {
      20,
      <0.2500000, 0.6666667>,
      <0.5000000, 0.6666667>,
      <0.5000000, 0.3333333>,
      <0.2500000, 0.3333333>,
      <0.2500000, 1.0000000>,
      <0.5000000, 1.0000000>,
      <0.2500000, 0.0000000>,
      <0.5000000, 0.0000000>,
      <0.0000000, 0.6666667>,
      <0.0000000, 0.3333333>,
      <0.7500000, 0.6666667>,
      <0.7500000, 0.3333333>,
      <1.0000000, 0.6666667>,
      <1.0000000, 0.3333333>,
      <0.5000000, 0.5000000>,
      <0.0000000, 0.0000000>,
      <0.3750000, 0.3333333>,
      <0.0000000, 0.0000000>,
      <0.3750000, 0.5833333>,
      <0.3750000, 0.5833333>
    }
    face_indices {
      6,   // 6 triangles and 0 quads
      <6, 4, 2>,
      <4, 5, 3>,
      <6, 1, 0>,
      <4, 0, 5>,
      <4, 6, 0>,
      <1, 6, 2>
    }
    normal_indices {
      6,   // from 6 triangles and 0 quads
      <0, 0, 0>,
      <1, 1, 1>,
      <2, 2, 2>,
      <3, 3, 3>,
      <4, 4, 4>,
      <5, 5, 5>
    }
    uv_indices {
      6,   // from 6 triangles and 0 quads
      <19, 14, 1>    <14, 16, 2>    <18, 0, 3>    <14, 3, 16>    <14, 18, 3>    <0, 19, 1>
    }
    translate  <-0.825589, 1.41217, -1.005259>
  }
#end

#declare BVPP_CabinaIntersection1 = prism {
  linear_sweep
  cubic_spline
  -1.0,0.0
  10  // control points
  <-0.281667, 0.205095>,
  <-0.359902, 0.104712>,
  <-0.306267, -0.012045>,
  <0.19869, -0.005527>,
  <0.207398, 0.10474>,
  <0.09184, 0.195903>,
  <-0.038802, 0.218558>,
  <-0.281667, 0.205095>,
  <-0.359902, 0.104712>,
  <-0.306267, -0.012045>
  rotate -x*90
  scale <1.0, 1.0, 0.5>
  translate  -0.25*z
}
#declare BVPP_Intersection2 = prism {
  linear_sweep
  cubic_spline
  -1.0,0.0
  10  // control points
  <-0.110947, 0.2>,
  <-0.141881, 0.107109>,
  <-0.124705, -0.002811>,
  <0.124705, -0.002811>,
  <0.143258, 0.104528>,
  <0.105326, 0.2>,
  <0.002582, 0.214053>,
  <-0.110947, 0.2>,
  <-0.141881, 0.107109>,
  <-0.124705, -0.002811>
  rotate -x*90
  rotate -90.0*y
  translate  0.5*x
}     

#macro BVPP_CabinaIntersection( MaterialCabina ) 
intersection {
  object { BVPP_CabinaIntersection1 }
  object { BVPP_Intersection2 }
  material {
    MaterialCabina
  }
}
#end
#declare BVPP_Difference3 = prism {
  linear_sweep
  linear_spline
  -1.0,0.0
  5  // control points
  <0.017927, 0.075608>,
  <0.180303, 0.07629>,
  <0.098405, 0.191737>,
  <-0.059474, 0.191916>,
  <0.017927, 0.075608>
  rotate -x*90
  scale <1.0, 1.0, 0.5>
  translate  <-0.183324, 0.001852, -0.25>
}
#declare BVPP_Difference5 = prism {
  linear_sweep
  linear_spline
  -1.0,0.0
  5  // control points
  <0.017927, 0.075608>,
  <0.180303, 0.07629>,
  <0.094701, 0.18433>,
  <-0.061326, 0.19562>,
  <0.017927, 0.075608>
  rotate -x*90
  scale <1.0, 1.0, 0.5>
  translate  -0.25*z
}
#declare BVPP_Difference1 = prism {
  linear_sweep
  linear_spline
  -1.0,0.0
  4  // control points
  <0.017927, 0.075608>,
  <0.172376, 0.07629>,
  <0.094701, 0.190671>,
  <0.017927, 0.075608>
  rotate -x*90
  scale <1.0, 1.0, 0.5>
  translate  <-0.362944, 0.003704, -0.25>
}
#declare BVPP_Difference2 = prism {
  linear_sweep
  linear_spline
  -1.0,0.0
  5  // control points
  <0.017927, 0.0791>,
  <0.11847, 0.0791>,
  <0.105944, 0.18433>,
  <0.01456, 0.187188>,
  <0.017927, 0.0791>
  rotate -x*90
  rotate -90.0*y
  translate  0.5*x
}
#declare BVPP_Difference4 = prism {
  linear_sweep
  linear_spline
  -1.0,0.0
  5  // control points
  <0.017927, 0.0791>,
  <0.11847, 0.0791>,
  <0.105944, 0.18433>,
  <0.01456, 0.187188>,
  <0.017927, 0.0791>
  rotate -x*90
  scale -1.0
  rotate <180.0, -90.0, 0.0>
  translate  0.5*x
}
#macro BVPP_CabinaSinVentanas( MaterialCabina ) 
difference {
  object { BVPP_CabinaIntersection( MaterialCabina) }
  object { BVPP_Difference3 }
  object { BVPP_Difference5 }
  object { BVPP_Difference1 }
  object { BVPP_Difference2 }
  object { BVPP_Difference4 }
  material {
    MaterialCabina
  }
}
#end
#if ( BVPP_POV3_1 )
  #declare BVPP_Ventanas = mesh {
    #local Punto0 = <-1.4262055, -0.4239862, -1.2733521>;
    #local Punto1 =  <-1.0000000, 1.0000000, -1.0000000>;
    #local Punto2 =  <1.0000000, 1.0000000, -1.0000000>;
    #local Punto3 =  <2.0135414, -1.0000000, -1.2350417>;
    #local Punto4 =  <-1.4262055, -0.4239862, 1.2733521>;
    #local Punto5 =  <-1.0000000, 1.0000000, 1.0000000>;
    #local Punto6 =  <1.0000000, 1.0000000, 1.0000000>;
    #local Punto7 =  <2.0135414, -1.0000000, 1.2350417>;
    triangle { Punto5, Punto4, Punto7 }
    triangle { Punto5, Punto7, Punto6 }
    triangle { Punto4, Punto0, Punto3 }
    triangle { Punto4, Punto3, Punto7 }
    triangle { Punto0, Punto1, Punto2 }
    triangle { Punto0, Punto2, Punto3 }
    triangle { Punto1, Punto5, Punto6 }
    triangle { Punto1, Punto6, Punto2 }
    triangle { Punto0, Punto4, Punto5 }
    triangle { Punto0, Punto5, Punto1 }
    triangle { Punto2, Punto6, Punto7 }
    triangle { Punto2, Punto7, Punto3 }
    scale <0.18, 0.1, 0.11>
    translate  <-0.1, 0.1, 0.0>
  }
#else
  #declare BVPP_Ventanas = mesh2 {
    vertex_vectors {
      8,
      <-1.4262055, -0.4239862, -1.2733521>,
      <-1.0000000, 1.0000000, -1.0000000>,
      <1.0000000, 1.0000000, -1.0000000>,
      <2.0135414, -1.0000000, -1.2350417>,
      <-1.4262055, -0.4239862, 1.2733521>,
      <-1.0000000, 1.0000000, 1.0000000>,
      <1.0000000, 1.0000000, 1.0000000>,
      <2.0135414, -1.0000000, 1.2350417>
    }
    normal_vectors {
      6,
      <0.0405348, 0.1766512, 0.9834385>,
      <-0.1651585, -0.9862670, 0.0000000>,
      <0.0000000, 0.1885206, -0.9820692>,
      <0.0000000, 1.0000000, 0.0000000>,
      <-0.9580095, 0.2867365, 0.0000000>,
      <0.8919984, 0.4520386, 0.0000000>
    }
    uv_vectors {
      14,
      <0.2500000, 0.6666667>,
      <0.5000000, 0.6666667>,
      <0.5000000, 0.3333333>,
      <0.2500000, 0.3333333>,
      <0.2500000, 1.0000000>,
      <0.5000000, 1.0000000>,
      <0.2500000, 0.0000000>,
      <0.5000000, 0.0000000>,
      <0.0000000, 0.6666667>,
      <0.0000000, 0.3333333>,
      <0.7500000, 0.6666667>,
      <0.7500000, 0.3333333>,
      <1.0000000, 0.6666667>,
      <1.0000000, 0.3333333>
    }
    face_indices {
      12,   // 0 triangles and 6 quads
      <5, 4, 7>,
      <5, 7, 6>,
      <4, 0, 3>,
      <4, 3, 7>,
      <0, 1, 2>,
      <0, 2, 3>,
      <1, 5, 6>,
      <1, 6, 2>,
      <0, 4, 5>,
      <0, 5, 1>,
      <2, 6, 7>,
      <2, 7, 3>
    }
    normal_indices {
      12,   // from 0 triangles and 6 quads
      <0, 0, 0>,
      <0, 0, 0>,
      <1, 1, 1>,
      <1, 1, 1>,
      <2, 2, 2>,
      <2, 2, 2>,
      <3, 3, 3>,
      <3, 3, 3>,
      <4, 4, 4>,
      <4, 4, 4>,
      <5, 5, 5>,
      <5, 5, 5>
    }
    uv_indices {
      12,   // from 0 triangles and 6 quads
      <0, 3, 2>,
      <0, 2, 1>    <3, 6, 7>,
      <3, 7, 2>    <13, 12, 10>,
      <13, 10, 11>    <4, 0, 1>,
      <4, 1, 5>    <9, 3, 0>,
      <9, 0, 8>    <10, 1, 2>,
      <10, 2, 11>
    }
    scale <0.18, 0.1, 0.11>
    translate  <-0.1, 0.1, 0.0>
  }
#end
#macro BVPP_BaseCabinaBarraIzquierda( MaterialCabina )
difference {
  superellipsoid { // BVPP_CabinaBase02
    <0.2, 0.2>
    scale <0.4, 0.1, 0.03>
    translate  <-0.3, -0.05, 0.09>
  }
  cylinder { // BVPP_Diferencia2
    <0,0,1>, <0,0,0>, 1 
    scale <0.01, 0.01, 0.3>
    rotate -90.0*y
    translate  <-0.388881, 0.051248, 0.101655>
  }
  cylinder { // BVPP_Diferencia3
    <0,0,1>, <0,0,0>, 1 
    scale <0.01, 0.01, 0.3>
    rotate -90.0*y
    translate  <-0.388881, 0.051248, 0.07166> 
  }
    material            {   
      MaterialCabina
    }
}
#end
#macro BVPP_BaseCabinaBarraIzquierda1( MaterialCabina ) 
difference {
  superellipsoid { // BVPP_CabinaBase03
    <0.2, 0.2>
    scale <0.4, 0.1, 0.03>
    translate  <-0.3, -0.05, 0.09>
  }
  cylinder { // BVPP_Diferencia4
    <0,0,1>, <0,0,0>, 1 
    scale <0.01, 0.01, 0.3>
    rotate -90.0*y
    translate  <-0.388881, 0.051248, 0.101655>
  }
  cylinder { // BVPP_Diferencia5
    <0,0,1>, <0,0,0>, 1 
    scale <0.01, 0.01, 0.3>
    rotate -90.0*y
    translate  <-0.388881, 0.051248, 0.07166>
  }
  scale <1.0, 1.0, -1.0>  
  material              { 
    MaterialCabina
  }
}
#end

#declare BVPP_Poste1 = union {
  cylinder { // BVPP_BasePoste3
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste4
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera1
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste5
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -25.63895*y
  translate  <0.797948, 0.0, -0.043522>
}
#declare BVPP_Poste2 = union {
  cylinder { // BVPP_BasePoste6
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste7
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera2
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste8
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -19.530357*y
  translate  <0.705489, 0.0, -0.073116>
}
#declare BVPP_Poste3 = union {
  cylinder { // BVPP_BasePoste9
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste10
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera3
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste11
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -18.230442*y
  translate  <0.616708, 0.0, -0.10213>
}
#declare BVPP_Poste4 = union {
  cylinder { // BVPP_BasePoste12
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste13
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera4
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste14
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -12.408837*y
  translate  <0.533342, 0.0, -0.117217>
}
#declare BVPP_Poste5 = union {
  cylinder { // BVPP_BasePoste15
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste16
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera5
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste17
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -11.732555*y
  translate  <0.437205, 0.0, -0.140238>
}
#declare BVPP_Poste6 = union {
  cylinder { // BVPP_BasePoste18
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste19
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera6
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste20
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -12.50121*y
  translate  <0.341648, 0.0, -0.159581>
}
#declare BVPP_Poste7 = union {
  cylinder { // BVPP_BasePoste21
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste22
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera7
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste23
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -10.856246*y
  translate  <0.249768, 0.0, -0.174088>
}
#declare BVPP_Poste8 = union {
  cylinder { // BVPP_BasePoste24
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste25
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera8
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste26
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -8.691353*y
  translate  <0.153632, 0.0, -0.188595>
}
#declare BVPP_Poste9 = union {
  cylinder { // BVPP_BasePoste27
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste28
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera9
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste29
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -8.901665*y
  translate  <0.062733, 0.0, -0.200816>
}
#declare BVPP_Poste10 = union {
  cylinder { // BVPP_BasePoste30
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste31
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera10
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste32
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -6.066774*y
  translate  <-0.026657, 0.0, -0.209329>
}
#declare BVPP_Poste11 = union {
  cylinder { // BVPP_BasePoste33
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste34
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera11
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste35
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -3.414597*y
  translate  <-0.120303, 0.0, -0.213586>
}
#declare BVPP_Poste12 = union {
  cylinder { // BVPP_BasePoste36
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste37
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera12
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste38
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -2.863257*y
  translate  <-0.209693, 0.0, -0.217842>
}
#declare BVPP_Poste13 = union {
  cylinder { // BVPP_BasePoste39
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste40
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera13
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste41
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate 0.897317*y
  translate  <-0.30334, 0.0, -0.213586>
}
#declare BVPP_Poste14 = union {
  cylinder { // BVPP_BasePoste42
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste43
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera14
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste44
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate 1.405071*y
  translate  <-0.396987, 0.0, -0.209329>
}
#declare BVPP_Poste15 = union {
  cylinder { // BVPP_BasePoste45
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste46
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera15
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste47
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate 6.971316*y
  translate  <-0.486377, 0.0, -0.196559>
}
#declare BVPP_Poste16 = union {
  cylinder { // BVPP_BasePoste48
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste49
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera16
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste50
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate 5.680738*y
  translate  <-0.567253, 0.0, -0.188046>
}
#declare BVPP_Poste17 = union {
  cylinder { // BVPP_BasePoste51
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste52
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera17
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste53
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate 14.707106*y
  translate  <-0.759504, 0.0, -0.145479>
}
#declare BVPP_Poste18 = union {
  cylinder { // BVPP_BasePoste54
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste55
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera18
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste56
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate 8.433639*y
  translate  <-0.669413, 0.0, -0.171019>
}
#declare BVPP_Poste19 = union {
  cylinder { // BVPP_BasePoste57
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste58
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera19
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste59
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate 88.587723*y
  translate  <-0.758803, 0.0, -0.064602>
}
#macro BVPP_BarandaUnLado( MaterialBaranda ) 
union {
  object { BVPP_Poste1 }
  object { BVPP_Poste2 }
  object { BVPP_Poste3 }
  object { BVPP_Poste4 }
  object { BVPP_Poste5 }
  object { BVPP_Poste6 }
  object { BVPP_Poste7 }
  object { BVPP_Poste8 }
  object { BVPP_Poste9 }
  object { BVPP_Poste10 }
  object { BVPP_Poste11 }
  object { BVPP_Poste12 }
  object { BVPP_Poste13 }
  object { BVPP_Poste14 }
  object { BVPP_Poste15 }
  object { BVPP_Poste16 }
  object { BVPP_Poste17 }
  object { BVPP_Poste18 }
  object { BVPP_Poste19 } 
  material              { 
    MaterialBaranda
  }
}   
#end
#declare BVPP_Poste20 = union {
  cylinder { // BVPP_BasePoste60
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste61
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera20
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste62
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -25.63895*y
  translate  <0.797948, 0.0, -0.043522>
}
#declare BVPP_Poste21 = union {
  cylinder { // BVPP_BasePoste63
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste64
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera21
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste65
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -19.530357*y
  translate  <0.705489, 0.0, -0.073116>
}
#declare BVPP_Poste22 = union {
  cylinder { // BVPP_BasePoste66
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste67
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera22
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste68
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -18.230442*y
  translate  <0.616708, 0.0, -0.10213>
}
#declare BVPP_Poste23 = union {
  cylinder { // BVPP_BasePoste69
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste70
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera23
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste71
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -12.408837*y
  translate  <0.533342, 0.0, -0.117217>
}
#declare BVPP_Poste24 = union {
  cylinder { // BVPP_BasePoste72
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste73
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera24
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste74
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -11.732555*y
  translate  <0.437205, 0.0, -0.140238>
}
#declare BVPP_Poste25 = union {
  cylinder { // BVPP_BasePoste75
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste76
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera25
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste77
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -12.50121*y
  translate  <0.341648, 0.0, -0.159581>
}
#declare BVPP_Poste26 = union {
  cylinder { // BVPP_BasePoste78
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste79
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera26
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste80
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -10.856246*y
  translate  <0.249768, 0.0, -0.174088>
}
#declare BVPP_Poste27 = union {
  cylinder { // BVPP_BasePoste81
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste82
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera27
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste83
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -8.691353*y
  translate  <0.153632, 0.0, -0.188595>
}
#declare BVPP_Poste28 = union {
  cylinder { // BVPP_BasePoste84
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste85
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera28
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste86
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -8.901665*y
  translate  <0.062733, 0.0, -0.200816>
}
#declare BVPP_Poste29 = union {
  cylinder { // BVPP_BasePoste87
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste88
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera29
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste89
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -6.066774*y
  translate  <-0.026657, 0.0, -0.209329>
}
#declare BVPP_Poste30 = union {
  cylinder { // BVPP_BasePoste90
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste91
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera30
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste92
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -3.414597*y
  translate  <-0.120303, 0.0, -0.213586>
}
#declare BVPP_Poste31 = union {
  cylinder { // BVPP_BasePoste93
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste94
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera31
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste95
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate -2.863257*y
  translate  <-0.209693, 0.0, -0.217842>
}
#declare BVPP_Poste32 = union {
  cylinder { // BVPP_BasePoste96
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste97
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera32
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste98
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate 0.897317*y
  translate  <-0.30334, 0.0, -0.213586>
}
#declare BVPP_Poste33 = union {
  cylinder { // BVPP_BasePoste99
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste100
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera33
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste101
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate 1.405071*y
  translate  <-0.396987, 0.0, -0.209329>
}
#declare BVPP_Poste34 = union {
  cylinder { // BVPP_BasePoste102
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste103
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera34
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste104
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate 6.971316*y
  translate  <-0.486377, 0.0, -0.196559>
}
#declare BVPP_Poste35 = union {
  cylinder { // BVPP_BasePoste105
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste106
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera35
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste107
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate 5.680738*y
  translate  <-0.567253, 0.0, -0.188046>
}
#declare BVPP_Poste36 = union {
  cylinder { // BVPP_BasePoste108
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste109
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera36
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste110
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate 14.707106*y
  translate  <-0.759504, 0.0, -0.145479>
}
#declare BVPP_Poste37 = union {
  cylinder { // BVPP_BasePoste111
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste112
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera37
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste113
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate 8.433639*y
  translate  <-0.669413, 0.0, -0.171019>
}
#declare BVPP_Poste38 = union {
  cylinder { // BVPP_BasePoste114
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste115
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera38
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste116
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate 90.0*y
    translate  0.055*y
  }
  rotate 88.587723*y
  translate  <-0.758803, 0.0, -0.064602>
}
#macro BVPP_BarandaOtroLado( MaterialBaranda ) 
union {
  object { BVPP_Poste20 }
  object { BVPP_Poste21 }
  object { BVPP_Poste22 }
  object { BVPP_Poste23 }
  object { BVPP_Poste24 }
  object { BVPP_Poste25 }
  object { BVPP_Poste26 }
  object { BVPP_Poste27 }
  object { BVPP_Poste28 }
  object { BVPP_Poste29 }
  object { BVPP_Poste30 }
  object { BVPP_Poste31 }
  object { BVPP_Poste32 }
  object { BVPP_Poste33 }
  object { BVPP_Poste34 }
  object { BVPP_Poste35 }
  object { BVPP_Poste36 }
  object { BVPP_Poste37 }
  object { BVPP_Poste38 }  
  scale <1.0, 1.0, -1.0>   
  material      {        
    MaterialBaranda
  }
}                                            
#end
#macro BVPP_PostePunta( MaterialBaranda ) 
union {
  cylinder { // BVPP_BasePoste118
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera39
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  material {
    MaterialBaranda
  }
  translate  <0.88553, 0.0, -0.004257>
}   
#end
#macro BVPP_PosteAnterior( MaterialBaranda ) 
union {
  cylinder { // BVPP_BasePoste117
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.12>
    rotate 90.0*y
    translate  <-0.06, 0.085, 0.0>
  }
  cylinder { // BVPP_BasePoste119
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.0912>
    rotate -90.0*x
  }
  sphere { // BVPP_BasePosteEsfera40
    <0,0,0>,1
    scale 0.01
    translate  0.085*y
  }
  cylinder { // BVPP_BasePoste120
    <0,0,1>, <0,0,0>, 1 
    scale <0.005, 0.005, 0.12>
    rotate 90.0*y
    translate  <-0.06, 0.055, 0.0>
  }
  material {
    MaterialBaranda
  }
  rotate <180.0, -89.444443, 180.0>
  translate  -0.757686*x
}
#end

#declare BVPP_CascoPlanar = prism {
  linear_sweep
  cubic_spline
  -1.0,0.0
  9  // control points
  <-0.76964, 0.1626>,
  <-0.984103, 0.0>,
  <-0.76964, -0.1626>,
  <0.0, -0.2168>,
  <0.909672, 0.0>,
  <0.0, 0.2168>,
  <-0.76964, 0.1626>,
  <-0.984103, 0.0>,
  <-0.76964, -0.1626>
  rotate -x*90
  scale <1.0, 1.0, 0.3648>
  rotate -90.0*x
  translate  -0.3648*y
}
#declare BLPP_PrismaInterseccionCascoLateral = prism {
  linear_sweep
  cubic_spline
  -1.0,0.0
  11  // control points
  <0.753752, -0.051096>,
  <-0.712056, -0.046208>,
  <-0.948307, -0.120566>,
  <-0.7296, -0.27968>,
  <0.0, -0.32832>,
  <0.7296, -0.22496>,
  <0.8512, -0.1216>,
  <0.889434, -0.033869>,
  <0.753752, -0.051096>,
  <-0.712056, -0.046208>,
  <-0.948307, -0.120566>
  rotate -x*90
  translate  -0.5*z
}
#declare BVPP_CascoFrontalIntersection = prism {
  linear_sweep
  cubic_spline
  -1.0,0.0
  8  // control points
  <0.2222, 0.0>,
  <-0.2222, 0.0>,
  <-0.13738, -0.21684>,
  <0.0, -0.342036>,
  <0.13378, -0.21684>,
  <0.2222, 0.0>,
  <-0.2222, 0.0>,
  <-0.13738, -0.21684>
  rotate -x*90
  scale <1.0, 1.0, 2.0>
  rotate 90.0*y
  translate  -1.0*x
}
#macro BVPP_CascoInterseccion( MaterialCasco ) 
intersection {
  object { BVPP_CascoPlanar }
  object { BLPP_PrismaInterseccionCascoLateral }
  object { BVPP_CascoFrontalIntersection }
  material {
    MaterialCasco
    scale       0.025
    rotate      2
  }
  scale <0.97, 1.0, 0.95>
}   
#end
#macro BVPP_Bajada1( MaterialCabina ) 
merge {
  sphere { <0.4000, 0.4000, 0.4000>, 0.1000 }
  sphere { <0.4000, -0.4000, 0.4000>, 0.1000 }
  sphere { <-0.4000, -0.4000, 0.4000>, 0.1000 }
  sphere { <-0.4000, 0.4000, 0.4000>, 0.1000 }
  sphere { <0.4000, 0.4000, -0.4000>, 0.1000 }
  sphere { <0.4000, -0.4000, -0.4000>, 0.1000 }
  sphere { <-0.4000, -0.4000, -0.4000>, 0.1000 }
  sphere { <-0.4000, 0.4000, -0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, 0.4000>, <-0.4000, 0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, -0.4000, 0.4000>, <-0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, -0.4000, -0.4000>, <-0.4000, -0.4000, -0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, -0.4000>, <-0.4000, 0.4000, -0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, -0.4000>, <0.4000, 0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, -0.4000, -0.4000>, <0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <-0.4000, -0.4000, -0.4000>, <-0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <-0.4000, 0.4000, -0.4000>, <-0.4000, 0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, 0.4000>, <0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, -0.4000>, <0.4000, -0.4000, -0.4000>, 0.1000 }
  cylinder { <-0.4000, 0.4000, -0.4000>, <-0.4000, -0.4000, -0.4000>, 0.1000 }
  cylinder { <-0.4000, 0.4000, 0.4000>, <-0.4000, -0.4000, 0.4000>, 0.1000 }
  box { <-0.4000, -0.4000, -0.5000> <0.4000, 0.4000, 0.5000> }
  box { <-0.4000, -0.5000, -0.4000> <0.4000, 0.5000, 0.4000> }
  box { <-0.5000, -0.4000, -0.4000> <0.5000, 0.4000, 0.4000> }
  material {
    MaterialCabina
  }
  scale <0.15, 0.1, 0.15>
  translate  <-0.425056, 0.003015, 0.0>
}
#end
#macro BVPP_Casco( MaterialCasco ) 
difference {
  object { BVPP_CascoInterseccion( MaterialCasco )   
    
  }
  object { BVPP_Bajada1( MaterialCabina ) }
}
#end
#declare BVPP_EjeFigura = prism {
  linear_sweep
  cubic_spline
  -1.0,0.0
  9  // control points
  <-0.76964, 0.1626>,
  <-0.96476, 0.0>,
  <-0.76964, -0.1626>,
  <0.0, -0.2168>,
  <0.9, 0.0>,
  <0.0, 0.2168>,
  <-0.76964, 0.1626>,
  <-0.96476, 0.0>,
  <-0.76964, -0.1626>
  rotate -x*90
  scale <1.0, 1.0, 0.1216>
  rotate -90.0*x
  translate  -0.1216*y
}
#declare BLPP_PrismaInterseccionEje = prism {
  linear_sweep
  linear_spline
  -1.0,0.0
  8  // control points
  <-0.76964, -0.0271>,
  <-0.96476, -0.0912>,
  <-0.96476, -0.1216>,
  <-0.76864, -0.06075>,
  <0.91, -0.06075>,
  <0.91, 0.1>,
  <-0.76964, 0.1>,
  <-0.76964, -0.0271>
  rotate -x*90
  translate  -0.5*z
}
#macro BVPP_EjeInterseccion( MaterialBorde ) 
intersection {
  object { BVPP_EjeFigura }
  object { BLPP_PrismaInterseccionEje }
  material {
    MaterialBorde
  }
} 
#end
#macro BVPP_EjePlano( MaterialBorde ) 
union {
  object { BVPP_EjeInterseccion( MaterialBorde ) }
} 
#end
#macro BVPP_EjeFiguraRestado( MaterialBorde ) 
prism {
  linear_sweep
  cubic_spline
  -1.0,0.0
  9  // control points
  <-0.76964, 0.1626>,
  <-0.96476, 0.0>,
  <-0.76964, -0.1626>,
  <0.0, -0.2168>,
  <0.9, 0.0>,
  <0.0, 0.2168>,
  <-0.76964, 0.1626>,
  <-0.96476, 0.0>,
  <-0.76964, -0.1626>
  rotate -x*90
  material {
    MaterialBorde
  }
  scale <0.9, 0.95, 0.15>
  rotate -90.0*x
  translate  -0.14*y
}                                               
#end
#macro BVPP_EjePlanoDifference( MaterialBorde ) 
difference {
  object { BVPP_EjePlano( MaterialBorde ) }
  object { BVPP_EjeFiguraRestado( MaterialBorde ) }
}
#end
#declare BVPP_EjeFigura1 = prism {
  linear_sweep
  cubic_spline
  -1.0,0.0
  9  // control points
  <-0.76964, 0.1626>,
  <-0.96476, 0.0>,
  <-0.76964, -0.1626>,
  <0.0, -0.2168>,
  <0.9, 0.0>,
  <0.0, 0.2168>,
  <-0.76964, 0.1626>,
  <-0.96476, 0.0>,
  <-0.76964, -0.1626>
  rotate -x*90
  scale <1.0, 1.0, 0.1216>
  rotate -90.0*x
  translate  -0.1216*y
}
#declare BLPP_PrismaInterseccionEje1 = prism {
  linear_sweep
  linear_spline
  -1.0,0.0
  8  // control points
  <-0.76964, -0.0271>,
  <-0.96476, -0.0912>,
  <-0.96476, -0.1216>,
  <-0.76864, -0.06075>,
  <0.91, -0.06075>,
  <0.91, 0.1>,
  <-0.76964, 0.1>,
  <-0.76964, -0.0271>
  rotate -x*90
  translate  -0.5*z
}
#declare BVPP_EjeInterseccion1 = intersection {
  object { BVPP_EjeFigura1 }
  object { BLPP_PrismaInterseccionEje1 }
  scale 0.95
  translate  -0.02*y
}
#declare BVPP_Bajada = merge {
  sphere { <0.4000, 0.4000, 0.4000>, 0.1000 }
  sphere { <0.4000, -0.4000, 0.4000>, 0.1000 }
  sphere { <-0.4000, -0.4000, 0.4000>, 0.1000 }
  sphere { <-0.4000, 0.4000, 0.4000>, 0.1000 }
  sphere { <0.4000, 0.4000, -0.4000>, 0.1000 }
  sphere { <0.4000, -0.4000, -0.4000>, 0.1000 }
  sphere { <-0.4000, -0.4000, -0.4000>, 0.1000 }
  sphere { <-0.4000, 0.4000, -0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, 0.4000>, <-0.4000, 0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, -0.4000, 0.4000>, <-0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, -0.4000, -0.4000>, <-0.4000, -0.4000, -0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, -0.4000>, <-0.4000, 0.4000, -0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, -0.4000>, <0.4000, 0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, -0.4000, -0.4000>, <0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <-0.4000, -0.4000, -0.4000>, <-0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <-0.4000, 0.4000, -0.4000>, <-0.4000, 0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, 0.4000>, <0.4000, -0.4000, 0.4000>, 0.1000 }
  cylinder { <0.4000, 0.4000, -0.4000>, <0.4000, -0.4000, -0.4000>, 0.1000 }
  cylinder { <-0.4000, 0.4000, -0.4000>, <-0.4000, -0.4000, -0.4000>, 0.1000 }
  cylinder { <-0.4000, 0.4000, 0.4000>, <-0.4000, -0.4000, 0.4000>, 0.1000 }
  box { <-0.4000, -0.4000, -0.5000> <0.4000, 0.4000, 0.5000> }
  box { <-0.4000, -0.5000, -0.4000> <0.4000, 0.5000, 0.4000> }
  box { <-0.5000, -0.4000, -0.4000> <0.5000, 0.4000, 0.4000> }
  scale <0.15, 0.1, 0.15>
  translate  <-0.425056, 0.003015, 0.0>
}
#declare BVPP_PlanoPiso = difference {
  object { BVPP_EjeInterseccion1 }
  object { BVPP_Bajada }
  scale 1.052632
  translate  0.021053*y
}
#macro BVPP_EjePlanoInterno( MaterialPiso ) 
union {
  object { BVPP_PlanoPiso }
  scale 0.95
  translate  -0.02*y    
  material                      { 
    MaterialPiso
  }
}
#end 
#macro BVPP_BarcoVeleroParaPiscina(
      MaterialCasco,
      MaterialCabina,
      MaterialBorde,  
      MaterialPiso,
      MaterialVentanas, 
      MaterialBaranda,  
      MaterialMastil,
      MaterialVelaPosterior,
      MaterialVelaDelantera,
      MaterialVelaMedia,
      MaterialBandera,
      MaterialMetalizado, 
      MaterialGrada
    )
union                   {
union { // BVPP_Barco
  object { BVPP_Casco( MaterialCasco ) }
  object { BVPP_EjePlanoDifference( MaterialBorde ) }
  object { BVPP_EjePlanoInterno( MaterialPiso ) }
  cylinder { // BVPP_CilindroPosteriorReja
    <0,0,1>, <0,0,0>, 1 
    material {
      MaterialBaranda
    }
    scale <0.05, 0.05, 0.28184>
    translate  <-0.7696, 0.0, -0.14092>
  }
}
union { // BVPP_Poste
  object { BVPP_BarandaUnLado( MaterialBaranda ) }
  object { BVPP_BarandaOtroLado( MaterialBaranda ) }
  object { BVPP_PostePunta( MaterialBaranda ) }
  object { BVPP_PosteAnterior( MaterialBaranda ) }
}                     
union { // BVPP_Cabina
  superellipsoid { // BVPP_CabinaBase01
    <0.5, 0.5>
    material {
      MaterialCabina
    }
    scale <0.4, 0.1, 0.15>
    translate  -0.05*y
  }
  object { BVPP_CabinaSinVentanas( MaterialCabina ) }
  object { BVPP_Ventanas  
    material            { 
      MaterialVentanas
    }
  }
  object { BVPP_BaseCabinaBarraIzquierda( MaterialCabina ) }
  object { BVPP_BaseCabinaBarraIzquierda1( MaterialCabina ) }
}

union { // BVPP_VelaPosterior
  object { BVPP_DetalleVelaPosterior }
  material {
    MaterialVelaPosterior
  }
}




union { // BVPP_Mastil
  cylinder { // BVPP_BaseMastil
    <0,0,1>, <0,0,0>, 1 
    scale <0.03, 0.03, 0.2>
    rotate -90.0*x
    translate  0.3*x
  }
  cone { // BVPP_MastilPrincipal
    <0,0,0>, 0.025, <0,0,1>, 0.0125
    scale <1.0, 1.0, 2.25>
    rotate <-90.970467, 0.014759, 2.61231>
    translate  0.3*x
  }
  cylinder { // BVPP_MastilHorizontal
    <0,0,1>, <0,0,0>, 1 
    scale <0.02, 0.02, 1.0>
    rotate <-0.050243, -86.386116, -2.460305>
    translate  <0.275, 0.35, 0.0> 
  }
  torus { // BVPP_TorusMastil
    1.0, 0.1  rotate -x*90
    scale 0.05
    translate  <0.284265, 0.369545, 0.0> 
    material            {   
      MaterialMetalizado
    }
  }
  box { // BVPP_Veleta
    <-1, -1, -1>, <1, 1, 1>  
    material                    {
      MaterialBandera
    }
    rotate <-3.635684, -2.167897, -28.814333>
    translate  <0.867747, -0.404577, 1.040118>
    scale <0.05, 0.05, 0.01>
    rotate <0.224058, 2.342129, 30.352777>
    translate  <0.204958, 2.181347, -0.042465> 
  }
  torus { // BVPP_AroMastil
    0.035, 0.015  rotate -x*90
    rotate <-6.148253, -90.0, 0.0>
    translate  <0.027131, 0.358377, 0.005313>
    material                    {   
      MaterialMetalizado
    }
  }
  torus { // BVPP_AroMastil1
    0.035, 0.015  rotate -x*90
    rotate <-6.148253, -90.0, 0.0>
    translate  <-0.313517, 0.376465, 0.023909> 
    material            {   
      MaterialMetalizado
    }
  }
  cylinder { // BVPP_BaseMastil1
    <0,0,1>, <0,0,0>, 1 
    scale <0.03, 0.03, 0.2>
    rotate <-90.803772, 0.043226, 3.621227>
    translate  <0.272869, 0.623302, -0.00797>
    material            {   
      MaterialMetalizado
    }
  }
  material {
    MaterialMastil
  }
}

union { // BVPP_VelaDelantera
  object { BVPP_DetalleVelaDelantera }
  material {
    MaterialVelaDelantera 
  }
}

union { // BVPP_VelaMedia
  object { BVPP_DetalleVelaMedia }
  material      {  
    MaterialVelaMedia
  }
}  

union { // BVPP_DecoradoMoray
  cylinder { // BVPP_Cylndr003
    <0,0,1>, <0,0,0>, 1 
    material {
      MaterialMetalizado
    }
    scale <0.005, 0.005, 0.15>
    rotate <-115.024933, -1.651992, -43.990681>
    translate  <0.71892, 0.009044, 0.0>
  }
  cylinder { // BVPP_Cylndr002
    <0,0,1>, <0,0,0>, 1 
    material {
      MaterialMetalizado
    }
    scale <0.005, 0.005, 0.075>
    rotate -90.0*x
    translate  0.776197*x
  }
  cylinder { // BVPP_Cylndr001
    <0,0,1>, <0,0,0>, 1 
    material {
      MaterialMetalizado
    }
    scale <0.01, 0.01, 0.05>
    rotate -90.0*x
    translate  0.776197*x
  }
  torus { // BVPP_AroCabina1
    0.105, 0.005  rotate -x*90
    material {
      MaterialMetalizado
    }
    rotate <-90.0, -0.0, -4.953473>
    translate  <0.280356, 0.027131, 0.0>
  }
  object { BVPP_RoundePosterior( MaterialCabina ) }
  box { // BVPP_Grada
    <-1, -1, -1>, <1, 1, 1>
    material {
      MaterialGrada
    }
    scale <0.1, 0.01, 0.1>
    translate  <-0.536596, -0.03316, 0.0>
  }
  box { // BVPP_Grada1
    <-1, -1, -1>, <1, 1, 1>
    material {
      MaterialGrada
    }
    scale <0.1, 0.011, 0.15>
    translate  <-0.569756, -0.03316, 0.0>
  }
  box { // BVPP_Grada3
    <-1, -1, -1>, <1, 1, 1>
    material {
      MaterialGrada
    }
    scale <0.1, 0.011, 0.02>
    translate  <-0.336898, 0.009044, 0.017854>
  }
  box { // BVPP_Grada2
    <-1, -1, -1>, <1, 1, 1>
    material {
      MaterialGrada
    }
    scale <0.1, 0.011, 0.02>
    translate  <-0.307487, 0.009044, -0.056475>
  }
  cylinder { // BVPP_Diferencia6
    <0,0,1>, <0,0,0>, 1 
    material {
      MaterialMetalizado
    }
    scale <0.03, 0.01, 0.3>
    rotate -90.0*y
    translate  <0.045982, 0.214035, -0.033885>
  }
  torus { // BVPP_AroCabina2
    0.095, 0.015  rotate -x*90
    material {
      MaterialMetalizado
    }
    scale <0.5, 0.75, 0.5>
    rotate <-90.0, -0.0, -4.953473>
    translate  <0.298444, 0.036175, 0.0>
  }
} 
  scale         10
}
#end    // 

#macro BVPP_Barco()    
  object                        {   
    BVPP_BarcoVeleroParaPiscina(  
      BVPP_MaterialCasco,
      BVPP_MaterialCabina,
      BVPP_MaterialBorde,  
      BVPP_MaterialPiso,
      BVPP_MaterialVentanas, 
      BVPP_MaterialBaranda,  
      BVPP_MaterialMastil,
      BVPP_MaterialVelaPosterior,
      BVPP_MaterialVelaDelantera,
      BVPP_MaterialVelaMedia,
      BVPP_MaterialBandera,
      BVPP_MaterialMetalizado, 
      BVPP_MaterialGrada
    )
  }
#end





