// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 11 noviembre 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//                      
// BVPP BarcoVeleroParaPiscina
// El archivo dibuja un barco velero, basada en un juguete
// a control remoto.  Se modifico ligeramente, para mejorar su apariencia
// y poderlo exhibir en escenas de mayor realismo.  Aunque probablemente
// falle en el acercamiento.
// Incluye macro para modificar texturas.  Es compatible con POVRay 3.1.
//      
// La siguiente macro dibuja el objeto default: 
// #macro BVPP_Barco()    
//                                             
// Las dimensiones del objetos default son :  
//      Minimo                  : <-9.75, -3.3,-2.35>
//      Maximo                  : <+9.00, 22.5,+2.35>  
// En el plano XY se encuentra la base de baranda.
// El verdero piso se encuentra por debajo del plano. 
// 
// La siguiente macro permite modificar las texturas facilmente:                               
// #macro BVPP_BarcoVeleroParaPiscina(
//      MaterialCasco, MaterialCabina, MaterialBorde, MaterialPiso,
//      MaterialVentanas, MaterialBaranda,   MaterialMastil,
//      MaterialVelaPosterior, MaterialVelaDelantera, MaterialVelaMedia,
//      MaterialBandera, MaterialMetalizado, MaterialGrada )
//              MaterialCasco           : Material a aplicar al casco.
//              MaterialCabina          : Material principal de cabina.
//              MaterialBorde           : Material para el borde.
//              MaterialPiso            : Material para el piso.
//              MaterialVentanas        : Material para ventanas.
//              MaterialBaranda         : Material para barandas.
//              MaterialMastil          : Material para el mastil.
//              MaterialVelaPosterior   : Material de vela posterior.
//              MaterialVelaDelantera   : Material de vela delantera.
//              MaterialVelaMedia       : Material de vela media.
//              MaterialBandera         : Material de bandera.
//              MaterialMetalizado      : Material de zonas metalicas.
//              MaterialGrada           : Material para gradas.                                                         
//                                                          
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse.
// #declare BVPP_DefaultMaterialCasco           
//      Material a aplicar al casco.
// #declare BVPP_DefaultMaterialCabina          
//      Material principal de cabina.
// #declare BVPP_DefaultMaterialBorde           
//      Material para el borde.
// #declare BVPP_DefaultMaterialPiso            
//      Material para el piso.
// #declare BVPP_DefaultMaterialVentanas        
//      Material para ventanas.
// #declare BVPP_DefaultMaterialBaranda         
//      Material para barandas.
// #declare BVPP_DefaultMaterialMastil          
//      Material para el mastil.
// #declare BVPP_DefaultMaterialVelaPosterior   
//      Material de vela posterior.
// #declare BVPP_DefaultMaterialVelaDelantera   
//      Material de vela delantera.
// #declare BVPP_DefaultMaterialVelaMedia       
//      Material de vela media.
// #declare BVPP_DefaultMaterialBandera         
//      Material de bandera.
// #declare BVPP_MaterialMetalizado      
//      Material de zonas metalicas.
// #declare BVPP_MaterialGrada           
//      Material para gradas.                                                         
//   
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare BVPP_MaterialCasco                          = material { ... }        
//      Material a aplicar al casco.
// #declare BVPP_MaterialCabina                         = material { ... }          
//      Material principal de cabina.
// #declare BVPP_MaterialBorde                          = material { ... }          
//      Material para el borde.
// #declare BVPP_DefaultMaterialPiso                    = material { ... }            
//      Material para el piso.
// #declare BVPP_DefaultMaterialVentanas                = material { ... }       
//      Material para ventanas.
// #declare BVPP_DefaultMaterialBaranda                 = material { ... } 
//      Material para barandas.
// #declare BVPP_DefaultMaterialMastil                  = material { ... }
//      Material para el mastil.
// #declare BVPP_DefaultMaterialVelaPosterior           = material { ... }
//      Material de vela posterior.
// #declare BVPP_DefaultMaterialVelaDelantera           = material { ... } 
//      Material de vela delantera.
// #declare BVPP_DefaultMaterialVelaMedia               = material { ... }
//      Material de vela media.
// #declare BVPP_DefaultMaterialBandera                 = material { ... }
//      Material de bandera.
// #declare BVPP_MaterialMetalizado                     = material { ... }
//      Material de zonas metalicas.
// #declare BVPP_MaterialGrada                          = material { ... }
//      Material para gradas.
// #declare BVPP_POV3_1                                 = off;
//      Valor "on" activa simplificaciones para lograr
//      compatibilidad con POVRay 3.1.  En algunas versiones se
//      activara automaticamente.
//
// Para colocarlo simplemente
//
// #include "BVPP.inc"
//  object                  {
//    BVPP_Barco( ) 
//  }
//
//  o bien la misma figura con la macro detallada... 
//  #include "BVPP.inc"
//  object                  { 
//    BVPP_BarcoVeleroParaPiscina(  
//      BVPP_MaterialCasco, BVPP_MaterialCabina, BVPP_MaterialBorde, BVPP_MaterialPiso,
//      BVPP_MaterialVentanas, BVPP_MaterialBaranda, BVPP_MaterialMastil,
//      BVPP_MaterialVelaPosterior, BVPP_MaterialVelaDelantera, BVPP_MaterialVelaMedia,
//      BVPP_MaterialBandera, BVPP_MaterialMetalizado, BVPP_MaterialGrada ) 
//  }
//
//  o bien se puede redefinir alguna textura 
//  #include "BVPP.inc"                     
//  #declare BVPP_MaterialCasco = material{ { Texture { PinkAlabaster } } }
//  object                  {                                   
//    BVPP_Barco()
//  }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}          

#include "BVPP.inc"
   
#local FactorAcercamiento               = 0.05;
   
   
object                 { 
  BVPP_Barco()         
  translate             -10*y
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z         
}

