// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 17 junio 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//
// Para lograr compatibilidad con POVRay 3.1., se
// realizo una copia casi textual de parte del archivo
// logo.inc de la distribucion PovRay.  La seccion copiada
// fue creada por Rune S. Johansen modificando el modelo original
// de Chris Cholefax.
//
// CCEB CalculadoraComplementoExamenBachillerato
// El archivo dibuja una calculadora, como las que usaban
// los estudiantes bachilleres en la decada pasada.
//
// La macro default no tiene parametros
// #macro CCEB_Calculadora()
//
// Las dimensiones de la calculdora son:
//      Alto total              =   109.0*L
//      Frente                  =    54.0*L
//      Profundidad             =   - 3.8*L..+6.2*L
// Se dibuja parcialmente centrado en el origen.
// El frente sobresale en direccion Z-, con gravedad Y-.
//
// La siguiente macro permite mayor flexibilidad:
// #macro CCEB_CalculadoraComplementoExamenBachillerato(
//         AltoCalculadora, AnchoCalculadora, ProfundidadCalculadora,
//         Titulo, ColorTitulo, TituloSuperior,
//         FraccionPosterior, FraccionPantalla, FraccionAltoPantalla,
//         FraccionBoton1, AltoBoton1,
//         FraccionBoton2, AltoBoton2,
//         ListaBoton1, ListaBoton2,
//         ListaString, ListaColores,
//         TexturaPlastica, TexturaFondoPantalla )
//      AltoCalculadora         : Alto Y de la calculdora.  Default es 109*L.
//      AnchoCalculadora        : Frente X de la calculadora.
//                                Default es 54*L.
//      ProfundidadCalculadora  : Referencia para la profundidad Z.
//                                Default es 8*L.
//      Titulo                  : Para colocar un titulo a la pantalla.
//                                Default es "BACHILLER".
//      ColorTitulo             : Para darle color al titulo y otros
//                                elementos relacionados.
//                                Default es Gray60.
//      TituloSuperior          : Para colocar un titulo superior.
//                                Default es "PROCESADOR POVRay"
//      FraccionPosterior       : Para generar abultamiento posterior,
//                                para la bateria y otros elementos.
//                                Utilice 0.0 para eliminar el efecto.
//                                Default es 0.5.
//      FraccionPantalla        : Ubica como fraccion la pantalla respecto
//                                al borde inferior.
//                                Default es 0.75.
//      FraccionAltoPantalla    : Alto como fraccion vertical de la pantalla.
//                                Default es 1/7.
//      FraccionBoton1          : Ubica como fraccion vertical el primer
//                                grupo de botones.
//                                Default es 0.19.
//      AltoBoton1              : Alto como fraccion vertical del
//                                primer grupo de botones.
//                                Utilice un valor de 0 par no dibujar.
//                                Default es 0.3.
//      FraccionBoton2          : Ubica como fraccion vertical el segundo
//                                grupo de botones.
//                                Default es 0.51.
//      AltoBoton2              : Alto como fraccion vertical del
//                                segundo grupo de botones.
//                                Utiliceun valor de 0 para no dibujar.
//                                Default es 3/11.
//      ListaBoton1             : Describe los botones del primer grupo
//                                como un array [Filas][Columnas][5]
//                                Cada dato tiene la composicion.
//                                { IndiceString1, IndiceString2,
//                                  IndiceColor1, IndiceColor2, IndiceColor3 }
//                                Default es CCEB_ListaBoton1.
//              IndiceString1   : Valor indice a partir de cero en parametro
//                      ListaString, para rotular el boton.
//                      Indice 0 no escribe mensaje
//                      Negativo no dibuja el boton
//                      Indice -2 dibuja un boton cilindrico del doble
//                      de tamano sin texto, ni otros rotulos.  Deberia
//                      asignar indice negativos a los botones
//                      derecho, inferior e inferior-derecho.
//                      Utilice mensajes de tres letras maximo.
//              IndiceString2   : Valor indice adicional para texto
//                      sobre el boton.
//              IndiceColor1    : Valor indice de color del boton
//                      segun parametro ListaColores.
//              IndiceColor2    : Para el color del texto.
//              IndiceColor3    : Color del texto sobre el boton.
//      ListaBoton2             : Similar a ListaBoton1, pero aplicado
//                                al segundo grupo de botones.
//                                Default es CCEB_ListaBoton2.
//      ListaString             : Array de String para los botones.
//                                El primer dato se ignora, pues
//                                el indice cero, indica ningun rotulo.
//                                Default es CCEB_ListaString.
//      ListaColores            : Array de colores para los botones.
//                                Default es CCEB_ListaColores.
//      TexturaPlastica         : Textura de la calculadora.
//                                Default es CCEB_TexturaPlastica.
//      TexturaFondoPantalla    : Textura de la pantalla.
//                                Default es CCEB_TexturaFondoPantalla.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare CCEB_DefaultTexturaPlastica
//      Textura principal para la calculadora.
// #declare CCEB_DefaultTexturaFondoPantalla
//      Textura para la pantalla.
// #declare CCEB_ListaBoton1
//      Contiene una descripcion de los botones basicos.
// #declare CCEB_ListaBoton2
//      Contiene una descripcion de otras funciones de la calculadora.
// #declare CCEB_ListaString
//      Array para rotular los botones.
// #declare CCEB_ListaColores
//      Array para los colores a aplicar a los botones.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare CCEB_TexturaPlastica                = texture { ... }
//      Textura principal a aplicar a la calculadora.
// #declare CCEB_TexturaFondoPantalla           = texture { ... }
//      Textura a aplicar al fondo de pantalla. 
// #declare CCEB_BanderaLogo                    = on;
//      Valor off suprime el logo POVRay.
// #declare CCEB_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "CCEB.inc"
// object        { CCEB_Calculadora( ) }
//
// Otro ejemplo con modificador
// #include "CCEB.inc"
// #declare CCEB_TexturaPlastica        = texture       {
//   average
//   texture_map        {
//     [ 0.5 CCEB_DefaultTexturaPlastica ]
//     [ 0.5 Rust                        ]
//   }
// }
// object        {
//   CCEB_Calculadora( )
// }
//
// Un ejemplo con la macro detallada
// #include "CCEB.inc"
// object               {
//   CCEB_CalculadoraComplementoExamenBachillerato
//   ( 0.109, 0.054, 0.008, "BACHILLER", Gray60, "PROCESADOR POVRay", 0.5,
//     0.75, 1/7, 0.055, 0.3, 0.51, 3/11, CCEB_ListaBoton1, CCEB_ListaBoton2,
//     CCEB_ListaString, CCEB_ListaColores, CCEB_TexturaPlastica,
//     CCEB_TexturaFondoPantalla )
// }
//

#include "colors.inc"
#declare CCEB_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( CCEB_POV3_1 )
    #declare CCEB_POV3_1        = on;
  #end
#else
  #ifndef( CCEB_POV3_1 )
    #declare CCEB_POV3_1        = off;
  #end
#end

#declare CCEB_BanderaLogo       = on;

#if ( CCEB_POV3_1 )
// copia textual desde logo.inc
#declare Povray_Logo_Prism =
merge {
   cylinder {-z, z, 1 translate 2*y}
   difference {
      prism {-0.9999, 0.9999, 4, <-1,2>, <1,2>, <0,-4>, <-1,2> rotate -90*x}
      cylinder {-z, z, 1.4 scale <1,0.9,1.1> translate 1.9*y}
   }
   difference {
      cylinder {-z, z, 1 scale <2.6, 2.2, 1>}
      cylinder {-z, z, 1 scale <2.22, 1.72, 1.1> translate <-0.43, 0, 0>}
      rotate z*30 translate 2*y
   }
   rotate <0, 0, -25>
   translate <-0.5,-0.35,0>
   scale <1/4,1/4,1/8>
}
#else
 #include "logo.inc"
#end

#declare CCEB_DefaultTexturaPlastica     = texture       {
  pigment               {
    MidnightBlue
  }
  normal                {
    bumps
  }
}

#declare CCEB_TexturaPlastica            = texture       {
  CCEB_DefaultTexturaPlastica
}

#declare CCEB_DefaultTexturaFondoPantalla = texture       {
  pigment               {
    MediumSpringGreen
  }
  finish                {
    phong       0.2
  }
  normal                {
    gradient x
    scale               0.01
    turbulence          0.02
  }
}
  texture               {
    pigment             {
      bumps
      scale             0.001
      pigment_map       {
        [ 0.0 color HuntersGreen filter 0.02 ]
        [ 1.0 color SeaGreen     filter 0.02 ]
      }
    }
    finish              {
      phong     0.3
    }
  }

#declare CCEB_TexturaFondoPantalla       = texture       {
  CCEB_DefaultTexturaFondoPantalla
}

#declare CCEB_ListaBoton2               = array [5][6][5]
  { { { 0, 23, 1, 0, 5},
      { 0, 24, 1, 0, 3},
      {-2, 0, 1, 0, 0},
      {-1, 0, 1, 0, 0},
      { 0, 25, 1, 0, 1},
      { 0, 26, 1, 0, 1} },
    { {27,50, 4, 2, 5},
      {28, 0, 4, 2, 0},
      {-1, 0, 1, 0, 0},
      {-1, 0, 1, 0, 0},
      {29,52, 4, 2, 5},
      {30, 0, 4, 2, 0} },
    { {31, 0, 4, 2, 0},
      {32, 0, 4, 2, 0},
      {33, 0, 4, 2, 0},
      {34, 0, 4, 2, 0},
      {35,51, 4, 2, 5},
      {36, 0, 4, 2, 0} },
    { {37,53, 4, 2, 5},
      {38,54, 4, 2, 5},
      {39,55, 4, 2, 5},
      {40,56, 4, 2, 5},
      {41,57, 4, 2, 5},
      {42,58, 4, 2, 5} },
    { {43,49, 4, 2, 5},
      {44, 0, 4, 2, 0},
      {45, 0, 4, 2, 0},
      {46, 0, 4, 2, 0},
      {47, 0, 4, 2, 0},
      {48, 0, 4, 2, 0} } }

#declare CCEB_ListaBoton1               = array [4][5][5]
  { { { 1, 0, 1, 2, 0},
      { 2, 0, 1, 2, 0},
      { 3, 0, 1, 2, 0},
      { 4, 22, 3, 2, 5},
      { 5, 21, 3, 2, 5} },
    { { 6, 0, 1, 2, 0},
      { 7, 0, 1, 2, 0},
      { 8, 0, 1, 2, 0},
      { 9, 0, 1, 2, 0},
      { 10, 0, 1, 2, 0} },
    { { 11, 0, 1, 2, 0},
      { 12, 0, 1, 2, 0},
      { 13, 0, 1, 2, 0},
      { 14, 0, 1, 2, 0},
      { 15, 0, 1, 2, 0} },
    { { 16, 0, 1, 2, 0},
      { 17, 0, 1, 2, 0},
      { 18, 0, 1, 2, 0},
      { 19, 0, 1, 2, 0},
      { 20, 0, 1, 2, 0} } }
      
#declare CCEB_ListaColores      = array [6]
  { Clear, Gray60, White, Red, Gray30, Orange }

#declare CCEB_ListaString       = array [59]
  { "1", "7", "8", "9", "DEL", "AC", "4", "5", "6", "X", "/",
         "1", "2", "3", "+", "-", "0", ".", "EXP", "ANS", "=",
         "OFF", "INS", "SHIFT", "ALPHA", "MODE", "ON",
         "inv", "nCr", "Pol", "x3", "fra", "srt", "x2", "pot", "log", "ln",
         "neg", "seg", "hyp", "sin", "cos", "tan",
         "RCL", "ENG", "(", ")", ",", "M+",
         "STO", "fac", "pow", "Rec", "A", "B", "C", "D", "E", "F" }

#macro CCEB_ArregloBotones
  ( ListaBoton, ListaString, ListaColor )
  union                         {
    #local TotX                 = dimension_size( ListaBoton, 2 );
    #local TotY                 = dimension_size( ListaBoton, 1 );
    #local DeltaX               = 1/TotX;
    #local DeltaY               = 1/TotY;
    #local D                    = 0;
    #while ( D < TotY )
      #local C                  = 0;
      #while ( C < TotX )
        #if ( ListaBoton[D][C][0] >= 0 )
          union                 {
            superellipsoid      {
              <0.2,0.2>
              pigment           {
                ListaColor[ ListaBoton[D][C][2] ]
              }
            }
            #if ( ListaBoton[D][C][0] > 0 )
              #local Mensaje    = ListaString[ ListaBoton[D][C][0] ]
              text              {
                ttf
                  "timrom.ttf" Mensaje 1, 0
                  scale 1.6
                  translate       -0.5*y-1.25*z-0.3*x
                #switch (strlen(Mensaje))
                  #case (2)
                    scale       <0.60,1,1>
                    translate   -0.3*x
                  #break
                  #case (3)
                    scale       <0.50,1,1>
                    translate   -0.6*x
                #end
                pigment {
                  ListaColor[ ListaBoton[D][C][3] ]
                }

              }
            #end
            #if ( ListaBoton[D][C][1] > 0 )
              text                      {
                ttf "timrom.ttf" ListaString[ ListaBoton[D][C][1] ] 1, 0
                scale   0.75
                translate       +1.4*y-0.2*z-1.0*x
                pigment {
                  ListaColor[ ListaBoton[D][C][4] ]
                }
              }
            #end
            scale               < DeltaX*0.75, DeltaY*0.5, 1 >
            translate           ( 2*( C+0.5 )*DeltaX-1 )*x
                               +( 1-2*( D+0.5 )*DeltaY )*y
          }
        #else  // PuntoPivote.red >= 0
          #if ( ListaBoton[D][C][0] = -2 )
          union                 {
            difference          {
              cylinder          {
                -z, z, 1
              }
              torus             {
                0.65, 0.12
                rotate  90*x
                translate       -z
              }
              pigment           {
                ListaColor[ ListaBoton[D][C][2] ]
              }
              normal            { onion scale 1
                rotate  90*x
                translate -10*z
              }
            }
            scale               < DeltaX*1.50, DeltaY*1.75, 1 >
            translate           ( 2*( C+1.0 )*DeltaX-1 )*x
                               +( 1-2*( D+1.0 )*DeltaY )*y
          }
          #end
        #end
        #local C                = C+1;
        
      #end
      #local D                  = D+1;
    #end
  }
#end

#macro CCEB_CalculadoraComplementoExamenBachillerato(
         AltoCalculadora, AnchoCalculadora, ProfundidadCalculadora,
         Titulo, ColorTitulo, TituloSuperior,
         FraccionPosterior, FraccionPantalla, FraccionAltoPantalla,
         FraccionBoton1, AltoBoton1,
         FraccionBoton2, AltoBoton2,
         ListaBoton1, ListaBoton2,
         ListaString, ListaColores,
         TexturaPlastica, TexturaFondoPantalla
       )
  union                         {
    // Cuerpo principal
    union                       {
      difference                {
        union                   {
          superellipsoid        {
            <0.2,0.2>
          }
          difference            {
            superellipsoid        {
              <0.2,0.2>
              matrix              <
                                  1,0,0,
                                  0,1,FraccionPosterior,
                                  0,0,1,
                                  0,0,0
                                  >
            }
            plane               {
              y, 0
            }
          }
        }
        superellipsoid          {
          <0.1,0.1>
          scale         <0.8,FraccionAltoPantalla,0.4>
          translate             ( 2*FraccionPantalla-1 )*y
          translate             -z
        }
        superellipsoid          {
          <0.05,0.05>
          scale        <2,1.0,0.05>
          translate     -y
        }
      }
      box                       {
        -1, 1
        scale           <0.8,FraccionAltoPantalla,0.8>
        translate       ( 2*FraccionPantalla-1 )*y
        texture { TexturaFondoPantalla }
      }
      text                      {
        ttf "timrom.ttf" Titulo 1, 0
        scale   FraccionAltoPantalla/2*<2,1,3>
        translate       ( 2*FraccionPantalla-1 )*y+1.25*FraccionAltoPantalla*y
                        -1.15*z-0.8*x
        pigment { ColorTitulo }
      }
      text                      {
        ttf "timrom.ttf" TituloSuperior 1, 0
        scale   FraccionAltoPantalla/3*<1.5,1,3>
        translate       y-FraccionAltoPantalla*y-0.8*x-1.15*z
        pigment { ColorTitulo }
      }
      #if ( CCEB_BanderaLogo )
        object                  {
          Povray_Logo_Prism
          scale   FraccionAltoPantalla/2*<1.5,1,8>
          translate       y-FraccionAltoPantalla*y+0.7*x-1.05*z
          pigment { ColorTitulo }
        }
      #end
      #if ( AltoBoton1 > 0 )
      object                    {
        object          {
          CCEB_ArregloBotones( ListaBoton1, ListaString, ListaColores )
        }
        scale           <0.85,AltoBoton1,0.1>
        translate               ( 2*FraccionBoton1-1 )*y-z
        pigment { White }
      }
      #end  // #if ( AltoBoton1 )
      #if  ( AltoBoton2 > 0 )
      object                    {
        object          {
          CCEB_ArregloBotones( ListaBoton2, ListaString, ListaColores )
        }
        scale           <0.85,AltoBoton2,0.1>
        translate               ( 2*FraccionBoton2-1 )*y-z
        pigment {White}
      }
      #end  // #if ( AltoBoton2 )
      superellipsoid            {
        <0.2,0.2>
        scale           <0.9,0.9,0.3>
      }
      scale             <AnchoCalculadora,AltoCalculadora,
                          ProfundidadCalculadora>/2
    }  // superellipsoid
    texture                     {
      TexturaPlastica
    }
  }  // union
#end

#macro CCEB_Calculadora()
  object                {
    #local L            = CCEB_L;
    #local Alto         = 109*L;
    #local Ancho        = 54*L;
    #local Profundidad  = 8*L;
    #local FraccionPantalla             = 0.75;
    #local FraccionAltoPantalla         = 1/7;
    #local FraccionPosterior            = 0.5;
    #local FraccionBoton1               = 3/20+0.04;
    #local FraccionAltoBoton1           = 3/10;
    #local FraccionBoton2               = 9/20+0.06;
    #local FraccionAltoBoton2           = 3/11;
    #local Titulo                       = "BACHILLER"
    #local TituloSuperior               = "PROCESADOR POVRay"
    CCEB_CalculadoraComplementoExamenBachillerato(
      Alto, Ancho, Profundidad, Titulo, Gray60,
      TituloSuperior,
      FraccionPosterior, FraccionPantalla, FraccionAltoPantalla,
      FraccionBoton1, FraccionAltoBoton1,
      FraccionBoton2, FraccionAltoBoton2,
      CCEB_ListaBoton1, CCEB_ListaBoton2, CCEB_ListaString, CCEB_ListaColores,
      CCEB_TexturaPlastica, CCEB_TexturaFondoPantalla
    )
    
  }
#end
