// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 17 junio 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//
// Para lograr compatibilidad con POVRay 3.1., se
// realizo una copia casi textual de parte del archivo
// logo.inc de la distribucion PovRay.  La seccion copiada
// fue creada por Rune S. Johansen modificando el modelo original
// de Chris Cholefax.
//
// CCEB CalculadoraComplementoExamenBachillerato
// El archivo dibuja una calculadora, como las que usaban
// los estudiantes bachilleres en la decada pasada.
//
// La macro default no tiene parametros
// #macro CCEB_Calculadora()
//
// Las dimensiones de la calculdora son:
//      Alto total              =   109.0*L
//      Frente                  =    54.0*L
//      Profundidad             =   - 3.8*L..+6.2*L
// Se dibuja parcialmente centrado en el origen.
// El frente sobresale en direccion Z-, con gravedad Y-.
//
// La siguiente macro permite mayor flexibilidad:
// #macro CCEB_CalculadoraComplementoExamenBachillerato(
//         AltoCalculadora, AnchoCalculadora, ProfundidadCalculadora,
//         Titulo, ColorTitulo, TituloSuperior,
//         FraccionPosterior, FraccionPantalla, FraccionAltoPantalla,
//         FraccionBoton1, AltoBoton1,
//         FraccionBoton2, AltoBoton2,
//         ListaBoton1, ListaBoton2,
//         ListaString, ListaColores,
//         TexturaPlastica, TexturaFondoPantalla )
//      AltoCalculadora         : Alto Y de la calculdora.  Default es 109*L.
//      AnchoCalculadora        : Frente X de la calculadora.
//                                Default es 54*L.
//      ProfundidadCalculadora  : Referencia para la profundidad Z.
//                                Default es 8*L.
//      Titulo                  : Para colocar un titulo a la pantalla.
//                                Default es "BACHILLER".
//      ColorTitulo             : Para darle color al titulo y otros
//                                elementos relacionados.
//                                Default es Gray60.
//      TituloSuperior          : Para colocar un titulo superior.
//                                Default es "PROCESADOR POVRay"
//      FraccionPosterior       : Para generar abultamiento posterior,
//                                para la bateria y otros elementos.
//                                Utilice 0.0 para eliminar el efecto.
//                                Default es 0.5.
//      FraccionPantalla        : Ubica como fraccion la pantalla respecto
//                                al borde inferior.
//                                Default es 0.75.
//      FraccionAltoPantalla    : Alto como fraccion vertical de la pantalla.
//                                Default es 1/7.
//      FraccionBoton1          : Ubica como fraccion vertical el primer
//                                grupo de botones.
//                                Default es 0.19.
//      AltoBoton1              : Alto como fraccion vertical del
//                                primer grupo de botones.
//                                Utilice un valor de 0 par no dibujar.
//                                Default es 0.3.
//      FraccionBoton2          : Ubica como fraccion vertical el segundo
//                                grupo de botones.
//                                Default es 0.51.
//      AltoBoton2              : Alto como fraccion vertical del
//                                segundo grupo de botones.
//                                Utiliceun valor de 0 para no dibujar.
//                                Default es 3/11.
//      ListaBoton1             : Describe los botones del primer grupo
//                                como un array [Filas][Columnas][5]
//                                Cada dato tiene la composicion.
//                                { IndiceString1, IndiceString2,
//                                  IndiceColor1, IndiceColor2, IndiceColor3 }
//                                Default es CCEB_ListaBoton1.
//              IndiceString1   : Valor indice a partir de cero en parametro
//                      ListaString, para rotular el boton.
//                      Indice 0 no escribe mensaje
//                      Negativo no dibuja el boton
//                      Indice -2 dibuja un boton cilindrico del doble
//                      de tamano sin texto, ni otros rotulos.  Deberia
//                      asignar indice negativos a los botones
//                      derecho, inferior e inferior-derecho.
//                      Utilice mensajes de tres letras maximo.
//              IndiceString2   : Valor indice adicional para texto
//                      sobre el boton.
//              IndiceColor1    : Valor indice de color del boton
//                      segun parametro ListaColores.
//              IndiceColor2    : Para el color del texto.
//              IndiceColor3    : Color del texto sobre el boton.
//      ListaBoton2             : Similar a ListaBoton1, pero aplicado
//                                al segundo grupo de botones.
//                                Default es CCEB_ListaBoton2.
//      ListaString             : Array de String para los botones.
//                                El primer dato se ignora, pues
//                                el indice cero, indica ningun rotulo.
//                                Default es CCEB_ListaString.
//      ListaColores            : Array de colores para los botones.
//                                Default es CCEB_ListaColores.
//      TexturaPlastica         : Textura de la calculadora.
//                                Default es CCEB_TexturaPlastica.
//      TexturaFondoPantalla    : Textura de la pantalla.
//                                Default es CCEB_TexturaFondoPantalla.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare CCEB_DefaultTexturaPlastica
//      Textura principal para la calculadora.
// #declare CCEB_DefaultTexturaFondoPantalla
//      Textura para la pantalla.
// #declare CCEB_ListaBoton1
//      Contiene una descripcion de los botones basicos.
// #declare CCEB_ListaBoton2
//      Contiene una descripcion de otras funciones de la calculadora.
// #declare CCEB_ListaString
//      Array para rotular los botones.
// #declare CCEB_ListaColores
//      Array para los colores a aplicar a los botones.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare CCEB_TexturaPlastica                = texture { ... }
//      Textura principal a aplicar a la calculadora.
// #declare CCEB_TexturaFondoPantalla           = texture { ... }
//      Textura a aplicar al fondo de pantalla. 
// #declare CCEB_BanderaLogo                    = on;
//      Valor off suprime el logo POVRay.
// #declare CCEB_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "CCEB.inc"
// object        { CCEB_Calculadora( ) }
//
// Otro ejemplo con modificador
// #include "CCEB.inc"
// #declare CCEB_TexturaPlastica        = texture       {
//   average
//   texture_map        {
//     [ 0.5 CCEB_DefaultTexturaPlastica ]
//     [ 0.5 Rust                        ]
//   }
// }
// object        {
//   CCEB_Calculadora( )
// }
//
// Un ejemplo con la macro detallada
// #include "CCEB.inc"
// object               {
//   CCEB_CalculadoraComplementoExamenBachillerato
//   ( 0.109, 0.054, 0.008, "BACHILLER", Gray60, "PROCESADOR POVRay", 0.5,
//     0.75, 1/7, 0.055, 0.3, 0.51, 3/11, CCEB_ListaBoton1, CCEB_ListaBoton2,
//     CCEB_ListaString, CCEB_ListaColores, CCEB_TexturaPlastica,
//     CCEB_TexturaFondoPantalla )
// }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "CCEB.inc"

#local FactorAcercamiento       = 10;

object                  {
  CCEB_Calculadora()
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z       
}


