// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 29 abril 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// CFPS CasaFiguraPeliculaShoujo
// El archivo dibuja una casita para figuras de peliculas Shoujo
// de juguete, de supuesta fabricacion artesanal.
// #macro CFPS_Casita( AnguloDelantero1, AnguloDelantero2,
//                     AnguloPosterior1, AnguloPosterior2 )
//      AnguloDelantero1        : Controla el angulo
//              de apertura a partir de cero puerta delantera izquierda.
//      AnguloDelantero2        : Controla el angulo
//              de apertura a partir de cero puerta delantera derecha.
//      AnguloPosterior1        : Controla el angulo
//              de apertura de la puerta trasera inferior.
//      AnguloPosterior2        : Controla el angulo
//              de apertura de la puerta trasera superior.
//
// La siguiente macro permite mayor flexibilidad.
// #macro CFPS_CasaFiguraPeliculaShoujo(
//    AnguloDelantero1,AnguloDelantero2,ArregloAnguloPosterior,
//    ReferenciaX, ReferenciaY, ReferenciaZ,
//    GruesoMadera, RadioTorre, RadioTorreSuperior,
//    RadioMesaSuperior, AltoMesaSuperior, GruesoBorde, TotalPisos,
//    TexturaMaderaBase, TexturaMaderaInterior,
//    TexturaTorre, TexturaTorreSuperior, TexturaAccesorios )
//      AnguloDelantero1        : Controla el angulo
//              de apertura a partir de cero puerta delantera izquierda.
//      AnguloDelantero1        : Controla el angulo
//              de apertura a partir de cero puerta delantera derecha.
//      ArregloAnguloPosterior  : Controla los angulos
//              de apertura de los compartimientos posteriores.
//              Es un arreglo real de dimension igual al total de pisos.
//      ReferenciaX             : Valor de referencia para el frente.
//              Default es 375*L.
//      ReferenciaY             : Valor de la altura por piso sin el
//              grueso de la madera.  Default es 215*L.
//      ReferenciaZ             : Profundidad de referencia
//              para la casita.  Default es 215*L.
//      GruesoMadera            : Mide el grueso de la madera.
//              Default es 5*L.
//      RadioTorre              : Radio de la torre en la zona inferior.
//              Defaut es 40*L.
//      RadioTorreSuperior      : Radio de la torre en la zona superior.
//              Default es 55*L.
//      RadioMesaSuperior       : Radio de la mesa en la terraza superior.
//              Default es 40*L.
//      AltoMesaSuperior        : Alto de la mesa de la terraza.
//              Default es 50*L.
//      GruesoBorde             : Grueso de las lineas de la baranda.
//              Default es 5*L.
//      TotalPisos              : Total de pisos de la estructura.
//              Default es 2.
//      TexturaMaderaBase       : Textura principal del objeto.
//              Default es CFPS_TexturaMaderaBase.
//      TexturaMaderaInterior   : Textura de algunas placas interiores.
//              Default es CFPS_TexturaMaderaInterior.
//      TexturaTorre            : Textura de la torre inferior.
//              Default es CFPS_TexturaTorre.
//      TexturaTorreSuperior    : Textura superior de torre.
//              Default es CFPS_TexturaTorreSuperior.
//      TexturaAccesorios       : Textura de algunos accesorios.  Se aplica
//              en la escalera, mesa y sillas.
//              Default es CFPS_TexturaAccesorios.
//
// Las dimensiones de la estrutura cerrada:
//      Alto            : 112.5*L+220*L*TotalPisos
//      Frente          : 485*L
//      Profundidad     : 245*L
// El cuerpo se encuentra parcialmente centrado sobre el plano
// XZ, frente hacia Z- y gravedad Y-.
//
// Las siguientes variables predefinidas no deberian modificarse.
// CFPS_DefaultTexturaMaderaBase
//      Textura de la madera base.
// CFPS_DefaultTexturaMaderaInterior
//      Textura de algunas zonas interiores.
// CFPS_DefaultTexturaTorre
//      Textura de la torre.
// CFPS_DefaultTexturaTorreSuperior
//      Textura de la torre superior.
// CFPS_DefaultTexturaAccesorios
//      Textura de algunos accesorios.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare CFPS_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare CFPS_TexturaMaderaBase              =
//              texture { CFPS_DefaultTexturaMaderaBase         }
//      Textura principal de la estructura.
// #declare CFPS_TexturaMaderaInterior          =
//              texture { CFPS_DefaultTexturaMaderaInterior     }
//      Textura a aplicar a la madera interior.
// #declare CFPS_TexturaTorre                   =
//              texture { CFPS_DefaultTexturaTorre              }
//      Textura a aplicar a la torre.
// #declare CFPS_TexturaTorreSuperior           =
//              texture { CFPS_DefaultTexturaTorreSuperior      }
//      Textura a aplicar en la torre superior.
// #declare CFPS_TexturaAccesorios              =
//              texture { CFPS_DefaultTexturaAccesorios         }
//      Textura a aplicar a los accesorios.
//
// Algunos ejemplos de uso....
// #include "CFPS.inc"
// object        { CFPS_Casita(0,0,0,0) }
//
// Otro ejemplo con modificador
// #include "CFPS.inc"
// #declare CFPS_TexturaMaderaBase        =
//      texture { CFPS_DefaultTexturaMaderaBase }
//      texture { pigment {rgbt 0.5 } }
// object        { CFPS_Casita(0,0,0,0) }
//
// Otro ejemplo con macro de texturas
// #include "CFPS.inc"
// #declare ArregloAngulos      = array [2] {0,0}
// object        { CFPS_CasaFiguraPeliculaShoujo( 0, 0, ArregloAngulos,
//             0.375, 0.215, 0.215, 0.005, 0.040,
//             0.055, 0.040, 0.050, 0.005, 2,
//             CFPS_TexturaMaderaBase, CFPS_TexturaMaderaInterior,
//             CFPS_TexturaTorre, CFPS_TexturaTorreSuperior,
//             CFPS_TexturaAccesorios ) }

#include "woods.inc"
#include "metals.inc"
#include "shapes.inc"
#include "textures.inc"

#declare CFPS_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( CFPS_POV3_1 )
    #declare CFPS_POV3_1        = on;
  #end
#else
  #ifndef( CFPS_POV3_1 )
    #declare CFPS_POV3_1        = off;
  #end
#end

#declare CFPS_DefaultTexturaMaderaBase          = texture       {
//  PinkAlabaster
  pigment               {
    crackle 
    scale       0.01
    pigment_map         {
      [0.0 Yellow]
      [1.0 Red*0.5+Magenta*0.5]
    }
    //color Magenta        transmit        0.0
  }
  #ifndef ( CFPS_POV3_1 )
  normal                {
    facets   
    coords      0.1
   // scale       0.001
  }
  #end
}

#declare CFPS_TexturaMaderaBase                 = texture       {
  CFPS_DefaultTexturaMaderaBase
}

#declare CFPS_DefaultTexturaMaderaInterior      = texture       {
  PinkAlabaster
  pigment               {
    color Magenta        transmit        0.3
  }
}

#declare CFPS_TexturaMaderaInterior             = texture       {
  CFPS_DefaultTexturaMaderaInterior
}

#declare CFPS_DefaultTexturaTorre               = texture       {
  pigment              {
  brick
  pigment { White } pigment { Red }
  scale         0.006
  }
}

#declare CFPS_TexturaTorre                      = texture       {
  CFPS_DefaultTexturaTorre          
}

#declare CFPS_DefaultTexturaTorreSuperior       = texture       {
  pigment              {
  brick
  pigment { Magenta } pigment { Red }
  scale         0.003
  }
}

#declare CFPS_TexturaTorreSuperior      = texture       {
  CFPS_DefaultTexturaTorreSuperior
}

#declare CFPS_DefaultTexturaAccesorios           = texture       {
  pigment { Gold }
}

#declare CFPS_TexturaAccesorios            = texture       {
  CFPS_DefaultTexturaAccesorios
}

#macro CFPS_CasaFiguraPeliculaShoujo(
      AnguloDelantero1,AnguloDelantero2,ArregloAnguloPosterior,
      ReferenciaX, ReferenciaY, ReferenciaZ,
      GruesoMadera, RadioTorre, RadioTorreSuperior,
      RadioMesaSuperior, AltoMesaSuperior, GruesoBorde, TotalPisos,
      TexturaMaderaBase, TexturaMaderaInterior,
      TexturaTorre, TexturaTorreSuperior, TexturaAccesorios )
  union                         {
    #local RadioSillaSuperior   = RadioMesaSuperior/4;
    #local AltoSillaSuperior    = AltoMesaSuperior*0.4;
    union                       {
      difference                {
        union                   {
          box                     {
            <-ReferenciaX/2-GruesoMadera,0,-ReferenciaZ/2>,
            <+ReferenciaX/2+GruesoMadera,
             +GruesoMadera+TotalPisos*ReferenciaY+TotalPisos*GruesoMadera,
             +ReferenciaZ/2 >
          }
          #local C              = 0;
          #while ( C < 4 )
            union               {
              cylinder              {
                0, ( GruesoMadera+TotalPisos*ReferenciaY
                          +TotalPisos*GruesoMadera )*y,
                RadioTorre
                texture             {
                  TexturaTorre
                }
                translate           -( ReferenciaX/2+GruesoMadera )*x
                translate           -( ReferenciaZ/2-RadioTorre )*z
              }
              cylinder                  {
                0, AltoSillaSuperior*y,
                RadioSillaSuperior
                texture { TexturaMaderaInterior }
                translate ( GruesoMadera+TotalPisos*ReferenciaY
                          +TotalPisos*GruesoMadera )*y
                translate
                    ( -RadioMesaSuperior-2*RadioSillaSuperior )*(x+z)
                texture         {
                  TexturaAccesorios
                }
              }
              difference                {
                cylinder              {
                  ( GruesoMadera+TotalPisos*ReferenciaY
                          +TotalPisos*GruesoMadera )*y,
                  ( GruesoMadera+TotalPisos*ReferenciaY+ReferenciaY/2+
                          +TotalPisos*GruesoMadera )*y,
                  RadioTorreSuperior
                }
                cylinder              {
                  ( GruesoMadera+TotalPisos*ReferenciaY+0.01*ReferenciaY+
                          +TotalPisos*GruesoMadera )*y,
                  ( GruesoMadera+TotalPisos*ReferenciaY+ReferenciaY+
                          +TotalPisos*GruesoMadera )*y,
                  RadioTorre
                }
                texture             {
                    TexturaTorreSuperior
                }

                translate           -( ReferenciaX/2+GruesoMadera )*x
                translate           -( ReferenciaZ/2-RadioTorre )*z
              }
              #switch (C)
                #case (0)
                  scale <+1,+1,+1>
                #break
                #case (1)
                  scale <-1,+1,+1>
                #break
                #case (2)
                  scale <-1,+1,-1>
                #break
                #case (3)
                  scale <+1,+1,-1>
                #break
              #end
            }
            #local C            = C+1;
          #end
        }
        #local C                = 0;
        #while ( C < TotalPisos )
          union                 {
            box                 {
              <-ReferenciaX/2,GruesoMadera,-ReferenciaZ>,
              <+ReferenciaX/2,GruesoMadera+ReferenciaY,+ReferenciaZ>
            }
            box                 {
              <0,GruesoMadera+ReferenciaY/2,-ReferenciaZ/2+RadioTorre>,
              <ReferenciaX,ReferenciaY,+ReferenciaZ/2
                                            -RadioTorre>
            }
            translate           C*( ReferenciaY+GruesoMadera )*y
          }
          #local C              = C+1;
        #end  // #while
        #if ( TotalPisos > 1 )
          box                   {
            <-ReferenciaX/2*0.90,ReferenciaY/2,-GruesoMadera/2>,
            <-ReferenciaX/2*0.50,ReferenciaY+4*GruesoMadera,
             +ReferenciaZ/2*0.6>
          }
        #end
      }
      texture                   {
        TexturaMaderaBase
      }
      
    }
    #local C                    = 0;
    #while ( C < TotalPisos )
      union                     {
        box                     {
          <-ReferenciaX/2,0,-GruesoMadera/2>,
          <0,5*ReferenciaY/8+GruesoMadera,+GruesoMadera/2>
        }
        box                     {
          <+3*ReferenciaX/8,ReferenciaY/2,-ReferenciaZ/2+RadioTorre>,
          <+ReferenciaX/2,ReferenciaY/2+GruesoMadera,
            +ReferenciaZ/2-RadioTorre>
        }
        texture                 {
          TexturaMaderaInterior
        }
        translate               ( ReferenciaY+GruesoMadera )*y*C
      }
      #local C                  = C+1;
    #end
    union                       {
      cylinder                  {
        ( AltoMesaSuperior-GruesoMadera )*y, AltoMesaSuperior*y,
        RadioMesaSuperior
      }
      cylinder                  {
        0, AltoMesaSuperior*y,
        RadioSillaSuperior
      }
      texture { TexturaAccesorios }
      translate ( GruesoMadera+TotalPisos*ReferenciaY
                          +TotalPisos*GruesoMadera )*y
    }
    // Baranda
    #local C                    = 1;
    #while ( C < 4 )
      union                     {
        cylinder                {
          -( ReferenciaZ/2            )*z
          -( ReferenciaX/2            )*x,
          -( ReferenciaZ/2            )*z
          +( ReferenciaX/2            )*x,
          GruesoBorde/2
        }
        cylinder                {
          +( ReferenciaZ/2            )*z
          -( ReferenciaX/2            )*x,
          +( ReferenciaZ/2            )*z
          +( ReferenciaX/2            )*x,
          GruesoBorde/2
        }
        cylinder                {
          -( ReferenciaZ/2-2*RadioTorre )*z
          -( ReferenciaX/2+GruesoMadera )*x,
          +( ReferenciaZ/2-2*RadioTorre )*z
          -( ReferenciaX/2+GruesoMadera )*x,
          GruesoBorde/2
        }
        cylinder                {
          -( ReferenciaZ/2-2*RadioTorre )*z
          +( ReferenciaX/2+GruesoMadera )*x,
          +( ReferenciaZ/2-2*RadioTorre )*z
          +( ReferenciaX/2+GruesoMadera )*x,
          GruesoBorde/2
        }
        texture                 {
          TexturaAccesorios
        }
        translate ( GruesoMadera+TotalPisos*ReferenciaY+AltoMesaSuperior
                          +TotalPisos*GruesoMadera )*y
                    -AltoMesaSuperior/4*C*y
      }
      #local C                  = C+1;
    #end
    difference                  {
      box                         {
        0,
        <+ReferenciaX/2*0.990,
          +GruesoMadera+TotalPisos*ReferenciaY
                          +TotalPisos*GruesoMadera,
         -GruesoMadera>
        rotate    AnguloDelantero1*y
        translate -ReferenciaX/2*x
                -ReferenciaZ/2*z
      }
      #local C                  = 0;
      #while ( C < TotalPisos )
        box                     {
          <-3*ReferenciaX/8,GruesoMadera+ReferenciaY*0.50,-ReferenciaZ>,
          <-1*ReferenciaX/8,GruesoMadera+ReferenciaY*0.75,+ReferenciaZ>
          translate     C*y*( GruesoMadera+ReferenciaY )
        }
        #local C                = C+1;
      #end
      texture                   {
        TexturaMaderaBase
      }
    }
    difference                  {
      box                         {
        0,
        <+ReferenciaX/2*0.990,
          +GruesoMadera+TotalPisos*ReferenciaY
                          +TotalPisos*GruesoMadera,
         -GruesoMadera>
        rotate    AnguloDelantero2*y
        translate -ReferenciaX/2*x
                -ReferenciaZ/2*z
      }
      #local C                  = 0;
      #while ( C < TotalPisos )
        box                     {
          <-3*ReferenciaX/8,GruesoMadera+ReferenciaY*0.50,-ReferenciaZ>,
          <-1*ReferenciaX/8,GruesoMadera+ReferenciaY*0.75,+ReferenciaZ>
          translate     C*y*( GruesoMadera+ReferenciaY )
        }
        #local C                = C+1;
      #end
      texture                   {
        TexturaMaderaBase
      }
      scale             <-1,1,1>
    }
    #local C                    = 0;
    #while ( C < TotalPisos )
      union                       {
        box                         {
          -ReferenciaX/2*x,
          <+ReferenciaX/2,-ReferenciaY-GruesoMadera,+GruesoMadera>
        }
        cylinder                  {
          0, +3*GruesoMadera*z,
          0.025*ReferenciaY
          translate       -ReferenciaY*0.9*y
        }
        cylinder                  {
          0, +1*GruesoMadera*z,
          0.075*ReferenciaY
          translate       -ReferenciaY*0.9*y+3*GruesoMadera*z
        }
        rotate            -ArregloAnguloPosterior[C]*x
        translate         ( ReferenciaY+GruesoMadera )*y
                            +ReferenciaZ/2*z
        texture                   {
          TexturaMaderaBase
        }
        translate       C*y*( ReferenciaY+GruesoMadera )
      }
      #local C          = C+1;
    #end
    #if ( TotalPisos > 1 )
      union             {
        #local C          = 0;
        #local DireccionEscalera   = ReferenciaY*y-ReferenciaX/2*0.4*x;
        #local LargoEscalera  = vlength(DireccionEscalera);
        cylinder          {
          0, DireccionEscalera, GruesoBorde/2
          translate GruesoMadera/2*z-ReferenciaX/2*0.50*x
                  +2*GruesoMadera*z
        }
        cylinder          {
          0, DireccionEscalera, GruesoBorde/2
          translate GruesoMadera/2*z-ReferenciaX/2*0.50*x
                  +( ReferenciaZ/2*0.60-GruesoMadera/2 )*z
                  -2*GruesoMadera*z
        }
        #local DireccionEscalera  = DireccionEscalera/LargoEscalera;
        #while ( C < LargoEscalera )
          cylinder                {
            0     , ( ReferenciaZ/2*0.60-GruesoMadera/2 )*z,
            GruesoBorde/2
            translate GruesoMadera/2*z-ReferenciaX/2*0.50*x
            translate     C*DireccionEscalera
          }
          #local C               = C+3*GruesoBorde;
        #end
        texture               {
          TexturaAccesorios
        }        
      }
    #end
  }
#end

#macro CFPS_Casita( AnguloDelantero1, AnguloDelantero2,
                    AnguloPosterior1, AnguloPosterior2 )
  object                        {
    #local L                    = CFPS_L;
    #local ReferenciaX          = 375*L;
    #local ReferenciaY          = 215*L;
    #local ReferenciaZ          = 215*L;
    #local GruesoMadera         = 5*L;
    #local RadioTorre           = 40*L;
    #local RadioTorreSuperior   = 55*L;
    #local RadioMesaSuperior    = 40*L;
    #local AltoMesaSuperior     = 50*L;
    #local GruesoBorde          = 5*L;
    #local TotalPisos           = 2;
    #local ArregloAnguloPosterior       = array [2]
                { AnguloPosterior1, AnguloPosterior2 }
    CFPS_CasaFiguraPeliculaShoujo(
      AnguloDelantero1,AnguloDelantero2,ArregloAnguloPosterior,
      ReferenciaX, ReferenciaY, ReferenciaZ,
      GruesoMadera, RadioTorre, RadioTorreSuperior,
      RadioMesaSuperior, AltoMesaSuperior, GruesoBorde, TotalPisos,
      CFPS_TexturaMaderaBase, CFPS_TexturaMaderaInterior,
      CFPS_TexturaTorre, CFPS_TexturaTorreSuperior,
      CFPS_TexturaAccesorios
    )
  }
#end


