// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 29 abril 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// CFPS CasaFiguraPeliculaShoujo
// El archivo dibuja una casita para figuras de peliculas Shoujo
// de juguete, de supuesta fabricacion artesanal.
// #macro CFPS_Casita( AnguloDelantero1, AnguloDelantero2,
//                     AnguloPosterior1, AnguloPosterior2 )
//      AnguloDelantero1        : Controla el angulo
//              de apertura a partir de cero puerta delantera izquierda.
//      AnguloDelantero2        : Controla el angulo
//              de apertura a partir de cero puerta delantera derecha.
//      AnguloPosterior1        : Controla el angulo
//              de apertura de la puerta trasera inferior.
//      AnguloPosterior2        : Controla el angulo
//              de apertura de la puerta trasera superior.
//
// La siguiente macro permite mayor flexibilidad.
// #macro CFPS_CasaFiguraPeliculaShoujo(
//    AnguloDelantero1,AnguloDelantero2,ArregloAnguloPosterior,
//    ReferenciaX, ReferenciaY, ReferenciaZ,
//    GruesoMadera, RadioTorre, RadioTorreSuperior,
//    RadioMesaSuperior, AltoMesaSuperior, GruesoBorde, TotalPisos,
//    TexturaMaderaBase, TexturaMaderaInterior,
//    TexturaTorre, TexturaTorreSuperior, TexturaAccesorios )
//      AnguloDelantero1        : Controla el angulo
//              de apertura a partir de cero puerta delantera izquierda.
//      AnguloDelantero1        : Controla el angulo
//              de apertura a partir de cero puerta delantera derecha.
//      ArregloAnguloPosterior  : Controla los angulos
//              de apertura de los compartimientos posteriores.
//              Es un arreglo real de dimension igual al total de pisos.
//      ReferenciaX             : Valor de referencia para el frente.
//              Default es 375*L.
//      ReferenciaY             : Valor de la altura por piso sin el
//              grueso de la madera.  Default es 215*L.
//      ReferenciaZ             : Profundidad de referencia
//              para la casita.  Default es 215*L.
//      GruesoMadera            : Mide el grueso de la madera.
//              Default es 5*L.
//      RadioTorre              : Radio de la torre en la zona inferior.
//              Defaut es 40*L.
//      RadioTorreSuperior      : Radio de la torre en la zona superior.
//              Default es 55*L.
//      RadioMesaSuperior       : Radio de la mesa en la terraza superior.
//              Default es 40*L.
//      AltoMesaSuperior        : Alto de la mesa de la terraza.
//              Default es 50*L.
//      GruesoBorde             : Grueso de las lineas de la baranda.
//              Default es 5*L.
//      TotalPisos              : Total de pisos de la estructura.
//              Default es 2.
//      TexturaMaderaBase       : Textura principal del objeto.
//              Default es CFPS_TexturaMaderaBase.
//      TexturaMaderaInterior   : Textura de algunas placas interiores.
//              Default es CFPS_TexturaMaderaInterior.
//      TexturaTorre            : Textura de la torre inferior.
//              Default es CFPS_TexturaTorre.
//      TexturaTorreSuperior    : Textura superior de torre.
//              Default es CFPS_TexturaTorreSuperior.
//      TexturaAccesorios       : Textura de algunos accesorios.  Se aplica
//              en la escalera, mesa y sillas.
//              Default es CFPS_TexturaAccesorios.
//
// Las dimensiones de la estrutura cerrada:
//      Alto            : 112.5*L+220*L*TotalPisos
//      Frente          : 485*L
//      Profundidad     : 245*L
// El cuerpo se encuentra parcialmente centrado sobre el plano
// XZ, frente hacia Z- y gravedad Y-.
//
// Las siguientes variables predefinidas no deberian modificarse.
// CFPS_DefaultTexturaMaderaBase
//      Textura de la madera base.
// CFPS_DefaultTexturaMaderaInterior
//      Textura de algunas zonas interiores.
// CFPS_DefaultTexturaTorre
//      Textura de la torre.
// CFPS_DefaultTexturaTorreSuperior
//      Textura de la torre superior.
// CFPS_DefaultTexturaAccesorios
//      Textura de algunos accesorios.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare CFPS_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare CFPS_TexturaMaderaBase              =
//              texture { CFPS_DefaultTexturaMaderaBase         }
//      Textura principal de la estructura.
// #declare CFPS_TexturaMaderaInterior          =
//              texture { CFPS_DefaultTexturaMaderaInterior     }
//      Textura a aplicar a la madera interior.
// #declare CFPS_TexturaTorre                   =
//              texture { CFPS_DefaultTexturaTorre              }
//      Textura a aplicar a la torre.
// #declare CFPS_TexturaTorreSuperior           =
//              texture { CFPS_DefaultTexturaTorreSuperior      }
//      Textura a aplicar en la torre superior.
// #declare CFPS_TexturaAccesorios              =
//              texture { CFPS_DefaultTexturaAccesorios         }
//      Textura a aplicar a los accesorios.
//
// Algunos ejemplos de uso....
// #include "CFPS.inc"
// object        { CFPS_Casita(0,0,0,0) }
//
// Otro ejemplo con modificador
// #include "CFPS.inc"
// #declare CFPS_TexturaMaderaBase        =
//      texture { CFPS_DefaultTexturaMaderaBase }
//      texture { pigment {rgbt 0.5 } }
// object        { CFPS_Casita(0,0,0,0) }
//
// Otro ejemplo con macro de texturas
// #include "CFPS.inc"
// #declare ArregloAngulos      = array [2] {0,0}
// object        { CFPS_CasaFiguraPeliculaShoujo( 0, 0, ArregloAngulos,
//             0.375, 0.215, 0.215, 0.005, 0.040,
//             0.055, 0.040, 0.050, 0.005, 2,
//             CFPS_TexturaMaderaBase, CFPS_TexturaMaderaInterior,
//             CFPS_TexturaTorre, CFPS_TexturaTorreSuperior,
//             CFPS_TexturaAccesorios ) }

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
light_source    {
         <-500  , 500   , -3000 >*L
         White
}
light_source    {
         < 500  ,-500   , -3000 >*L
         White
}
light_source    {
         <-500  ,-500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "CFPS.inc"

#local FactorAcercamiento       = 2.0;

object                  {
  CFPS_Casita(90,90,90,90)
  translate     -0.25*y
  translate       -( VecesCentroAbsoluto+1 )*
         ( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
}


