// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 25 noviembre 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//                      
// EBPH EscobaBarrerPisoHogar
// El archivo dibuja una escoba corriente, de uso en la actualidad.
// Incluye una macro para variar caracteristicas fundamentales.
//      
// La siguiente macro dibuja el objeto default:
// #macro EBPH_Escoba()
//   
// Las dimensiones del objetos default son : 
//      Alto Y                  : -80*L..875*L   
//      Frente X                : -125*L..125*L (variable)
//      Frente X (sin pelos)    : -80*L..80*L
//      Profundidad Z           : -50*L..50*L (variable)
//      Profundidad Z (sin pelos)       : -20*L..20*L   
// Los pelos comienzan en el plano XY, luego se proyectan hacia Y-.
//
// La siguiente macro permite mucho mayor control de las caractersticas:
// #macro EBPH_EscobaBarrerPisoHogar(
//    DiametroPalo, LargoPalo, DiametroAgarre, AltoAgarre,
//    BaseReferencia, BaseAncho, BaseGrueso,
//    TotalHileras, GruposPorHilera,
//    AltoPelos, DiametroPelos, DensidadPelos
//    AnguloPelos, OscilacionAngular,
//    TexturaMadera, TexturaPlastica, TexturaPelos )
//      DiametroPalo            : Diametro del palo de madera.  Default es 16*L.
//      LargoPalo               : Largo referencia del palo.  Default es 858*L.
//      DiametroAgarre          : Diametro del cilindro de union del palo. 
//              Default es 21.4*L.
//      AltoAgarre              : Alto del cilindro de agarre.  Default es 20*L.
//      BaseReferencia          : Referencia para la base soporte de pelos.
//              Default es 143*L.
//      BaseAncho               : Referencia para el ancho del soporte de pelos.
//              Default es 25*L.
//      BaseGrueso              : Grueso Y del soporte de pelos.  Default es 10.7*L.
//      TotalHileras            : Total de hileras de pelos en el soporte.  Default es 7.
//      GruposPorHilera         : Total de grupillos de pelos por hilera.  Default es 19.
//      AltoPelos               : Referencia para el largo de los pelos. Default es 82*L.
//      DiametroPelos           : Diametro de los pelos.  Default es 1*L.
//      DensidadPelos           : Parametro para controlar la densidad de los pelos por grupo.
//              Default es 5.
//      AnguloPelos             : Angulo en grados de inclinacion de pelos en el borde.  
//              Default es 15.   
//      OscilacionAngular       : Introduce incertidumbre en el angulo de los pelos.
//              Default es 5.
//      TexturaMadera           : Textura a aplicar al palo.  Default es EBPH_TexturaMadera.
//      TexturaPlastica         : Textura del soporte.  Default es EBPH_TexturaPlastica.
//      TexturaPelos            : Textura de los pelos.  Default es EBPH_TexturaPelos.    
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse.
// #declare EBPH_DefaultTexturaMadera         
//      Textura de la madera.
// #declare EBPH_DefaultTexturaPlastica       
//      Textura del plastico.
// #declare EBPH_DefaultTexturaPelos         
//      Textura de los pelos.  
//   
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare EBPH_Semilla                                = 2356;
//      Para modificar el generador aleatorio para la escoba.
// #declare EBPH_TexturaMadera                          = texture { ... }     
//      Textura de la madera.
// #declare EBPH_TexturaPlastica                        = texture { ... }       
//      Textura del plastico.
// #declare EBPH_TexturaPelos                           = texture { ... }         
//      Textura para los pelos.           
// #declare EBPH_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
//
// Para colocarlo simplemente
//
// #include "EBPH.inc"
// object                  {
//   EBPH_Escoba( ) 
// }
//
// o bien la misma figura anterior con macro detallada 
// #include "EBPH.inc"
// object                  {   
//   EBPH_EscobaBarrerPisoHogar( 0.016, 0.858, 0.0214, 0.020, 0.143, 0.025,
//              0.0107, 7, 19, 0.082, 0.001, 5, 15, 5,  
//              EBPH_TexturaMadera, EBPH_TexturaPlastica, EBPH_TexturaPelos )
// }
//   
// o bien los modificadores
// #include "EBPH.inc"
// #declare EBPH_TexturaMadera = texture { pigment { Blue } } 
// object               { 
//   EBPH_Escoba( )
// } 
//
#include "woods.inc" 
#include "stones.inc"

#if ( version < 3.2 )
  #ifndef( EBPH_POV3_1 )
    #declare EBPH_POV3_1        = on;
  #end
#else
  #ifndef( EBPH_POV3_1 )
    #declare EBPH_POV3_1        = off;
  #end
#end

#ifndef ( EBPH_Semilla )
  #declare EBPH_Semilla         = 2356;
#end

#declare EBPH_L                 = 0.001;

#declare EBPH_DefaultTexturaMadera              =
  texture       { T_Stone41 }
  texture       { 
    pigment { radial
      frequency         20 
      turbulence        0.25 
     // scale             0.01
      pigment_map  {      
        [ 0.1 color Brown transmit 0.8 ]
        [ 0.1 color Clear ]
      }
    }
  }

#declare EBPH_DefaultTexturaPlastica            =
  texture       { T_Wood7 }
  texture       { pigment { color White transmit 0.5 } }

#declare EBPH_DefaultTexturaPelos               =
  texture       { pigment { checker pigment { ForestGreen } pigment { DarkGreen } } }

#ifndef ( EBPH_TexturaMadera )
  #declare EBPH_TexturaMadera   =
    texture     { EBPH_DefaultTexturaMadera }
#end  // #ifndef ( EBPH_TexturaMadera )

#ifndef ( EBPH_TexturaPlastica )
  #declare EBPH_TexturaPlastica =
    texture     { EBPH_DefaultTexturaPlastica }
#end  // #ifndef ( EBPH_TexturaPlastica )

#ifndef ( EBPH_TexturaPelos )
  #declare EBPH_TexturaPelos    =
    texture     { EBPH_DefaultTexturaPelos }
#end  // #ifndef ( EBPH_TexturaPelos )

#macro EBPH_EscobaBarrerPisoHogar(
    DiametroPalo, LargoPalo, DiametroAgarre, AltoAgarre,
    BaseReferencia, BaseAncho, BaseGrueso,
    TotalHileras, GruposPorHilera,
    AltoPelos, DiametroPelos, DensidadPelos
    AnguloPelos, OscilacionAngular,
    TexturaMadera, TexturaPlastica, TexturaPelos )
  union                         {
    // Palo de escoba
    #local S                    = seed( EBPH_Semilla );
    union                       {
      cylinder                  {
        0, LargoPalo*y, DiametroPalo/2
      }
      sphere                    {
        0, DiametroPalo/2
        scale                   <1,0.5,1>
        translate               LargoPalo*y
      }
      texture                   {
        TexturaMadera
      }
      translate                 BaseGrueso*y
    }
    // BaseEscoba
    union                       {
      cylinder                  {
        0, AltoAgarre*y, DiametroAgarre/2
        translate               BaseGrueso*y
      }
      box                       {
        <-BaseReferencia/2,0,-BaseAncho/2>,
        <+BaseReferencia/2,BaseGrueso,BaseAncho/2>
      }
      torus                     {
        BaseAncho/2, BaseGrueso/2
        translate               BaseReferencia/2*x
        translate               BaseGrueso/2*y
      }
      cylinder                  {
        0, BaseGrueso*y, BaseAncho/2
        translate               BaseReferencia/2*x
      }
      torus                     {
        BaseAncho/2, BaseGrueso/2
        translate               -BaseReferencia/2*x
        translate               BaseGrueso/2*y
      }
      cylinder                  {
        0, BaseGrueso*y, BaseAncho/2
        translate               -BaseReferencia/2*x
      }
      cylinder                  {
        -BaseReferencia/2*x, BaseReferencia/2*x, BaseGrueso/2
        translate               BaseAncho/2*z
        translate               BaseGrueso/2*y
      }
      cylinder                  {
        -BaseReferencia/2*x, BaseReferencia/2*x, BaseGrueso/2
        translate               -BaseAncho/2*z
        translate               BaseGrueso/2*y
      }
      texture                   {
        TexturaPlastica
      }
    }
    // Pelos Escoba
    // figura base
    #local Pelos1               = union         {
      #local Largo              = AltoPelos;
      #local Sita               = 0;
      #local Ro                 = pi/20;
      #local DeltaRo            = Ro;
      #local DeltaSita          = pi/DensidadPelos;
      #while ( Ro > 0 )
        #local Sita             = DeltaSita*rand( S );
        #while ( Sita < 2*pi )
          #local LargoActual    = Largo*( 0.9+0.2*rand( S ) );
          cylinder          {
            +BaseGrueso/2*y, -LargoActual*
            < sin( Ro )*cos( Sita ), 1, sin( Ro )*sin( Sita ) >, DiametroPelos
          }
          #local Sita           = Sita+DeltaSita;
        #end
        #local Ro               = Ro-DeltaRo;
      #end
    }
    // Figura de Pelos Escoba
    union                       {
      #local D                  = 0;
      #while ( D < TotalHileras )
        #if ( mod( D, 2 ) = 0 )
          #local MaxC             = GruposPorHilera+1;
        #else
          #local MaxC             = GruposPorHilera;
        #end
        #local CUnitario        = abs( 2*( D-TotalHileras/2 )/TotalHileras );
        #local BaseLargo        = BaseReferencia+
                sqrt( 1-CUnitario*CUnitario )*BaseAncho;
        #local C                = 0;
        #while ( C < MaxC )
          object                     {
            Pelos1
            texture           {
              TexturaPelos
              translate       ( -0.85-0.1*rand(S) )*AltoPelos*y+
                                0.1*AltoPelos*x+0.1*AltoPelos*z
            }
            #local BaseD        = 2*( D-TotalHileras/2 )/TotalHileras;
            #local BaseC        = 2*( C-MaxC/2 )/MaxC;
            rotate              -BaseD*AnguloPelos*x
            rotate              +BaseC*AnguloPelos*z
            rotate      OscilacionAngular*
                           ( 2*< rand( S ), rand(S ), rand( S ) >-1 )
            translate           BaseAncho*BaseD*z/2
            translate           BaseLargo*BaseC*x/2
          }
          #local C              = C+1;
        #end
        #local D                = D+1;
      #end
    }
  }
#end  // #macro EBPH_EscobaBarrerPisoHogar

#macro EBPH_Escoba()
  object                        {
    #local L                    = EBPH_L;
    #local DiametroPalo         = 16*L;
    #local LargoPalo            = 858*L;
    #local DiametroAgarre       = 21.4*L;
    #local AltoAgarre           = 20*L;
    #local BaseReferencia       = 143*L;
    #local BaseAncho            = 25*L;
    #local BaseGrueso           = 10.7*L;
    #local TotalHileras         = 7;
    #local GruposPorHilera      = 19;
    #local AltoPelos            = 82*L;
    #local DiametroPelos        = L;
    #local DensidadPelos        = 5;
    #local AnguloPelos          = 15;
    #local OscilacionAngular    = 5;
    object                      {
      EBPH_EscobaBarrerPisoHogar(
        DiametroPalo, LargoPalo, DiametroAgarre, AltoAgarre,
        BaseReferencia, BaseAncho, BaseGrueso,
        TotalHileras, GruposPorHilera,
        AltoPelos, DiametroPelos, DensidadPelos,
        AnguloPelos, OscilacionAngular,
        EBPH_TexturaMadera, EBPH_TexturaPlastica, EBPH_TexturaPelos
      )
    }
  }
#end  // #macro EBPH_Escoba


