// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 25 noviembre 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//                      
// EBPH EscobaBarrerPisoHogar
// El archivo dibuja una escoba corriente, de uso en la actualidad.
// Incluye una macro para variar caracteristicas fundamentales.
//      
// La siguiente macro dibuja el objeto default:
// #macro EBPH_Escoba()
//   
// Las dimensiones del objetos default son : 
//      Alto Y                  : -80*L..875*L   
//      Frente X                : -125*L..125*L (variable)
//      Frente X (sin pelos)    : -80*L..80*L
//      Profundidad Z           : -50*L..50*L (variable)
//      Profundidad Z (sin pelos)       : -20*L..20*L   
// Los pelos comienzan en el plano XY, luego se proyectan hacia Y-.
//
// La siguiente macro permite mucho mayor control de las caractersticas:
// #macro EBPH_EscobaBarrerPisoHogar(
//    DiametroPalo, LargoPalo, DiametroAgarre, AltoAgarre,
//    BaseReferencia, BaseAncho, BaseGrueso,
//    TotalHileras, GruposPorHilera,
//    AltoPelos, DiametroPelos, DensidadPelos
//    AnguloPelos, OscilacionAngular,
//    TexturaMadera, TexturaPlastica, TexturaPelos )
//      DiametroPalo            : Diametro del palo de madera.  Default es 16*L.
//      LargoPalo               : Largo referencia del palo.  Default es 858*L.
//      DiametroAgarre          : Diametro del cilindro de union del palo. 
//              Default es 21.4*L.
//      AltoAgarre              : Alto del cilindro de agarre.  Default es 20*L.
//      BaseReferencia          : Referencia para la base soporte de pelos.
//              Default es 143*L.
//      BaseAncho               : Referencia para el ancho del soporte de pelos.
//              Default es 25*L.
//      BaseGrueso              : Grueso Y del soporte de pelos.  Default es 10.7*L.
//      TotalHileras            : Total de hileras de pelos en el soporte.  Default es 7.
//      GruposPorHilera         : Total de grupillos de pelos por hilera.  Default es 19.
//      AltoPelos               : Referencia para el largo de los pelos. Default es 82*L.
//      DiametroPelos           : Diametro de los pelos.  Default es 1*L.
//      DensidadPelos           : Parametro para controlar la densidad de los pelos por grupo.
//              Default es 5.
//      AnguloPelos             : Angulo en grados de inclinacion de pelos en el borde.  
//              Default es 15.   
//      OscilacionAngular       : Introduce incertidumbre en el angulo de los pelos.
//              Default es 5.
//      TexturaMadera           : Textura a aplicar al palo.  Default es EBPH_TexturaMadera.
//      TexturaPlastica         : Textura del soporte.  Default es EBPH_TexturaPlastica.
//      TexturaPelos            : Textura de los pelos.  Default es EBPH_TexturaPelos.    
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse.
// #declare EBPH_DefaultTexturaMadera         
//      Textura de la madera.
// #declare EBPH_DefaultTexturaPlastica       
//      Textura del plastico.
// #declare EBPH_DefaultTexturaPelos         
//      Textura de los pelos.  
//   
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare EBPH_Semilla                                = 2356;
//      Para modificar el generador aleatorio para la escoba.
// #declare EBPH_TexturaMadera                          = texture { ... }     
//      Textura de la madera.
// #declare EBPH_TexturaPlastica                        = texture { ... }       
//      Textura del plastico.
// #declare EBPH_TexturaPelos                           = texture { ... }         
//      Textura para los pelos.           
// #declare EBPH_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
//
// Para colocarlo simplemente
//
// #include "EBPH.inc"
// object                  {
//   EBPH_Escoba( ) 
// }
//
// o bien la misma figura anterior con macro detallada 
// #include "EBPH.inc"
// object                  {   
//   EBPH_EscobaBarrerPisoHogar( 0.016, 0.858, 0.0214, 0.020, 0.143, 0.025,
//              0.0107, 7, 19, 0.082, 0.001, 5, 15, 5,  
//              EBPH_TexturaMadera, EBPH_TexturaPlastica, EBPH_TexturaPelos )
// }
//   
// o bien los modificadores
// #include "EBPH.inc"
// #declare EBPH_TexturaMadera = texture { pigment { Blue } } 
// object               { 
//   EBPH_Escoba( )
// } 
//
#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}           


#include "EBPH.inc"
#local FactorAcercamiento               = 1.5;


object                  {
  EBPH_Escoba()         
  translate             -0.4*y
  rotate                90*z 
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z         
}





