// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 14 octubre 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//                      
// EFAH ExtinguidorFuegoAccidentalHogar
// El archivo dibuja un extinguidor de incendios para hogar y automovil.
// Puede dibujarse con o sin soporte, e incluye una macro
// para variar caracteristicas fundamentales.
//      
// La siguiente macro dibuja el objeto default:
// #macro EFAH_ExtinguidorYSoporte
//      ( RotacionExtinguidor, FactorCierre, RotateAleatorio )
//              RotacionExtinguidor     : Rota el extinguidor en Y, con soporte fijo.
//              FactorCierre            : Entre 0.0.y 1.0 para simular
//                      apretar el disparador.  0.0 es cerrado.  
//                      Cualquier valor difernte de 0.0, produce
//                      que no se dibuje el seguro metalico. 
//              RotateAleatorio         : El gatillo suele ser algo flojo.
//                      Este factor aplica un rotate RotateAleatorio,
//                      al eje del disparador. 
//   
// Las dimensiones del objetos default (todo parametro cero) son :
//      Alto                    : 211*L  
//      Alto soporte            : 170*L  
//      Profundidad Z           : 65*L
//      Frente X                : -37*L..53*L  
//      Elevacion por soporte   : 3.65*L
// Todos los objetos anteriores descansan sobre el plano XZ, 
// casi centrados en el origen.  Frente X-, gravedad Y-.  
//
// El extinguidor puede dibujarse sin soporte con la siguiente macro.
// NOTA: Aplique translate 3.65*L*y para posicion default.
// #macro EFAH_Extinguidor( FactorCierre, RotateAleatorio )
//              FactorCierre            : Entre 0.0.y 1.0 para simular
//                      apretar el disparador.  0.0 es cerrado.  
//                      Cualquier valor difernte de 0.0, produce
//                      que no se dibuje el seguro metalico. 
//              RotateAleatorio         : El gatillo suele ser algo flojo.
//                      Este factor aplica un rotate RotateAleatorio,
//                      al eje del disparador. 
//
// Puede dibujarse solo el soporte con la macro sin parametros:
// #macro EFAH_Soporte() 
//
// El extinguidor puede modificarse con mayor flexibilidad, con la siguiente
// macro.
// NOTA: considere aplicar translate ( GruesoSoporte+GruesoCubiertaSoporte )/2*y
//       para ubicar en el soporte.
// #macro EFAH_ExtinguidorFuegoAccidentalHogar
//   ( FactorCierre, RotateAleatorio, DiametroFundamental, AlturaCilindro,
//     RadioDecorativoInferior, RadioSuperior,
//     AlturaCilindroSuperior, AlturaExtraSuperior,
//     ReferenciaPalanca, ProfundidadPalanca, BasePalanca,
//     TexturaCilindro, TexturaEtiqueta, TexturaPlastico, TexturaMetal, TexturaMetal2,
//     TexturaDisco, TexturaTransparente )
//              FactorCierre            : Entre 0.0.y 1.0 para simular
//                      apretar el disparador.  0.0 es cerrado.  
//                      Cualquier valor difernte de 0.0, produce
//                      que no se dibuje el seguro metalico. 
//              RotateAleatorio         : El gatillo suele ser algo flojo.
//                      Este factor aplica un rotate RotateAleatorio,
//                      al eje del disparador. 
//              DiametroFundamental     : Referencia para el diametro del cilindro
//                      principal.  Default es 64*L.
//              AlturaCilindro          : Referencia para la altura del cilindro
//                      principal.  Default es 143*L.
//              RadioDecorativoInferior : Referencia para la curvatura inferior
//                      del extinguidor.  Default es 1.75*L.
//              RadioSuperior           : Referencia para el radio de union
//                      con la boquilla.  Default es 10.5*L.
//              AlturaCilindroSuperior  : Referencia para la curvatura superior
//                      del extinguidor.  Default es 23.5*L.
//              AlturaExtraSuperior     : Referencia para la altura de la union
//                      con la boquilla.  Default es 9.2*L.
//              ReferenciaPalanca       : Referencia para la palanca liberadora
//                      de presion.  Default es 64.3*L.
//              ProfundidadPalanca      : Profundidad Z de la palanca liberadora
//                      de presion.  Default es 13*L.
//              BasePalanca             : Altura del soporte de palanca.  
//                      Default es 10.7*L.  
//              TexturaCilindro         : Textura principal.  
//                      Default es EFAH_TexturaCilindro.
//              TexturaEtiqueta         : Textura de las etiquetas del cilindro.
//                      Se aplican como un bitmap map_type 2.  Utilice un
//                      fondo compatible con TexturaCilindro.
//                      Default es EFAH_TexturaEtiqueta. 
//              TexturaPlastico         : Textura de la union plastica con
//                      la boquilla.  Default es EFAH_TexturaPlastico.
//              TexturaMetal            : Textura a aplicar a la base metalica
//                      de boquilla.  Default es EFAH_TexturaMetal.
//              TexturaMetal2           : Textura a aplicar al seguro
//                      y otros elementos.  Default es EFAH_TexturaMetal2.
//              TexturaDisco            : Textura del disco medidor de presion.
//                      Default es EFAH_TexturaDisco.
//              TexturaTransparente     : Textura del plastico transparente
//                      del medidor de presion.  Default es EFAH_TexturaTransparente.
//  
// La siguiente macro controla con mayor detalle el soporte.
// Muchos parametros se suponen son identicos a la macro anterior,
// para ajustar la figura.
// #macro EFAH_SoporteDetalle
//   ( DiametroFundamental, AlturaCilindro, RadioDecorativoInferior,
//     RadioSuperior, AlturaCilindroSuperior, AlturaExtraSuperior,
//     GruesoSoporte, GruesoCubiertaSoporte,
//     TexturaSoporteCilindro, TexturaSoporteCilindroCuero )
//              DiametroFundamental     : Referencia para el diametro del cilindro
//                      principal.  Default es 64*L.
//              AlturaCilindro          : Referencia para la altura del cilindro
//                      principal.  Default es 143*L.
//              RadioDecorativoInferior : Referencia para la curvatura inferior
//                      del extinguidor.  Default es 1.75*L.
//              RadioSuperior           : Referencia para el radio de union
//                      con la boquilla.  Default es 10.5*L.
//              AlturaCilindroSuperior  : Referencia para la curvatura superior
//                      del extinguidor.  Default es 23.5*L.
//              AlturaExtraSuperior     : Referencia para la altura de la union
//                      con la boquilla.  Default es 9.2*L.
//              GruesoSoporte           : Se refiere al grueso de las varillas.
//                      Default es 3*L.
//              GruesoCubiertaSoporte   : Se refiere al grueso de varillas,
//                      recubiertas por cuero.  Default es 4.3*L.  
//              TexturaSoporteCilindro  : Textura basica del soporte.
//                      Default es EFAH_TexturaSoporteCilindro.
//              TexturaSoporteCilindroCuero     : Textura para el cuero de contacto
//                      superior del soporte.
//                      Default es EFAH_TexturaSoporteCilindroCuero. 
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse.
// #declare EFAH_DefaultTexturaCilindro         
//      Textura principal.
// #declare EFAH_DefaultTexturaEtiqueta       
//      Textura de las etiquetas del cilindro.
// #declare EFAH_DefaultTexturaPlastico         
//      Textura de la union plastica con la boquilla.  
// #declare EFAH_DefaultTexturaMetal            
//      Textura a aplicar a la base metalica de boquilla.  
// #declare EFAH_DefaultTexturaMetal2            
//      Textura a aplicar al seguro, y otros elementos.  
// #declare EFAH_DefaultTexturaDisco            
//      Textura del disco medidor de presion.
// #declare EFAH_DefaultTexturaTransparente     
//      Textura del plastico transparente del medidor de presion.  
// #declare EFAH_DefaultTexturaSoporteCilindro  
//      Textura basica del soporte.
// #declare EFAH_DefaultTexturaSoporteCilindroCuero     
//      Textura para el cuero de contacto superior del soporte.
//   
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare EFAH_TexturaCilindro                        = texture { ... }     
//      Textura principal.
// #declare EFAH_TexturaEtiqueta                        = texture { ... }       
//      Textura de las etiquetas del cilindro.
// #declare EFAH_TexturaPlastico                        = texture { ... }         
//      Textura de la union plastica con la boquilla.  
// #declare EFAH_TexturaMetal                           = texture { ... }           
//      Textura a aplicar a la base metalica de boquilla.  
// #declare EFAH_TexturaMetal2                          = texture { ... }        
//      Textura a aplicar al seguro y otros elementos.  
// #declare EFAH_TexturaDisco                           = texture { ... }      
//      Textura del disco medidor de presion.
// #declare EFAH_TexturaTransparente                    = texture { ... }     
//      Textura del plastico transparente del medidor de presion.  
// #declare EFAH_TexturaSoporteCilindro                 = texture { ... }
//      Textura basica del soporte.
// #declare EFAH_TexturaSoporteCilindroCuero            = texture { ... }   
//      Textura para el cuero de contacto superior del soporte.
// #declare EFAH_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
//
// Para colocarlo simplemente
//
// #include "EFAH.inc"
//  object                  {
//    EFAH_ExtinguidorYSoporte( 0, 0, 0 ) 
//  }
//
//  o bien solo el extinguidor... 
//  #include "EFAH.inc"
//  object                  {   
//    EFAH_Extinguidor( 0, 0 )  
//  }
//
//  o bien la misma figura anterior con macro detallada 
//  #include "EFAH.inc"
//  object                  {
//    EFAH_ExtinguidorFuegoAccidentalHogar
//      ( 0, 0, 0.064, 0.143, 0.00175, 0.0235, 
//              0.0105, 0.0092, 0.0643, 0.013, 0.0107,
//          EFAH_TexturaCilindro, EFAH_TexturaEtiqueta, EFAH_TexturaPlastico,
//          EFAH_TexturaMetal, EFAH_TexturaMetal2,
//          EFAH_TexturaDisco, EFAH_TexturaTransparente )
//  }
//

#include "colors.inc"
#include "metals.inc"
#include "EFAH_AU1.inc"

#if ( version < 3.2 )
  #ifndef( EFAH_POV3_1 )
    #declare EFAH_POV3_1        = on;
  #end
#else
  #ifndef( EFAH_POV3_1 )
    #declare EFAH_POV3_1        = off;
  #end
#end



#declare EFAH_L                         = 0.001;

#declare EFAH_DefaultTexturaCilindro    =
  texture                               {
    pigment                             {
      Red
    }     
    normal                              {   
      bumps                                 
      turbulence                        2
    }
    finish                              {   
      phong                             5
      phong_size                        30
      metallic
    }
  }

#declare EFAH_TexturaCilindro           =
  texture                               {
    EFAH_DefaultTexturaCilindro
  } 
  
#declare EFAH_DefaultTexturaEtiqueta    =
  texture                               { 
    pigment                             { 
      image_map                         {  
        gif  "EFAH_ETI.GIF"  
        once
        map_type 2
      }
    }
    normal                              {   
      bumps                                 
      turbulence                        2
    }
    finish                              {   
      phong                             5
      phong_size                        30
      metallic
    }
  } 

#declare EFAH_TexturaEtiqueta           =
  texture                               {
    EFAH_DefaultTexturaEtiqueta
  } 
  
  
#declare EFAH_DefaultTexturaPlastico    =
  texture                               {
    pigment                             {
      White
    }
  }

#declare EFAH_TexturaPlastico           =
  texture                               {
    EFAH_DefaultTexturaPlastico
  }

#declare EFAH_DefaultTexturaMetal    =
  texture                               {
    T_Copper_2A
  }

#declare EFAH_TexturaMetal           =
  texture                               {
    EFAH_DefaultTexturaMetal
  }

#declare EFAH_DefaultTexturaMetal2    =
  texture                               {
    T_Silver_2A
  }

#declare EFAH_TexturaMetal2           =
  texture                               {
    EFAH_DefaultTexturaMetal2
  }

#declare EFAH_DefaultTexturaDisco    =
  texture                               {  
    pigment                             {
      image_map                         {  
        gif  "EFAH_BAR.GIF" 
      }   
      translate               -0.5*x-0.5*y
      scale                   2
    }
  }

#declare EFAH_TexturaDisco           =
  texture                               {
    EFAH_DefaultTexturaDisco
  }

#declare EFAH_TexturaTra1            =
  texture                               { 
    pigment                             {
      onion
      scale               0.050  
      pigment_map                         {    
        [0.0 White ]
        [1.0 White transmit 1.0 ]
      }
    }
  }
  
#declare EFAH_TexturaTra2           =   
  texture                               { 
    pigment { color White transmit 0.8 }
    normal  { bumps scale 0.1 }
  }  

#declare EFAH_DefaultTexturaTransparente    =
  texture                               { 
    onion
    texture_map                         { 
      [ 0.0 EFAH_TexturaTra1 ]
      [ 0.5 EFAH_TexturaTra1 ]
      [ 0.5 EFAH_TexturaTra2 ]
      [ 1.0 EFAH_TexturaTra2 ]
    }
  }

#declare EFAH_TexturaTransparente           =
  texture                               {
    EFAH_DefaultTexturaTransparente
  }

#declare EFAH_DefaultTexturaSoporteCilindro    =
  texture                               {
    pigment                             {
      Gray15
    }         
    normal                              {
      bumps             2
    }
    finish                              { 
      phong             1
      phong_size        1
      metallic
    }
  }

#declare EFAH_TexturaSoporteCilindro           =
  texture                               {
    EFAH_DefaultTexturaSoporteCilindro
  }
  
#declare EFAH_DefaultTexturaSoporteCilindroCuero    =
  texture                               {
    pigment                             {
      Red*0.8
    }     
    normal                              {   
      bumps
    }
    finish                              {   
      phong                             10
      phong_size                        30
      metallic
    }
  } 

#declare EFAH_TexturaSoporteCilindroCuero           =
  texture                               {
    EFAH_DefaultTexturaSoporteCilindroCuero
  }

#macro EFAH_AcercarPunto
    ( PuntoAcercado, PuntoOrigen, PuntoDestino, DistanciaActual )
  #local Rayo                           = PuntoDestino-PuntoOrigen;
  #local Rayo                           = Rayo/vlength( Rayo );
  #local PuntoAcercado                  =
                PuntoOrigen+DistanciaActual*Rayo;
#end

#macro EFAH_ExtinguidorFuegoAccidentalHogar
  ( FactorCierre, RotateAleatorio, DiametroFundamental, AlturaCilindro,
    RadioDecorativoInferior, RadioSuperior,
    AlturaCilindroSuperior, AlturaExtraSuperior,
    ReferenciaPalanca, ProfundidadPalanca, BasePalanca,
    TexturaCilindro, TexturaEtiqueta, TexturaPlastico, TexturaMetal, TexturaMetal2,
    TexturaDisco, TexturaTransparente )
  union                                 {
    union                               {
      cylinder                          {
        0, AlturaCilindro*y, DiametroFundamental/2 
        texture                         {   
          TexturaCilindro
        } 
        texture                         {   
          TexturaEtiqueta  
          scale                 0.85*AlturaCilindro*y     
          translate             0.15*AlturaCilindro*y
        }
      }
      sphere                            {
        0, 1
        scale   < DiametroFundamental/2,
                  AlturaCilindroSuperior-AlturaExtraSuperior,
                  DiametroFundamental/2>
        translate                       AlturaCilindro*y
      }
      cone                              {
        0, RadioSuperior*1.5,
        AlturaCilindroSuperior*y, RadioSuperior
        translate                       AlturaCilindro*y
      }
      union                             {
        cone                            {
          0, RadioSuperior*1.5*1.05,
          AlturaCilindroSuperior*y*0.975, RadioSuperior*1.05
        }
        cone                            {
          0, RadioSuperior*2.0*1.05,
          AlturaCilindroSuperior*y*0.975, RadioSuperior*0.75
        }
        translate                       AlturaCilindro*y
        texture                         {
          TexturaPlastico
        }
      }
      torus                             {
        DiametroFundamental/2, RadioDecorativoInferior
        scale                           <1,2,1>
      }
      cylinder                          {
        0, AlturaCilindro/20*y,
        ( DiametroFundamental/2+RadioDecorativoInferior )
      }
      torus                             {
        DiametroFundamental/2, RadioDecorativoInferior
        translate                       AlturaCilindro/20*y
      }
      torus                             {
        DiametroFundamental/2, RadioDecorativoInferior
        translate                       AlturaCilindro/10*y
      }
      cylinder                          {
        0, 1.5*AlturaCilindro/20*y,
        ( DiametroFundamental/2+RadioDecorativoInferior )
        translate                       AlturaCilindro/10*y
      }
      translate                         2*RadioDecorativoInferior*y
      texture                           {
        TexturaCilindro
      }
    }
    // Palanca
    union                               {
      #local ReferenciaI                = ReferenciaPalanca/20;
      #local PrismaSuperior             =
        prism                           {
          -0.5, 0.5,
          9,
          <5,0.8>,
          <5,3.6>,
          <-4.8,8>,
          <-8.8,8.8>,
          <-12.8,8.4>,
          <-12.8,8>,
          <-10,8>,
          <-6.4,6.8>,
          <5,0.8>
          rotate                        -90*x
          rotate                        180*y
          scale           < ReferenciaI, ReferenciaI, ProfundidadPalanca >
        }

      #local PrismaInferior             =
        prism                           {
          -0.5, 0.5,
          10,
          <5,0.8>,
          <2,3.6>,
          <-8,1.2>,
          <-12,0>,
          <-14.4,-2>,
          <-14.4,-3>,
          <-13.8,-3>,
          <-12.6,-2>,
          <-6.4,-0.8>,
          <5,0.8>
          rotate                        -90*x
          rotate                        180*y
          scale       < ReferenciaI, ReferenciaI, 0.90*ProfundidadPalanca >
        }
        
      difference                          {
        object                            {
          PrismaSuperior
        }
        object                           {
          PrismaSuperior
          scale                 <1.05,0.95,0.95>
          
        }
        box                     {
          <-4.5,0.0,-0.5>,
          <-4.75,3.4,0.5>
          scale    < ReferenciaI, ReferenciaI, 2*ProfundidadPalanca >
        }
        translate               -( -0.175*x+0.10*y )*ReferenciaPalanca
        rotate                   -FactorCierre*25*z
        translate               ( -0.175*x+0.10*y )*ReferenciaPalanca
      }
      difference                        {
        object                            {
          PrismaInferior
        }
        object                          {
          PrismaInferior
          scale         <1.05,0.95,0.95>
        }
      }
      cylinder                          {
        -0.6*ProfundidadPalanca*z, 0.6*ProfundidadPalanca*z,
        0.025*ReferenciaPalanca
        translate               ( -0.175*x+0.10*y )*ReferenciaPalanca
        texture                         {
          TexturaMetal
        }
      }
      #if ( FactorCierre = 0 )
        union                           {
          cylinder                          {
            -0.8*ProfundidadPalanca*z, 0.8*ProfundidadPalanca*z,
            0.025*ReferenciaPalanca
          }
          torus                         {
            2*ProfundidadPalanca/3, 0.025*ReferenciaPalanca
            rotate              40*z
            translate                   +2*ProfundidadPalanca/3*z
            translate                   +0.8*ProfundidadPalanca*z
          }
          translate               ( -0.100*x+0.15*y )*ReferenciaPalanca
          texture                         {
            TexturaMetal2
          }
        }
      #end
      translate               -( -0.175*x+0.10*y )*ReferenciaPalanca
      rotate                  RotateAleatorio
      translate               ( -0.175*x+0.10*y )*ReferenciaPalanca
      translate  ( AlturaCilindro+AlturaCilindroSuperior
                   +2*RadioDecorativoInferior+BasePalanca )*y
      translate                         ( 0.1*x-0.03*y )*ReferenciaPalanca
      texture                           {
        TexturaCilindro
      }
    }
    // BaseMetalicaPalanca
    union                               {
      cylinder                          {
        0, BasePalanca/15*y, RadioSuperior
      }
      cylinder                          {
        0, 2*BasePalanca/15*y, 2*RadioSuperior/3
      }
      cylinder                          {
        0, BasePalanca*y, RadioSuperior/2
      }
      cylinder                          {
        0, -RadioSuperior*x, 6*BasePalanca/15
        translate               9*BasePalanca/15*y
      }
      cylinder                          {
        0, -5/4*RadioSuperior*z, BasePalanca/2
        translate               BasePalanca/2*y        
      }
      prism                             {
        0, -1/4*BasePalanca,
        7,
        #local D                = 0;
        #while ( D < 7 )
          <cos(D*pi/3),sin(D*pi/3)>*BasePalanca/2
          #local D              = D+1;
        #end
        rotate                  90*x
        translate               -5/4*RadioSuperior*z+BasePalanca/2*y
      }

      union                     {
        cone                    {
          0, BasePalanca/2, -RadioSuperior/8*z, BasePalanca
        }
        difference              {
          torus                 {
            BasePalanca, RadioSuperior/8
            rotate              90*x
            translate           -RadioSuperior/8*z
          }
          cylinder              {
            0, -RadioSuperior/4*z*1.1, BasePalanca
          }
          translate             -RadioSuperior/8*z
        }
        disc                    {
          -RadioSuperior/4*z, z, BasePalanca
          texture { TexturaDisco scale BasePalanca }
        }
        difference              {
          cylinder              {
            0, -RadioSuperior/2*z, BasePalanca
          }
          cylinder              {
            0.1*RadioSuperior*z, -0.95*RadioSuperior/2*z, 0.90*BasePalanca
          }
          translate             -3*RadioSuperior/8*z
          texture               { 
            TexturaTransparente  
            scale  BasePalanca*1.25
            translate             -3*RadioSuperior/8*z
          }
        }
        translate               -3/2*RadioSuperior*z+BasePalanca/2*y
        texture                 {
          TexturaMetal2
        }
      }

      box                               {
        <-2*RadioSuperior/3,0,-RadioSuperior/2>,
        <+2*RadioSuperior/3,BasePalanca/3,+RadioSuperior/2>
        translate               BasePalanca*y
      }
      difference                        {
        union                             {
          cylinder                        {
            0, -0.15*RadioSuperior*x, 8*BasePalanca/15
          }        
          cone                            {
            0, 6*BasePalanca/15,
            -1.15*RadioSuperior*x, 9*BasePalanca/15
          }
        }
        cylinder                        {
          +RadioSuperior*x, -0.20*RadioSuperior*x, 2*BasePalanca/15
        }
        cone                            {
          -0.16*RadioSuperior*x, 6.25*BasePalanca/15,
          -1.16*RadioSuperior*x, 8.75*BasePalanca/15
        }
        translate                       -RadioSuperior*x
        translate                       9*BasePalanca/15*y
        texture                         {
          TexturaPlastico
        }
      }
      translate  ( AlturaCilindro+AlturaCilindroSuperior
                   +2*RadioDecorativoInferior )*y
      texture                           {
        TexturaMetal
      }
    }
  }
#end  // #macro EFAH_ExtinguidorFuegoAccidentalHogar

#macro EFAH_SoporteDetalle
  ( DiametroFundamental, AlturaCilindro, RadioDecorativoInferior,
    RadioSuperior, AlturaCilindroSuperior, AlturaExtraSuperior,
    GruesoSoporte, GruesoCubiertaSoporte, 
    TexturaSoporteCilindro, TexturaSoporteCilindroCuero )
  union                                 {
    #local RadioSoporte                 =
                DiametroFundamental/2+RadioDecorativoInferior
                  +GruesoCubiertaSoporte/2;
    #local AltoSoporte                  =
                AlturaCilindro+AlturaCilindroSuperior-AlturaExtraSuperior/2;
    #local Curvatura                    = GruesoCubiertaSoporte/2;
    #local PuntoA                       = +RadioSoporte*x;
    #local PuntoA                       = vaxis_rotate( PuntoA, y, 10 );
    #local PuntoD                       = PuntoA+AltoSoporte*y;
    #local PuntoA                       = PuntoA
             -( 2*RadioDecorativoInferior-GruesoCubiertaSoporte/2 )*y;
    #local PuntoB                       = vaxis_rotate( PuntoA, y, 110 );
    #local PuntoC                       = PuntoB+0.13*AltoSoporte*y;
    union                               {
      #local C                          = 0;
      #while ( C < 2 )
        union                           {
          #local PuntoB1                = PuntoB;
          EFAH_AcercarPunto( PuntoB1, PuntoB, PuntoC, Curvatura )
          #local PuntoC1                = PuntoC;
          EFAH_AcercarPunto( PuntoC1, PuntoC, PuntoB, Curvatura )
          cylinder                      {
            PuntoB1, PuntoC1, GruesoSoporte/2
          }
          #local PuntoC2                = vaxis_rotate( PuntoC, y, 3 );
          #local PuntoC4                = PuntoC2*<1,1,-1>;
          #local PuntoC3                = -RadioSoporte*x+PuntoC2.y*y;
          #local PuntoC5                =
                   ( sqrt(2)-1 )*PuntoC+
                   ( 1-sqrt(2)/2 )*( PuntoC1+PuntoC2 );
          object                        {
            EFAH_SweepTriplePunto
            ( PuntoC2, PuntoC3, PuntoC4, GruesoSoporte/2, false )
          }
          object                        {
            EFAH_SweepTriplePunto
            ( PuntoC2, PuntoC5, PuntoC1, GruesoSoporte/2, true )
          }
          #local PuntoA1                     = <0,0,0>;
          EFAH_AcercarPunto( PuntoA1, PuntoA, PuntoB, Curvatura )
          #local PuntoB2                     = <0,0,0>;
          EFAH_AcercarPunto( PuntoB2, PuntoB, PuntoA, Curvatura )
          #local PuntoB3                =
             ( sqrt(2)-1 )*PuntoB+
             ( 1-sqrt(2)/2 )*( PuntoB1+PuntoB2 );
          cylinder                      {
            PuntoA1, PuntoB2, GruesoSoporte/2
          }
          object                        {
            EFAH_SweepTriplePunto
            ( PuntoB1, PuntoB3, PuntoB2, GruesoSoporte/2, true )
          }
          #local PuntoA2                     = <0,0,0>;
          EFAH_AcercarPunto( PuntoA2, PuntoA, PuntoD, Curvatura )
          #local PuntoD1                     = <0,0,0>;
          EFAH_AcercarPunto( PuntoD1, PuntoD, PuntoA, Curvatura )
          #local PuntoA3                =
             ( sqrt(2)-1 )*PuntoA+
             ( 1-sqrt(2)/2 )*( PuntoA1+PuntoA2 );
          cylinder                      {
            PuntoD1, PuntoA2, GruesoSoporte/2
          }
          object                        {
            EFAH_SweepTriplePunto
            ( PuntoA1, PuntoA3, PuntoA2, GruesoSoporte/2, true )
          }
          #local PuntoE                 = PuntoD*<0.5,1,1>;
          #local PuntoF                 = PuntoE*<-1,1,1>;
          #local PuntoEF                =
            < 0, PuntoE.y, -( RadioSuperior+GruesoCubiertaSoporte ) >;
          #local PuntoEM                = ( PuntoE+PuntoEF )/2;
          #local PuntoFM                = ( PuntoF+PuntoEF )/2;
          #local PuntoFFinal            = PuntoF*<1.25,1,1.25>;
          #local PuntoD2                = <0,0,0>;
          EFAH_AcercarPunto( PuntoD2, PuntoD, PuntoE, Curvatura )
          #local PuntoD3                =
             ( sqrt(2)-1 )*PuntoD+
             ( 1-sqrt(2)/2 )*( PuntoD1+PuntoD2 );
          cylinder                      {
            PuntoD2, PuntoE, GruesoSoporte/2
          }
          object                        {
            EFAH_SweepTriplePunto
            ( PuntoD1, PuntoD3, PuntoD2, GruesoSoporte/2, true )
          }
          sphere                        {
            PuntoE, GruesoSoporte/2
          }
          cylinder                      {
            PuntoE, PuntoEM, GruesoSoporte/2
          }
          sphere                        {
            PuntoEM, GruesoSoporte/2
          }
          union                         {
            object                        {
              EFAH_SweepTriplePunto
              ( PuntoEM, PuntoEF, PuntoFM, GruesoCubiertaSoporte/2, false )
            }
            object                        {
              EFAH_SweepTriplePunto
              ( PuntoFM, PuntoF, PuntoFFinal, GruesoCubiertaSoporte/2, true )
            }
            texture                     {
              TexturaSoporteCilindroCuero
            }
          }
          // uniones
          #local D                      = 0;
          #while ( D < 2 )
            union                       {
              cylinder                    {
                0, 0.1*AltoSoporte*y, GruesoCubiertaSoporte/2
              }
              translate                 PuntoA
              translate                 AltoSoporte/3*y
              translate                 D*AltoSoporte/3*y
            }
            #local D                    = D+1;
          #end
          #if ( C = 0 )
            scale                       -z
          #end
        }
        #local C                        = C+1;
      #end
      #local D                          = 0;
      #while ( D < 2)
        difference                      {
          box                           {
            PuntoA-GruesoSoporte/4*x,
            PuntoA*<1,1,-1>+0.1*AltoSoporte*y+GruesoSoporte/4*x
          }
          cylinder                      {
            -GruesoSoporte*x, GruesoSoporte*x, GruesoCubiertaSoporte/2
            translate           PuntoA*<1,1,0>+0.05*AltoSoporte*y
          }
          translate                 AltoSoporte/3*y
          translate                 D*AltoSoporte/3*y
        }
        #local D                        = D+1;
      #end
      texture                           {
        TexturaSoporteCilindro
      }
    }   
    translate                   ( GruesoSoporte+GruesoCubiertaSoporte )*y/2
  }
#end  // #macro EFAH_SoporteDetalla

#macro EFAH_Extinguidor( FactorCierre, RotateAleatorio )
  union                                 {
    #local L                          = EFAH_L;
    #local DiametroFundamental        = 64*L;
    #local AlturaCilindro             = 143*L;
    #local RadioDecorativoInferior    = 3.5*L/2;
    #local AlturaCilindroSuperior     = 23.5*L;
    #local RadioSuperior              = 21*L/2;
    #local AlturaExtraSuperior        = 9.2*L;
    #local ReferenciaPalanca          = 64.3*L;
    #local ProfundidadPalanca         = 13*L;
    #local BasePalanca                = 10.7*L;
    object                            {
      EFAH_ExtinguidorFuegoAccidentalHogar
        ( FactorCierre, RotateAleatorio, DiametroFundamental, AlturaCilindro,
          RadioDecorativoInferior, RadioSuperior,
          AlturaCilindroSuperior, AlturaExtraSuperior,
          ReferenciaPalanca, ProfundidadPalanca, BasePalanca,
          EFAH_TexturaCilindro, 
          EFAH_TexturaEtiqueta, EFAH_TexturaPlastico,
          EFAH_TexturaMetal, EFAH_TexturaMetal2,
          EFAH_TexturaDisco, EFAH_TexturaTransparente )
    }
  }
#end

#macro EFAH_Soporte()
  union                                 {
    #local L                          = EFAH_L;
    #local DiametroFundamental        = 64*L;
    #local AlturaCilindro             = 143*L;
    #local RadioDecorativoInferior    = 3.5*L/2;
    #local AlturaCilindroSuperior     = 23.5*L;
    #local AlturaExtraSuperior        = 9.2*L;
    #local RadioSuperior              = 21*L/2;
    #local GruesoSoporte              = 3*L;
    #local GruesoCubiertaSoporte      = 4.3*L;
    object                              {
      EFAH_SoporteDetalle
        ( DiametroFundamental, AlturaCilindro, 
          RadioDecorativoInferior, RadioSuperior,
          AlturaCilindroSuperior, AlturaExtraSuperior,
          GruesoSoporte, GruesoCubiertaSoporte,
          EFAH_TexturaSoporteCilindro,
          EFAH_TexturaSoporteCilindroCuero )
    }
  }
#end

#macro EFAH_ExtinguidorYSoporte( RotacionExtinguidor, FactorCierre, RotateAleatorio )
  union                                 {  
    #local L                          = EFAH_L;
    #local GruesoSoporte              = 3*L;
    #local GruesoCubiertaSoporte      = 4.3*L;
    object                              {
      EFAH_Extinguidor( FactorCierre, RotateAleatorio ) 
      rotate                      RotacionExtinguidor*y
      translate                   ( GruesoSoporte+GruesoCubiertaSoporte )*y/2
    }
    object                              {
      EFAH_Soporte()
    }        
  }
#end



