// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 14 octubre 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//                      
// EFAH ExtinguidorFuegoAccidentalHogar
// El archivo dibuja un extinguidor de incendios para hogar y automovil.
// Puede dibujarse con o sin soporte, e incluye una macro
// para variar caracteristicas fundamentales.
//      
// La siguiente macro dibuja el objeto default:
// #macro EFAH_ExtinguidorYSoporte
//      ( RotacionExtinguidor, FactorCierre, RotateAleatorio )
//              RotacionExtinguidor     : Rota el extinguidor en Y, con soporte fijo.
//              FactorCierre            : Entre 0.0.y 1.0 para simular
//                      apretar el disparador.  0.0 es cerrado.  
//                      Cualquier valor difernte de 0.0, produce
//                      que no se dibuje el seguro metalico. 
//              RotateAleatorio         : El gatillo suele ser algo flojo.
//                      Este factor aplica un rotate RotateAleatorio,
//                      al eje del disparador. 
//   
// Las dimensiones del objetos default (todo parametro cero) son :
//      Alto                    : 211*L  
//      Alto soporte            : 170*L  
//      Profundidad Z           : 65*L
//      Frente X                : -37*L..53*L  
//      Elevacion por soporte   : 3.65*L
// Todos los objetos anteriores descansan sobre el plano XZ, 
// casi centrados en el origen.  Frente X-, gravedad Y-.  
//
// El extinguidor puede dibujarse sin soporte con la siguiente macro.
// NOTA: Aplique translate 3.65*L*y para posicion default.
// #macro EFAH_Extinguidor( FactorCierre, RotateAleatorio )
//              FactorCierre            : Entre 0.0.y 1.0 para simular
//                      apretar el disparador.  0.0 es cerrado.  
//                      Cualquier valor difernte de 0.0, produce
//                      que no se dibuje el seguro metalico. 
//              RotateAleatorio         : El gatillo suele ser algo flojo.
//                      Este factor aplica un rotate RotateAleatorio,
//                      al eje del disparador. 
//
// Puede dibujarse solo el soporte con la macro sin parametros:
// #macro EFAH_Soporte() 
//
// El extinguidor puede modificarse con mayor flexibilidad, con la siguiente
// macro.
// NOTA: considere aplicar translate ( GruesoSoporte+GruesoCubiertaSoporte )/2*y
//       para ubicar en el soporte.
// #macro EFAH_ExtinguidorFuegoAccidentalHogar
//   ( FactorCierre, RotateAleatorio, DiametroFundamental, AlturaCilindro,
//     RadioDecorativoInferior, RadioSuperior,
//     AlturaCilindroSuperior, AlturaExtraSuperior,
//     ReferenciaPalanca, ProfundidadPalanca, BasePalanca,
//     TexturaCilindro, TexturaEtiqueta, TexturaPlastico, TexturaMetal, TexturaMetal2,
//     TexturaDisco, TexturaTransparente )
//              FactorCierre            : Entre 0.0.y 1.0 para simular
//                      apretar el disparador.  0.0 es cerrado.  
//                      Cualquier valor difernte de 0.0, produce
//                      que no se dibuje el seguro metalico. 
//              RotateAleatorio         : El gatillo suele ser algo flojo.
//                      Este factor aplica un rotate RotateAleatorio,
//                      al eje del disparador. 
//              DiametroFundamental     : Referencia para el diametro del cilindro
//                      principal.  Default es 64*L.
//              AlturaCilindro          : Referencia para la altura del cilindro
//                      principal.  Default es 143*L.
//              RadioDecorativoInferior : Referencia para la curvatura inferior
//                      del extinguidor.  Default es 1.75*L.
//              RadioSuperior           : Referencia para el radio de union
//                      con la boquilla.  Default es 10.5*L.
//              AlturaCilindroSuperior  : Referencia para la curvatura superior
//                      del extinguidor.  Default es 23.5*L.
//              AlturaExtraSuperior     : Referencia para la altura de la union
//                      con la boquilla.  Default es 9.2*L.
//              ReferenciaPalanca       : Referencia para la palanca liberadora
//                      de presion.  Default es 64.3*L.
//              ProfundidadPalanca      : Profundidad Z de la palanca liberadora
//                      de presion.  Default es 13*L.
//              BasePalanca             : Altura del soporte de palanca.  
//                      Default es 10.7*L.  
//              TexturaCilindro         : Textura principal.  
//                      Default es EFAH_TexturaCilindro.
//              TexturaEtiqueta         : Textura de las etiquetas del cilindro.
//                      Se aplican como un bitmap map_type 2.  Utilice un
//                      fondo compatible con TexturaCilindro.
//                      Default es EFAH_TexturaEtiqueta. 
//              TexturaPlastico         : Textura de la union plastica con
//                      la boquilla.  Default es EFAH_TexturaPlastico.
//              TexturaMetal            : Textura a aplicar a la base metalica
//                      de boquilla.  Default es EFAH_TexturaMetal.
//              TexturaMetal2           : Textura a aplicar al seguro
//                      y otros elementos.  Default es EFAH_TexturaMetal2.
//              TexturaDisco            : Textura del disco medidor de presion.
//                      Default es EFAH_TexturaDisco.
//              TexturaTransparente     : Textura del plastico transparente
//                      del medidor de presion.  Default es EFAH_TexturaTransparente.
//  
// La siguiente macro controla con mayor detalle el soporte.
// Muchos parametros se suponen son identicos a la macro anterior,
// para ajustar la figura.
// #macro EFAH_SoporteDetalle
//   ( DiametroFundamental, AlturaCilindro, RadioDecorativoInferior,
//     RadioSuperior, AlturaCilindroSuperior, AlturaExtraSuperior,
//     GruesoSoporte, GruesoCubiertaSoporte,
//     TexturaSoporteCilindro, TexturaSoporteCilindroCuero )
//              DiametroFundamental     : Referencia para el diametro del cilindro
//                      principal.  Default es 64*L.
//              AlturaCilindro          : Referencia para la altura del cilindro
//                      principal.  Default es 143*L.
//              RadioDecorativoInferior : Referencia para la curvatura inferior
//                      del extinguidor.  Default es 1.75*L.
//              RadioSuperior           : Referencia para el radio de union
//                      con la boquilla.  Default es 10.5*L.
//              AlturaCilindroSuperior  : Referencia para la curvatura superior
//                      del extinguidor.  Default es 23.5*L.
//              AlturaExtraSuperior     : Referencia para la altura de la union
//                      con la boquilla.  Default es 9.2*L.
//              GruesoSoporte           : Se refiere al grueso de las varillas.
//                      Default es 3*L.
//              GruesoCubiertaSoporte   : Se refiere al grueso de varillas,
//                      recubiertas por cuero.  Default es 4.3*L.  
//              TexturaSoporteCilindro  : Textura basica del soporte.
//                      Default es EFAH_TexturaSoporteCilindro.
//              TexturaSoporteCilindroCuero     : Textura para el cuero de contacto
//                      superior del soporte.
//                      Default es EFAH_TexturaSoporteCilindroCuero. 
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse.
// #declare EFAH_DefaultTexturaCilindro         
//      Textura principal.
// #declare EFAH_DefaultTexturaEtiqueta       
//      Textura de las etiquetas del cilindro.
// #declare EFAH_DefaultTexturaPlastico         
//      Textura de la union plastica con la boquilla.  
// #declare EFAH_DefaultTexturaMetal            
//      Textura a aplicar a la base metalica de boquilla.  
// #declare EFAH_DefaultTexturaMetal2            
//      Textura a aplicar al seguro, y otros elementos.  
// #declare EFAH_DefaultTexturaDisco            
//      Textura del disco medidor de presion.
// #declare EFAH_DefaultTexturaTransparente     
//      Textura del plastico transparente del medidor de presion.  
// #declare EFAH_DefaultTexturaSoporteCilindro  
//      Textura basica del soporte.
// #declare EFAH_DefaultTexturaSoporteCilindroCuero     
//      Textura para el cuero de contacto superior del soporte.
//   
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare EFAH_TexturaCilindro                        = texture { ... }     
//      Textura principal.
// #declare EFAH_TexturaEtiqueta                        = texture { ... }       
//      Textura de las etiquetas del cilindro.
// #declare EFAH_TexturaPlastico                        = texture { ... }         
//      Textura de la union plastica con la boquilla.  
// #declare EFAH_TexturaMetal                           = texture { ... }           
//      Textura a aplicar a la base metalica de boquilla.  
// #declare EFAH_TexturaMetal2                          = texture { ... }        
//      Textura a aplicar al seguro y otros elementos.  
// #declare EFAH_TexturaDisco                           = texture { ... }      
//      Textura del disco medidor de presion.
// #declare EFAH_TexturaTransparente                    = texture { ... }     
//      Textura del plastico transparente del medidor de presion.  
// #declare EFAH_TexturaSoporteCilindro                 = texture { ... }
//      Textura basica del soporte.
// #declare EFAH_TexturaSoporteCilindroCuero            = texture { ... }   
//      Textura para el cuero de contacto superior del soporte.
// #declare EFAH_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
//
// Para colocarlo simplemente
//
// #include "EFAH.inc"
//  object                  {
//    EFAH_ExtinguidorYSoporte( 0, 0, 0 ) 
//  }
//
//  o bien solo el extinguidor... 
//  #include "EFAH.inc"
//  object                  {   
//    EFAH_Extinguidor( 0, 0 )  
//  }
//
//  o bien la misma figura anterior con macro detallada 
//  #include "EFAH.inc"
//  object                  {
//    EFAH_ExtinguidorFuegoAccidentalHogar
//      ( 0, 0, 0.064, 0.143, 0.00175, 0.0235, 
//              0.0105, 0.0092, 0.0643, 0.013, 0.0107,
//          EFAH_TexturaCilindro, EFAH_TexturaEtiqueta, EFAH_TexturaPlastico,
//          EFAH_TexturaMetal, EFAH_TexturaMetal2,
//          EFAH_TexturaDisco, EFAH_TexturaTransparente )
//  }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "EFAH.inc" 

#local FactorAcercamiento               = 6;

object                                  {
  EFAH_ExtinguidorYSoporte(0,0,0 )    
  translate                     -0.105*y
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z         
}


