// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 19 marzo 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// HFST HeightFieldSantisimaTrinidad
// El archivo dibuja una imagen en bajorelieve de yeso
// de la Santisima Trinidad
// Se utilizo una tecnica de doble foto para generar
// un HeigthField
// Para efectos de estudio se incluye en este paquete el codigo pascal
// de TRIN.EXE "HFST_TRI.TXT" el pequeno programa utilizado.
// No se recomienda su uso todavia, excepto si usted
// planea programar su propia version, consideramos que
// es bastante simple de hacer para un programador acostumbrado
// a POVRay.
// En futuros paquetes FreeRAY incorporaremos mejoras al programa.
// Esta version es muy ineficiente, y requiere mucho trabajo extra
// para corregir errores y lograr que funcione.  Y ademas, es bastante
// lenta.  Con mayor eficiencia estamos totalmente convencidos de ello,
// su velocidad incrementaria notablemente.
//
// El dibujo puede generarse con la siguiente macro.
// #macro HFST_HeightFieldSantisimaTrinidad()
//
// En esta otra version, se dibuja lo mismo pero sin el soporte.
// Note que se trata del HeightField solo, y que requiere correcciones.
// #macro HFST_HeightField()
//
// Caracteristicas del objeto:
//      Alto            = 289*L
//      Ancho           = 200*L
//      Profundidad     =  30*L
// El objeto descansa sobre el plano XZ gravedad Y-.
// El marco centrado respecto al eje Z.
// El frente sobresale hacia Z- y descansa sobre el plano XY.
//
// Para colocarlo simplemente
// #include "SMIE.inc"
// object        { HFST_HeightFieldSantisimaTrinidad() }
//

#include "woods.inc"


#declare HFST_L                 = 0.001;

#macro HFST_HeightField()
  height_field          {
    gif         "HFST_IM1.gif"
    water_level         0.01
    smooth
    hierarchy           on
    rotate              -90*x
    pigment             {
      image_map         {
        gif     "HFST_IM2.gif"
      }
      translate       -0.5*x-0.5*y
      scale           1.025
      translate       +0.5*x+0.5*y
    } 
    finish              { 
      ambient           0.4
      diffuse           0.3
    }
    normal              {
      bumps
    }
    translate           -0.525*x-0.5*y
    rotate              -1*z
    scale               <1.4,1,1.0>
    translate           +0.5*y
    scale               1/4
  }
#end  // #macro HFST_HeigthField

#macro HFST_HeightFieldSantisimaTrinidad( )
  union                 {
    object              {
      HFST_HeightField()
      scale             4
      translate           -0.5*y
    }
    union               {
      box                 {
        <-0.40,-0.50,-0.10>,
        <+0.40,-0.45, 0.00>
      }
      texture           {
        T_Wood31
      }
    }
    union               {
      box               {
        <-0.40,-0.45,-0.02>,
        <+0.40,+0.25, 0.00>
      }
      difference        {
        prism             {
          cubic_spline
          0, 0.02,7
          <+0.40,+0.25>,
          <+0.00,-0.15>,
          <-0.40,+0.25>,
          <+0.00,+0.65>,
          <+0.40,+0.25>,
          <+0.00,-0.15>,
          <-0.40,+0.25>
          rotate  -90*x
        }
        cylinder                {
          -z, z, 0.020
          translate     +0.60*y
        }
      }
      union             {
        torus           {
          0.02,0.0025
          rotate        -90*x
          translate     +0.60*y-0.02*z
        }
        pigment         {
          Silver
        }
        normal        {
          bumps
          scale       0.01
        }
      }
      texture           {
        T_Wood25
      }
    }
    translate           +0.5*y
    scale               1/4
  }
#end  // #macro HFST_HeightFieldSantisimaTrinidad
