// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 19 marzo 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// HFST HeightFieldSantisimaTrinidad
// El archivo dibuja una imagen en bajorelieve de yeso
// de la Santisima Trinidad
// Se utilizo una tecnica de doble foto para generar
// un HeigthField
// Para efectos de estudio se incluye en este paquete el codigo pascal
// de TRIN.EXE "HFST_TRI.TXT" el pequeno programa utilizado.
// No se recomienda su uso todavia, excepto si usted
// planea programar su propia version, consideramos que
// es bastante simple de hacer para un programador acostumbrado
// a POVRay.
// En futuros paquetes FreeRAY incorporaremos mejoras al programa.
// Esta version es muy ineficiente, y requiere mucho trabajo extra
// para corregir errores y lograr que funcione.  Y ademas, es bastante
// lenta.  Con mayor eficiencia estamos totalmente convencidos de ello,
// su velocidad incrementaria notablemente.
//
// El dibujo puede generarse con la siguiente macro.
// #macro HFST_HeightFieldSantisimaTrinidad()
//
// En esta otra version, se dibuja lo mismo pero sin el soporte.
// Note que se trata del HeightField solo, y que requiere correcciones.
// #macro HFST_HeightField()
//
// Caracteristicas del objeto:
//      Alto            = 289*L
//      Ancho           = 200*L
//      Profundidad     =  30*L
// El objeto descansa sobre el plano XZ gravedad Y-.
// El marco centrado respecto al eje Z.
// El frente sobresale hacia Z- y descansa sobre el plano XY.
//
// Para colocarlo simplemente
// #include "SMIE.inc"
// object        { HFST_HeightFieldSantisimaTrinidad() }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
light_source    {
         <-2000  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    
#include "HFST.inc"

#local FactorAcercamiento       = 4;

object                  {
  HFST_HeightFieldSantisimaTrinidad()
  translate     -0.14*y
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
}
