// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 11 marzo 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// ILFD InstrumentalLaboratorioFantasiaDomestico
// El archivo dibuja un laboratorio ficticio...
// Simplemente son inventados, pese al parecido con algo que usted haya visto.
// lo "divertido" es utilizar intensamente el archivo
// #include "functions.inc", y unos poquitos 
// rectangulos, cilindros, esferas y text para uniones y cosas asi... 
// Ademas se utilizaron casi textuales funciones de archivos por Alexander Enzmann
// en el subdirectorio POVRay objects\quartic\*.pov 
// siendo entidades matematicas, supuse que no le molestaria. 
//
// La macro utililzada es muy poco flexible.
// #macro ILFD_Laboratory( Semilla )   
//      Semilla         : Valor para la generacion de numeros aleatorios.
//                        Mismo valor inicial, repite patron.
//
// Las dimensiones del laboratorio son :
//      Alto total              =  1425*L
//      Fondo                   =   500*L aprox
//      Frente                  = -1220*L..1000*L   
// Se dibuja parcialemente centrado sobre el origen del plano XZ.
// El frente sobresale en direccion Z-, con gravedad Y-.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare ILFD_TexturaCrisol     
//      Textura del crisol de porcelada.
// #declare ILFD_TexturaPistilo   
//      Textura del pistilo del crisol de porcelana. 
// #declare ILFD_TexturaContacto    
//      Textura para la zona de contacto crisol y pistilo.
// #declare ILFD_TexturaMadera 
//      Textura para las repisas del laboratorio.  
// #declare ILFD_TexturaSoporteDestiladores 
//      Textura para la base del destilador.  
// #declare ILFD_TexturaTapa  
//      Textura del tapas del horno magnetico.    
// #declare ILFD_MaterialEspiral  
//      Material de la espiral del horno magnetico. 
// #declare ILFD_MaterialCilindro    
//      Material del vidrio del horno magnetico y de los perfiles de vidrio libres.
// #declare ILFD_MaterialDestilador 
//      Material principal del destilador. 
// #declare ILFD_MaterialCuelloDestilador   
//      Material del colector del destilador.
// #declare ILFD_TexturaAgarre   
//      Textura de agarre de la espiral del horno magnetico.  
// #declare ILFD_MaterialMagneto 
//      Material del magneto del horno.  
// #declare ILFD_MaterialSuperior6
//      Material del descanso superior del colector distribuidor de flujo.  
// #declare ILFD_MaterialSoporte6                                         
//      Material de la capa del colector distribuidor de flujo.
// #declare ILFD_MaterialExtractor6  
//      Material del generador de vacio.
// #declare ILFD_MaterialPata6          
//      Material de los colectores del colector distribuidor de flujo.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare ILFD_BanderaTexto                           = on;
//      Valor "off" elimina el texto.  "on" si lo dibuja.
// #declare ILFD_Texto                                  = "f(X)"; 
//      Texto a escribir.
// #declare ILFD_FactorXTexto                           = 1.00;             
//      Para corregir el largo del soporte horizontal del texto en forma
//      proporcional.                                                    
// #declare ILFD_TranslateTexto                         = <0,0,0>;
//      Para corregir la posicion del texto.
// #declare ILFD_DefaultTexturaCrisol                   = texture  { ... }
//      Textura a aplicar al crisol de porcelana.
// #declare ILFD_DefaultTexturaPistilo                  = texture  { ... }
//      Textura del pistilo para el crisol de porcelana.
// #declare ILFD_DefaultTexturaContacto                 = texture  { ... }
//      Textura para la zona de contacto crisol y pistilo.
// #declare ILFD_DefaultTexturaMadera                   = texture  { ... }  
//      Textura para las repisas del laboratorio.
// #declare ILFD_DefaultTexturaSoporteDestiladores      = texture  { ... } 
//      Textura para la base del destilador.                       
// #declare ILFD_DefaultTexturaTapa                     = texture  { ... }
//      Textura de tapas del horno magnetico.
// #declare ILFD_DefaultMaterialEspiral                 = material { ... }
//      Material de espiral del horno magnetico.
// #declare ILFD_DefaultMaterialCilindro                = material { ... }     
//      Material del vidrio del horno magnetico, y de los
//      perfiles de vidrio libres.
// #declare ILFD_DefaultMaterialDestilador              = material { ... }
//      Material principal del destilador.  
// #declare ILFD_DefaultMaterialCuelloDestilador        = material { ... }
//      Material del colector del destilador. 
// #declare ILFD_DefaultTexturaAgarre                   = texture  { ... }
//      Textura de agarre de la espiral del horno magnetico.
// #declare ILFD_DefaultMaterialMagneto                 = material { ... }
//      Material del magneto del horno.
// #declare ILFD_DefaultMaterialSuperior6               = material { ... } 
//      Material del descanso superior del colector-distribuidor de flujo.
// #declare ILFD_DefaultMaterialSoporte6                = material { ... }
//      Material de la capa del colector distribuidor de flujo.
// #declare ILFD_DefaultMaterialExtractor6              = material { ... } 
//      Material del generador de vacio.
// #declare ILFD_DefaultMaterialPata6                   = material { ... } 
//      Material de los colectores del colector distribuidor de flujo.
//
// Para colocarlo simplemente
// #include "ILFD.inc"
// object        { ILFD_Laboratory( 300 ) }
//
// Otro ejemplo con modificador
// #include "ILFD.inc"
// #declare ILFD_DefaultTexturaMadera        = texture       {
//   average
//   texture_map        {
//     [ 0.5 ILFD_TexturaMadera         ]
//     [ 0.5 Rust                       ]
//   }
// }
// object        {
//      ILFD_Laboratory( 300 )
// }
//

#include "stones.inc" 
#include "textures.inc"
#include "functions.inc"  
#include "glass.inc"  
#include "metals.inc"
#include "woods.inc"

#declare ILFD_L                 = 0.001; 

#declare ILFD_BanderaTexto      = on;

#declare ILFD_Texto             = "f(X)"; 

#declare ILFD_FactorXTexto      = 1.00;    

#declare ILFD_TranslateTexto    = <0,0,0>;
 
#declare ILFD_Lemniscata2       =
// By Alexander Enzmann
// tomado casi textural de objects\quartic\lemnisc2.pov 
// siendo entes matematicos se supuso que no le molestaria
// la copia y su uso 
union {
   /* Lemniscate of Gerono */
   quartic {
     < 1.0,  0.0,  0.0,  0.0, 0.0,  0.0,  0.0,  0.0,  0.0, -1.0,
       0.0,  0.0,  0.0,  0.0, 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
       0.0,  0.0,  0.0,  0.0, 0.0,  1.0,  0.0,  0.0,  0.0,  0.0,
       0.0,  0.0,  1.0,  0.0, 0.0 >

      bounded_by { sphere { <0, 0, 0>, 1.5 } }

      rotate 45*z
   }

   /* Lemniscate of Gerono */
   quartic {
      < 1.0,  0.0,  0.0,   0.0, 0.0,  0.0,  0.0,  0.0,  0.0, -1.0,
        0.0,  0.0,  0.0,   0.0, 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
        0.0,  0.0,  0.0,   0.0, 0.0,  1.0,  0.0,  0.0,  0.0,  0.0,
        0.0,  0.0,  1.0,   0.0, 0.0 >

      bounded_by { sphere { <0, 0, 0>, 1.5 } }

      rotate -45*z
   }

}

#declare ILFD_Hyptorus  =
quartic {
   < 1.0,  0.0,  0.0,   0.0,    2.0,  0.0,  0.0, -2.0,  0.0, -104.0
     0.0,  0.0,  0.0,   0.0,    0.0,  0.0,  0.0,  0.0,  0.0,   0.0
     1.0,  0.0,  0.0,  -2.0,    0.0, 56.0,  0.0,  0.0,  0.0,   0.0
     1.0,  0.0, 104.0,  0.0,  784.0 >

   bounded_by { sphere { <0, 0, 0>, 20 } }

   rotate 90*x
}   

#declare ILFD_Through   =
/* Crossed Trough */
intersection {
   object {
quartic {
 < 0.0,  0.0,  0.0,  0.0, 0.0,  0.0,  0.0,  4.0,  0.0,  0.0,
   0.0,  0.0,  0.0,  0.0, 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
   0.0,  0.0,  0.0,  0.0, 0.0,  0.0,  0.0,  0.0,  0.0, -1.0,
   0.0,  0.0,  0.0,  0.0, 0.0 >
}
   }

   object { box { -1, 1 }  texture { pigment {Clear} } }

   bounded_by { object { box { -1, 1 }  scale 1.5 } }

}   

#declare ILFD_Piriform  =
quartic {
   < 4.0,  0.0,  0.0,  -4.0, 0.0,  0.0,  0.0,  0.0,  0.0, 0.0,
     0.0,  0.0,  0.0,   0.0, 0.0,  0.0,  0.0,  0.0,  0.0, 0.0,
     0.0,  0.0,  0.0,   0.0, 0.0,  1.0,  0.0,  0.0,  0.0, 0.0,
     0.0,  0.0,  1.0,   0.0, 0.0 >

   bounded_by { box { -2*y-2*z+0.1*x, 2 } }
}


#declare ILFD_TexturaCrisol     =
  texture                       {
    T_Stone35  
    scale       1000
  }
   
#declare ILFD_TexturaPistilo    =
  texture                       {
    T_Stone35  
    scale       1000
  }
   
#declare ILFD_TexturaContacto   =
  texture                       {
    T_Stone31 
    scale       10
  } 
  
#declare ILFD_TexturaMadera   =
  texture                       {
    T_Stone38
    scale       0.1
  } 
  
#declare ILFD_TexturaSoporteDestiladores   =
  texture                       {
    T_Stone31 
    scale       10
  } 
  texture                       {
    pigment                     {
      gradient                  z
      scale             0.05
      triangle_wave
      pigment_map               {
        [ 0.0 rgb Silver         transmit 0.5 ]
        [ 1.0 rgb CornflowerBlue transmit 0.5 ]
      }
    }
    normal                      {
      gradient                  z
      scale             0.025
      triangle_wave
    }
 }
 texture                        {
   pigment                      {
     agate 
     turbulence  1             
     scale              0.1
     pigment_map                {
       [ 0.0 rgb Green transmit 0.6 ]
       [ 1.0 rgb Brown transmit 0.6 ]
     }
   }
   normal                      {
     granite 
     turbulence  1             
     scale              0.1
   }
 }
  
#declare ILFD_TexturaTapa       =
  texture                       {
    T_Stone24 
  } 
  
#declare ILFD_MaterialEspiral   =
  material                      { 
    texture { pigment { color Red transmit 0.5 } finish { F_Glass3 } }  
    interior { I_Glass fade_color Red }    
  }    

#declare ILFD_MaterialCilindro   =
  material                      { 
    texture { pigment { color Green transmit 0.85 } finish { F_Glass3 } }  
    interior { I_Glass fade_color Red }    
  }    

#declare ILFD_MaterialDestilador  =
  material                      { 
    texture { pigment { color White transmit 0.85 } finish { F_Glass3 } }  
    interior { I_Glass fade_color Red }    
  }    

#declare ILFD_MaterialCuelloDestilador  =
  material                      { 
    texture { pigment { color White transmit 0.75 } finish { F_Glass1 } }
    texture     { 
      pigment   {
      granite  
      scale             0.01
      pigment_map       {
        [0.0 rgbt 1 ]
        [0.5 rgbt 1 ]
        [0.5 rgb 1 transmit 0 ]          
        [1.0 rgb 1 transmit 0 ]
      }
      }
    }  
    interior { I_Glass }    
  }    

#declare ILFD_TexturaAgarre     =
  texture                    { 
    pigment { color Yellow transmit 0.5 } 
    finish  { F_Glass3 } 
  }    

#declare ILFD_MaterialMagneto   =
  material                      {   
    texture { pigment { color Orange transmit 0.50 } finish { F_Glass4 } }  
    interior { I_Glass fade_color Red }    
  }    
 
#declare ILFD_MaterialSuperior6  =
  material                      {    
    ILFD_MaterialDestilador  
  } 
 
#declare ILFD_MaterialSoporte6  =
  material                      {   
    M_Glass
  } 
 
#declare ILFD_MaterialExtractor6  =
  material                      {  
    texture     {     
      pigment { Yellow }
      normal    { gradient y scale 0.001 } 
    }  
  } 
 
#declare ILFD_MaterialPata6  =
  material                      { 
    ILFD_MaterialDestilador
  } 

#ifndef ( ILFD_DefaultTexturaCrisol )
  #declare ILFD_DefaultTexturaCrisol   = 
        texture { ILFD_TexturaCrisol }
#end  // #ifndef ( ILFD_DefaultTexturaCrisol ) 

#ifndef ( ILFD_DefaultTexturaTapa )
  #declare ILFD_DefaultTexturaTapa   = 
        texture { ILFD_TexturaTapa }
#end  // #ifndef ( ILFD_DefaultTexturaCrisol ) 

#ifndef ( ILFD_DefaultTexturaMadera )
  #declare ILFD_DefaultTexturaMadera   = 
        texture { ILFD_TexturaMadera }
#end  // #ifndef ( ILFD_DefaultTexturaCrisol ) 

#ifndef ( ILFD_DefaultTexturaPistilo )
  #declare ILFD_DefaultTexturaPistilo  = 
        texture { ILFD_TexturaPistilo }
#end  // #ifndef ( ILFD_DefaultTexturaCrisol ) 

#ifndef ( ILFD_DefaultTexturaContacto )   
  #declare ILFD_DefaultTexturaContacto  =
        texture { ILFD_TexturaContacto }
#end  // #ifndef ( ILFD_DefaultTexturaContacto )

#ifndef ( ILFD_DefaultTexturaSoporteDestiladores )   
  #declare ILFD_DefaultTexturaSoporteDestiladores  =
        texture { ILFD_TexturaSoporteDestiladores }
#end  // #ifndef ( ILFD_DefaultTexturaSoporteDestiladores )

#ifndef ( ILFD_DefaultMaterialEspiral )   
  #declare ILFD_DefaultMaterialEspiral  =
        material { ILFD_MaterialEspiral }
#end  // #ifndef ( ILFD_DefaultMaterialEspiral )

#ifndef ( ILFD_DefaultMaterialDestilador )   
  #declare ILFD_DefaultMaterialDestilador  =
        material { ILFD_MaterialDestilador }
#end  // #ifndef ( ILFD_DefaultMaterialEspiral )

#ifndef ( ILFD_DefaultMaterialCuelloDestilador )   
  #declare ILFD_DefaultMaterialCuelloDestilador  =
        material { ILFD_MaterialCuelloDestilador }
#end  // #ifndef ( ILFD_DefaultMaterialEspiral )

#ifndef ( ILFD_DefaultMaterialCilindro )   
  #declare ILFD_DefaultMaterialCilindro  =
        material { ILFD_MaterialCilindro }
#end  // #ifndef ( ILFD_DefaultMaterialEspiral )

#ifndef ( ILFD_DefaultTexturaAgarre )   
  #declare ILFD_DefaultTexturaAgarre  =
        texture { ILFD_TexturaAgarre }
#end  // #ifndef ( ILFD_DefaultTexturaContacto )

#ifndef ( ILFD_DefaultMaterialMagneto )   
  #declare ILFD_DefaultMaterialMagneto  =
        material { ILFD_MaterialMagneto }
#end  // #ifndef ( ILFD_DefaultMaterialEspiral )
      
#ifndef ( ILFD_DefaultMaterialSuperior6 )      
  #declare ILFD_DefaultMaterialSuperior6 =
        material { ILFD_MaterialSuperior6 }
#end   

#ifndef ( ILFD_DefaultMaterialSoporte6 )      
  #declare ILFD_DefaultMaterialSoporte6 =
        material { ILFD_MaterialSoporte6 }
#end   

#ifndef ( ILFD_DefaultMaterialExtractor6 )      
  #declare ILFD_DefaultMaterialExtractor6 =
        material { ILFD_MaterialExtractor6 }
#end   

#ifndef ( ILFD_DefaultMaterialPata6 )      
  #declare ILFD_DefaultMaterialPata6 =
        material { ILFD_MaterialPata6 }
#end   

#macro ILFD_Instrumental1( DiametroCrisol, DiametroInterno,
                        TexturaCrisol, TexturaContacto ) 
union                   {
  cylinder              {
    0                   , 0.1*DiametroCrisol*y,
    0.25*DiametroCrisol
    texture             {
      TexturaCrisol
    }
    translate           -DiametroCrisol/2*y
  }
  difference            {
    #local Radius = 8;
    intersection {
      isosurface {
	function  { f_cubic_saddle(x,y,z, -0.5) }
				//P0= Field Strength
	contained_by { sphere { 0, Radius } }
	max_gradient 38.1
	texture { TexturaCrisol }
      }
      sphere { 0, Radius-0.00001  texture { TexturaCrisol } }
      scale 0.8  rotate z*135  rotate x*-20  
    }
    sphere              {
      0, Radius*0.8*( DiametroInterno/DiametroCrisol )
      texture           { TexturaContacto }
    }
    rotate              25*x
    scale               0.5*DiametroCrisol/( Radius*0.8 )
  }	
}
#end  // #macro ILFD_Instrumental1() 

#macro ILFD_Instrumental2( TexturaPistilo, TexturaContacto )
  union                 {
    isosurface {
      function  { f_piriform(x,y,z, 0.7) }
		//P0= Field Strength
      contained_by { box { <-0, -0.4, -0.4>, <1, 0.4, 0.4> } }
      max_gradient 0.9
      texture { TexturaPistilo }
      scale 10  rotate y*-20  translate x*-4
      rotate              90*z
      scale               <0.01,0.01,0.01>
      translate           +0.040*y  
    }
    sphere              {
      0                 , 0.020
      texture           { TexturaContacto scale 0.01 }
    } 
    rotate              80*z 
  }
#end 

#macro ILFD_Instrumental3( Semilla, RadioReferencia, MaterialCilindro, 
         MaterialEspiral, TexturaAgarre,
         TexturaRecipiente, MaterialMagneto, TexturaTapa )
  union                 {
    #local S            = seed( Semilla );
    object              {
      #local LCorner = <-1, -0.05, -1>;  
      #local RCorner = <1, 0.05, 1>;
      isosurface {
	function { f_spiral(x,y,z, 0.2, 0.04, 1, 0, 0, 1) }
			//P0= distance between windings
			//P1= Y thickness
			//P2= outer diameter
			//P3= not used
			//P4= not used
			//P5= cross section shape
	contained_by { box { LCorner, RCorner } }
	max_gradient 1.3
	material { MaterialEspiral }
	scale 6.3  rotate x*-3
      }
      scale             Radio/6.3
    }
    union       {
      #local C          = 0;
      #while ( C < 3 )	
        isosurface {
	  function  { f_dupin_cyclid(x,y,z,-.05, 0.27, 0.04, 0.55, 0.0, 1.0) }
		//P0= Field Strength
		//P1= Major radius of torus
		//P2= Minor radius of torus
		//P3= X displacement of torus
		//P4= Y displacement of torus
		//P5= radius of inversion
	  contained_by { box { <1.0, -0.6, -1.6>, <4.3, 0.6, 1.6> } }
	  max_gradient 2.1
	  texture { TexturaAgarre }
	  scale 1.5  rotate x*-90 
	  scale   0.02
	  translate       +Radio*0.75*x
	  rotate        120*C*y
	}
	#local C                = C+1;
      #end
    }  
    object                      {
	isosurface {
		function  { f_algbr_cyl3(x,y,z,-1, 3, 1, 0, 0) }
			//P0= Field Strength
			//P1= Field limit
			//P2= SOR switch
			//P3= SOR offset
			//P4= SOR angle
		contained_by { box { <-1.05, -0.01, -1.05>, <1.05, 1.3, 1.05> } }
		max_gradient 6.5
		texture { TexturaRecipiente }

		scale 3.2  
	}
       scale 0.050 
       translate                0.25*RadioReferencia*<rand(S),0,rand(S)>
    }                              
    difference                  {
      cylinder                  {
        -0.10*RadioReferencia*y, 2.00*RadioReferencia*y, RadioReferencia
      }
      cylinder                  {
        -0.15*RadioReferencia*y, 2.05*RadioReferencia*y, 0.98*RadioReferencia
      }
      material                  {
        MaterialCilindro
      }
    } 
    object                      {
      #local LCorner = <-3.7, -1.7, -3.7>;  
      #local RCorner = <3.7, 1.7, 3.7>;
      isosurface {
	function  { f_helical_torus(x,y,z, 2, 7, 1, 0.1, 1, 0.5, 1, 6, 2.0, 0) }
			//P0= Major radius
			//P1= Nr of winding loops
			//P2= Twistness winding
			//P3= Flatness of winding?
			//P4= Threshold
			//P5= Negative minor radius?
			//P6= Another fatness of winding control
			//P7= Groove period
			//P8= Groove amplitude
			//P9= Groove phase
	contained_by { box { LCorner, RCorner } }
	max_gradient 13
	material { MaterialMagneto }
	scale 2.15   
	scale           0.05
	translate       1.5*RadioReferencia*y
      } 
    }
    cylinder            {
      -0.10*RadioReferencia*y, -0.15*RadioReferencia*y, 1.1*RadioReferencia
      texture           {
        TexturaTapa
      }
    }    
    cylinder            {
      +1.95*RadioReferencia*y, +2.00*RadioReferencia*y, 1.1*RadioReferencia
      texture           {
        TexturaTapa
      }
    }  
    translate           0.1*RadioReferencia*y  
  }
#end

#macro ILFD_Instrumental4( MaterialDestilador, MaterialCuelloDestilador, TexturaSoporteDestiladores )
  union                 {
    object              {
      #local LCorner = <-10, -4, -4>;  
      #local RCorner = <6, 4, 4>;
      intersection {
	isosurface {
	  function  { f_nodal_cubic(x,y,z, -0.005) }
				//P0= Field Strength
	  contained_by { box { LCorner, RCorner } }
	  max_trace 3
	  max_gradient 0.4
	}
	box { LCorner*0.9999, RCorner*0.9999 } 
	rotate          90*y      
	scale           0.10/4		
      } 
      texture           {   
        TexturaSoporteDestiladores
      }
    }
    object              {	
      #local LCorner = <-1.5, -2.9, -1.5>;  
      #local RCorner = <1.5, 2.9, 1.5>;
      isosurface {
	function { f_helix1(x,y,z, 1, 8, 0.3, 0.9, 0.6, 0.2, 0) }
			//P0= number of helixes
			//P1= frequency
			//P2= minor radius
			//P3= major radius
			//P4= Y scale cross section
			//P5= cross section
			//P6= cross section rotation ()
	contained_by { box { LCorner, RCorner } }
	max_gradient 1.5
      }
      rotate            -45*z
      scale             0.08    
      translate         0.20*(x+y) 
      material          {
        MaterialDestilador
      }
    }	
    object              {
      #local LCorner = <-3.3, -0.2, -2.5>;  
      #local RCorner = <3.3, 3.5, 3.0>;
      intersection {
	isosurface {
	  function  { f_umbrella(x,y,z, -0.2) }
				//P0= Field Strength
	  contained_by { box { LCorner, RCorner } }
	  max_gradient 2.6
	}
	box { LCorner*0.9999, RCorner*0.9999 }
      }        
      scale             0.050
      translate         +0.35*(x+y)
      material  { MaterialCuelloDestilador }
    }
    object                      {
      #local LCorner = <-0.4, -0.1, -0.4>;  
      #local RCorner = <0.4, 1.1, 0.4>;
      isosurface {
	function  { f_piriform_2d(x,y,z, -1, 1, -1, 0.9, 1, 0, -90) }
			//P0= Field Strength
			//P1= Size factor1: increasing this makes the curve larger
			//P2= Size factor 2: making this less negative makes the curve larger but also thinner
			//P3= Flatness: increasing this makes the curve fatter
			//P4= SOR switch
			//P5= SOR offset
			//P6= SOR angle
	contained_by { box { LCorner, RCorner } }
	max_gradient 1.4
      }    
      scale     <0.2,0.70,0.2>
      rotate    -90*x
      translate 0.5*(x+y)-0.05*y+0.25*z
      material          {
        MaterialDestilador
      }
    }	
  }
#end

#macro ILFD_Instrumental5( MaterialEje )
  union                   {
    object                { 
      #local LCorner = <-0.9, -0.55, -0.01>;  
      #local RCorner = <0.9, 1.0, 6>;
      intersection {
	isosurface {
          function  { f_algbr_cyl4(x,y,z, -0.4, 5, 0, 0, 0) }
				//P0= Field Strength
				//P1= Field limit
				//P2= SOR switch
				//P3= SOR offset
				//P4= SOR angle
	  contained_by { box { LCorner, RCorner } }
	  max_gradient 4
	}
	box { LCorner*0.9999, RCorner*0.9999 }
      }    
      rotate            -90*x
      rotate            20*y
      scale             <0.4,1,0.4>
      scale             0.1
      material                  {
        MaterialEje
      }      
    }
    #local EsferaEspecial       =
    object                      { 
      #local Radius = 4;
      isosurface {
	function  { f_sphere(x,y,z, 4) + f_noise3d(x*1/0.5,y*1/0.3,z*1/0.4)*0.8 }
	contained_by { sphere { 0, Radius } }
	evaluate 1, 10, 0.99
	max_gradient 1.4
      }
      scale             0.015
      translate         0.10*y
    }	
    #local C            = 0;
    #while ( C < 3 )
      object            {
        EsferaEspecial
        translate       C*y*0.20
        material                {
          MaterialEje
        }
      }
      #local C          = C+1;
    #end 
      isosurface {
	function  { f_ovals_of_cassini(x,y,z, -0.1, 0.4, 0.18, 6) }	
		//P0= Field strength
		//P1= Major radius - like the major radius of a torus
		//P2= Filling. Zero for a torus. With higher values the hole in the middle starts to fill up. Even higher values give an ellipsoid with a dimple
		//P3= Thickness. Higher values give plumper results
	contained_by { box { <-0.82, -0.35, -0.82>, <0.82, 0.35, 0.82> }}
	max_gradient 0.4
	scale           <0.5,0.1,0.5>
	material {MaterialEje}
      }

	#local LCorner = <-0.5, -0.5, -0.5>;  
	#local RCorner = <1.4, 0.5, 0.5>;
	isosurface {
		function  { f_blob2(x,y,z, 1, 1/0.2, 2, 1) }
			//P0= Separation (One comp at origin)
			//P1= Size (inv)
			//P2= Strength
			//P3= Threshold
		contained_by { box { LCorner, RCorner } }
		max_gradient 3.9
	  rotate        90*z
	  scale  <0.2,0.35,0.2> 
	  material { MaterialEje }
	  translate     +0.3*x+0.1*y	
	}
    scale       0.25	
  }
#end 

#macro ILFD_Instrumental6
  ( MaterialSuperior, MaterialSoporte, MaterialExtractor, MaterialBase )  
  union                 {  
    object              {
      ILFD_Lemniscata2
      rotate    90*x
      scale <0.3,0.1,0.3>
      translate 0.5*y
      material          { MaterialSuperior }
    }
    object              {
      ILFD_Hyptorus
      scale     0.025
      material          { MaterialBase }
    } 
    object              {
      ILFD_Through
      scale     <0.2,0.4,0.2>    
      rotate    45*y
      rotate    180*x
      translate 0.50*y  
      material          { MaterialSoporte }
    }
    object              {
      ILFD_Piriform
      scale     0.2
      material           {
        MaterialExtractor
      }    
      translate         0.15*x
    }
  }
#end

#macro ILFD_DefaultInstrumental1()
  object                        {
    #local L                    = ILFD_L;
    #local DiametroInterno      = 57.2*L;
    #local DiametroCrisol       = 71.5*L;
    ILFD_Instrumental1( DiametroCrisol, DiametroInterno,
      ILFD_DefaultTexturaCrisol, ILFD_DefaultTexturaContacto )
  }
#end  // #macro ILFD_DefaultInstrumental1()

#macro ILFD_DefaultInstrumental2()
  object                  {
    ILFD_Instrumental2(
      ILFD_DefaultTexturaPistilo, ILFD_DefaultTexturaContacto )
  }
#end

#macro ILFD_DefaultInstrumental3( Semilla )
  object                        {
    #local L                    = ILFD_L;  
    #local Radio                = 350*L;
    ILFD_Instrumental3( Semilla, Radio, 
        ILFD_DefaultMaterialCilindro, ILFD_DefaultMaterialEspiral,
        ILFD_DefaultTexturaAgarre, ILFD_DefaultTexturaCrisol, 
        ILFD_DefaultMaterialMagneto,
        ILFD_DefaultTexturaTapa )
  }
#end

#macro ILFD_DefaultInstrumental4()
  object                        {
    #local L                    = ILFD_L;
    ILFD_Instrumental4( ILFD_DefaultMaterialDestilador,
       ILFD_DefaultMaterialCuelloDestilador,
       ILFD_DefaultTexturaSoporteDestiladores )
  }
#end

#macro ILFD_DefaultInstrumental5()
  object                   {
    ILFD_Instrumental5(ILFD_DefaultMaterialCilindro)
  }
#end

#macro ILFD_DefaultInstrumental6()
  object                   {
    ILFD_Instrumental6(
      ILFD_DefaultMaterialSuperior6,
      ILFD_DefaultMaterialSoporte6, 
      ILFD_DefaultMaterialExtractor6,
      ILFD_DefaultMaterialPata6
    )
  }
#end

#macro ILFD_Laboratory( Semilla ) 
  union                                 {  
    #local S            = seed( Semilla ); 
    union                               {  
      #local C          = 0;
      #while ( C < 4 )        
        object                          {
          ILFD_DefaultInstrumental3( 100 )
          rotate          5*y*( rand( S )-0.5 )
          translate             C*0.70*y
        }                     
        #local C        = C+1;
      #end  
      translate         -2*x
    }   
    union                               {    
      #local C          = 0;
      #while ( C < 3 )        
      object                          { 
        ILFD_DefaultInstrumental6()  
        rotate          5*y*( rand( S )-0.5 )
        translate       0.40*y 
        translate       -0.75*x+1.00*C*x
      }
        #local C        = C+1;
      #end
    } 
    union                               {  
      #local C          = 0;
      #while ( C < 3 )      
        box                             {  
          -1.5*x-0.25*z, 2*x+0.25*z+0.05*y 
          translate     1.0*y*C
        }
        #local C        = C+1;
      #end  
      cylinder                          {  
        0, 2*y, 0.10
        translate       -1.375*x
      }
      cylinder                          {  
        0, 2*y, 0.10
        translate       +1.875*x
      }
    }  
    union                               { 
      #local C                          = 0;
      #while ( C < 2 )                        
        object                          {  
          ILFD_DefaultInstrumental4()
          rotate                5*y*( rand( S )-0.5 )
          translate             1.15*y     
          translate             y*C
          translate             ( 1-C )*x*0.15
        }
        object                          {  
          ILFD_DefaultInstrumental4() 
          rotate                5*y*( rand( S )-0.5 )
          rotate                90*y
          translate             1.15*y-0.3*x  
          translate             y*C           
          translate             ( 1-C )*x*0.15
        }
        #local C                        = C+1;
      #end
    } 
    union                               {   
      #local C                  = 0;
      #local MyX                = 0;
      #while ( C < 6 )                
        object                  {     
          ILFD_DefaultInstrumental5()    
          rotate                360*rand( S )*y
          scale 2
          translate             2.05*y+0.50*x+MyX
          #local MyX            = MyX+0.20*( 0.5+rand( S ) )*x;
          translate             0.1*( rand( S )-0.5 )*z
        }
        #local C                = C+1;
      #end
    }
    union                               {   
      #local C                  = 0;
      #local MyX                = 0;
      #while ( C < 5 )                
        object                  {     
          ILFD_DefaultInstrumental5()    
          rotate                360*rand( S )*y   
          rotate                1*(rand( S )-0.5 )
          scale 2
          translate             1.05*y-1.00*x+MyX
          #local MyX            = MyX+0.10*( 0.5+rand( S ) )*x;
          translate             0.1*( rand( S )-0.5 )*z
        }
        #local C                = C+1;
      #end
    }
    union                               {   
      #local C                  = 0;
      #local MyX                = 0;
      #while ( C < 8 )                
        object                  {     
          ILFD_DefaultInstrumental1()    
          rotate                360*rand( S )*y   
          scale 2
          translate             1.125*y+0.40*x+MyX
          #local MyX            = MyX+0.110*( 0.5+rand( S ) )*x;
          translate             0.15*( rand( S )-0.5 )*z
        }
        #local C                = C+1;
      #end
    }   
    union                               {   
      #local C                  = 0;
      #local MyX                = 0;
      #while ( C < 3 )                
        object                  {     
          ILFD_DefaultInstrumental2()    
          rotate                360*rand( S )*y   
          scale 2
          translate             1.095*y+1.30*x+MyX
          #local MyX            = MyX+0.20*( 0.5+rand( S ) )*x;
          translate             0.15*( rand( S )-0.5 )*z
        }
        #local C                = C+1;
      #end
    }                            
    #if ( ILFD_BanderaTexto )
      text {
        ttf "timrom.ttf" ILFD_Texto 0.25, 0
        scale             0.25
        translate         2.100*y-1.35*x-0.20*z     
        translate       ILFD_TranslateTexto*2
      }
      cylinder            {   
        0, 1.50*ILFD_FactorXTexto*x, 0.025    
        translate         0.25*y
        scale             0.25
        translate         2.100*y-1.35*x-0.20*z 
        translate       ILFD_TranslateTexto*2
      }
    #end
    texture { ILFD_DefaultTexturaMadera } 
    scale               0.5
  }
#end   
   
   