// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  15 julio 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//
// LFPL LlaveFrancesaPlomeriaLocal
// El archivo dibuja una llave fracesa pequena,
// proporciona una macro para modificar las caracteristicas principales.
//
// La macro default tiene tres parametros
// #macro LFPL_LlaveFrancesa( MoverGuia, AnguloOscilante, MoverRosca )
//      MoverGuia               : Valor real para abrir y cerrar
//              verticalmente.  Utilice valores positivos.
//      AnguloOscilante         : Vector para oscilar los dientes.
//              Utiliza el cilindro de ajuste como centro.
//      MoverRosca              : Aplica un translate adicional
//              al cuerpo de los dientes como vector.
//
// Las dimensiones de la llave francesa son:
//      Alto total              =   132.0*L
//      Frente                  =   -15.0*L..+17.5*L
//      Profundidad             =    15.0*L
// Se dibuja sobre el plano XZ hemisferio positivo,
// casi centrado en los otros planos.
// Los dientes de la llaven miran hacia X+, gravedad Y-.
//
// La siguiente macro permite mayor flexibilidad:
// #macro LFPL_LlaveFrancesaPlomeriaLocal(
//         MoverGuia, AnguloOscilante, MoverRosca,
//         AltoBase, AltoRosca, DiametroRosca,
//         AltoGuiaVertical, FrenteGuiaVertical,
//         ProfundidadGuiaVertical, GruesoDientes, FrenteDientes,
//         TexturaMetalica, TexturaBrillante, TexturaRosca, TexturaBase )
//      MoverGuia               : Valor real para abrir y cerrar
//              verticalmente.  Utilice valores positivos.
//      AnguloOscilante         : Vector para oscilar los dientes.
//              Utiliza el cilindro de ajuste como centro.
//      MoverRosca              : Aplica un translate adicional
//              al cuerpo de los dientes como vector.
//      AltoBase                : Alto referencia para la base.
//              Default es 120*L.
//      AltoRosca               : Alto del cilindro de ajuste.
//              Default es 7.15*L.
//      DiametroRosca           : Diametro del cilindro de ajuste.
//              Default es 14.3*L.
//      AltoGuiaVertical        : Referencia para el alto Z de la
//              columna guia de los dientes.  Default es 71.5*L.
//      FrenteGuiaVertical      : Referencia para el largo X de la
//              columna guia de los dientes.  Default es 10.7*L.
//      ProfundidadGuiaVertical : Referencia para la profundidad Z
//              de los dientes.  Default es 5.0*L.
//      GruesoDientes           : Grosor de los dientes.
//              Default es 1.19*L.
//      FrenteDientes           : Referencia para el largo X de los dientes.
//              Default es 17.5*L.
//      TexturaMetalica         : Textura principal a aplicar a la columna
//              guia de los dientes.  Default es LFPL_TexturaMetalica.
//      TexturaBrillante        : Textura de los dientes de agarre.
//              Default LFPL_TexturaMetalicaBrillante.
//      TexturaBase             : Textura de la base soporte.
//              Default es LFPF_TexturaBase
//      TexturaRosca            : Textura principal del cilindro de ajuste.
//              Default es LFPL_TexturaRosca
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare LFPL_DefaultTexturaMetalica
//      Textura principal a aplicar a la columna guia de los dientes.
// #declare LFPL_DefaultTexturaMetalicaBrillante
//      Textura de los dientes de agarre.
// #declare LFPL_DefaultTexturaBase
//      Textura de la base soporte.
// #declare LFPL_DefaultTexturaRosca
//      Textura principal del cilindro de ajuste.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare LFPL_TexturaMetalica                = texture  { ... }
//      Textura principal a aplicar a la columna guia de los dientes.
// #declare LFPL_TexturaMetalicaBrillante       = texture  { ... }
//      Textura de los dientes de agarre.
// #declare LFPL_TexturaBase                    = texture  { ... }
//      Textura de la base soporte.
// #declare LFPL_TexturaRosca                   = texture  { ... }
//      Textura principal del cilindro de ajuste.
// #declare LFPL_BanderaMarca                   = on;
//      Si se desactiva con "off" no escribe la marca.
// #declare LFPL_StringMarca                    = "POVRay"
//      Permite cambiar el mensaje de marca.
// #declare LFPL_CorrimientoYMarca              = 0;
//      Desplaza la marca en Y.  Positiva hacia Y+ como real.
// #declare LFPL_BanderaUnidades                = on;
//      Si se desactiva con "off" no escribe las unidades en la columna guia.
// #declare LFPL_StringUnidades                 = "7-LISA"
//      Mensaje para las unidades en la columna guia.
// #declare LFPL_CorrimientoYUnidades           = 0;
//      Desplaza el mensaje de unidades en Y.  Positivo hacia Y+ como real.
// #declare LFPL_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
//
// Para colocarlo simplemente
// #include "LFPL.inc"
// object        { LFPL_LlaveFrancesa( 0, 0, 0 ) }
//
// Otro ejemplo:
// #include "LFPL.inc"
// object        { LFPL_LlaveFrancesa( 0.010, 2*z+10*y, -0.001*x )
//
// Otra textura con modificadores:
// #include "LFPL.inc"
// #declare LFPL_TexturaMetalica        = texture       {
//   average
//   texture_map        {
//     [ 0.5 LFPL_DefaultTexturaMetalica ]
//     [ 0.5 Rust                        ]
//   }
// }
// object        {
//   LFPL_LlaveFrancesa( 0, 0, 0 )
// }
//
// Un ejemplo con la macro detallada
// #include "LFPL.inc"
// object               {
//   LFPL_LlaveFrancesaPlomeriaLocal( 0, 0, 0, 0.120, 0.00715, 0.0143,
//              0.0715, 0.0107, 0.005, 0.0715/60, 0.0175,
//              LFPL_TexturaMetalica, LFPL_TexturaMetalicaBrillante,
//              LFPL_TexturaRosca, LFPL_TexturaBase )
// }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "LFPL.inc"

#local FactorAcercamiento       = 10;

object                  {
  LFPL_LlaveFrancesa( 0, 2*z+10*y, -0.001*x )
  translate     -0.0675*y
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z  
}


