// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  1 julio 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//
// LSLE LlavinSeguridadLlaveExclusiva
// El archivo dibuja un Llavin con o sin llave.  Ademas ofrece
// macros para agregar accesorios.  Y permite variar algunas
// de sus caracteristicas basicas, incluyendo texturas.
//
// La macro del dibujo principal tiene un parametro.
// #macro LSLE_Llavin( FraccionBoton )
//      FraccionBoton           : Un valor de cero para pomo sencillo.
//              Negativo para agregar cerrojo, -1 sin giro, hasta -0.01
//              para casi 360 grados.
//              Positivo 1.0 para boton.  Aprieta el boton disminuyendo el valor
//              hasta 0.01.
//
// Para agrega los accesorios puede utilizar las siguentes macros.
// Crea la parte puerta del accesorio para trabar la puerta.
// #macro LSLE_AccesorioPuerta
//              ( FraccionAperturaMayor, FraccionAperturaMenor )
//      FraccionAperturaMayor   : 0.0 para cerrado, 1.0 para abierto.
//      FraccionAperturaMenor   : 0.0 para cerrado, 1.0 para abierto.
//
// Crea la parte pared del accesorio para trabar la puerta.
// #macro LSLE_AccesorioPared( )
//
// Las dimensiones del llavin son:
//      Diametro                :  53*L
//      Profundidad             :  52*L..54*L
// Sobresale casi centrado en el plano XY hacia el hemisferio Z-.
//
// Accesorio de puerta:
//      Profundidad en Z        : -13*L..44*L cerrado
//                                - 1*L..44*L abierto
//      Alto                    :  39*L
//      Ancho                   :  18*L
// Casi centrado en el plano XY.  La region interior a la puerta se ubica
// hacia Z+.  La traba mayor a la izquierda.
//
// Accesorio de pared:
//      Alto                    :  49*L
//      Frente                  : -14*L..10*L
//      Profundidad             :   8*L
// Semicentrado en el plano XY sobresale hacia Z+.
//
// La siguiente macro permite mayor flexibilidad:
// #macro LSLE_LlavinFundamental( GiroPomo, FraccionBoton,
//         RadioBasico, ProfundidadSoporte,
//         RadioColumna, ProfundidadColumna, RadioPomo, RadioBoton,
//         TexturaMetalica, TexturaMetalicaSecundaria, TexturaCerrojo )
//      GiroPomo                : Angulo en grados para girar el pomo.
//      FraccionBoton           : Un valor de cero para pomo sencillo.
//              Negativo para agregar cerrojo, -1 sin giro, hasta -0.01
//              para casi 360 grados.
//              Positivo 1.0 para boton.  Lo aprieta disminuyendo el valor
//              hasta 0.01.
//      RadioBasico             : Radio de la base del pomo.
//              Default es 26.5*L.
//      ProfundidadSoporte      : Referencia para la profundidad Z de base.
//              Default es 10*L.
//      RadioColumna            : Radio columna de soporte del pomo.
//              Default es 10*L.
//      ProfundidadColumna      : Referencia para la profundidad Z de la
//              columna soporte del pomo.  Default es 10.5*L.
//      RadioPomo               : Radio de la esfera del pomo.
//              Default es 19*L.
//      RadioBoton              : Radio de la perilla o cerrojo.
//              Default es 4.07*L.
//      TexturaMetalica         : Textura principal a aplicar al aparato.
//              Default es LSLE_DefaultTexturaMetalica.
//      TexturaMetalicaSecundaria               :
//              Textura para zonas de menor calidad.
//              Default es LSLE_DefaultTexturaMetalicaSecundaria.
//      TexturaCerrojo          : Textura para el cerrojo.
//              Default es LSLE_DefaultTexturaCerrojo.
//          
// Para varias el accesorio de puerta, puede usarse la macro siguiente:
// #macro LSLE_AccesorioPuertaLlaveExclusiva(
//          FraccionAperturaMayor, FraccionAperturaMenor,
//          Alto, Ancho, Grueso, RadioPrincipal,
//          ProfundidadCilindro, RadioTornillo, BanderaTornillo,
//          TexturaMetalica, TexturaCilindro, TexturaTornillo )
//      FraccionAperturaMayor   : 0.0 para cerrado, 1.0 para abierto.
//      FraccionAperturaMenor   : 0.0 para cerrado, 1.0 para abierto.
//      Alto                    : Alto del accesorio en Y.
//              Default es 39*L.
//      Ancho                   : Frente en X del accesorio.
//              Default es 18*L.
//      Grueso                  : Grueso de la placa principal.
//              Default es 1*L.
//      RadioPrincipal          : Radio referencia de la traba de puerta.
//              Default es 6.6*L.
//      ProfundidadCilindro     : Referencia para profundidad Z del cilindro
//              interior.  Default es 21*L.
//      RadioTornillo           : Radio para los cilindros de perforacin de los
//              tornillos.  Default es 2.1*L.
//      BanderaTornillo         : Valor "true" dibuja los tornillos, y valor
//              "false" no los dibuja.               
//      TexturaMetalica         : Textura a aplicar en la placa de puerta.
//              Default es LSLE_DefaultTexturaMetalica.
//      TexturaCilindro         : Textura a aplicar al cilindro interior.
//              Default es LSLS_DefaultTexturaCerrojo.
//      TexturaTornillo         : Textura a aplicar a los tornillos.
//              Default es LSLE_DefaultTexturaTornillo.  
//
// La siguiente macro corresponde al detalle del accesorio de pared.
// #macro LSLE_AccesorioParedLlaveExclusiva(
//          Alto, Ancho, Grueso, Fondo, RadioPrincipal, RadioTornillo,
//          BanderaTornillo, TexturaMetalica, TexturaNegra, TexturaTornillo )
//      Alto                    : Alto del accesorio en Y.  Default es 49*L.
//      Ancho                   : Ancho del accesorio en X.  Default es 20*L.
//      Grueso                  : Grueso de la placa.  Default es 1*L.
//      Fondo                   : Referencia para el fondo Z interior.
//              Default es 7*L.
//      RadioPrincipal          : Radio referencia para la traba correspondiente,
//              en el accesorio para puerta.  Default es 6.6*L.
//      RadioTornillo           : Radio del hueco para tornillo.  Default es 2.1*L.
//      BanderaTornillo         : Valor "true" dibuja los tornillos, y valor
//              "false" no los dibuja.
//      TexturaMetalica         : Textura a aplicar del metal.  
//              Default es LSLE_DefaultTexturaMetalica.                   
//      TexturaNegra            : Textura interior del accesorio de pared.
//              Default es LSLE_DefaultTexturaNegra.
//      TexturaTornillo         : Textura para los tornillos.
//              Default es LSLE_DefaultTexturaTornillo.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare LSLE_TexturaMetalica
//      Textura principal a aplicar a las estructuras.
// #declare LSLE_TexturaMetalicaSecundaria
//      Textura metalica para zonas de menor calidad.
// #declare LSLE_TexturaCerrojo
//      Textura para el cerrojo y el cilindro interior del accesorio de puerta.
// #declare LSLE_TexturaNegra
//      Textura para el compartimiento interno del accesorio de pared.
// #declare LSLE_TexturaTornillo
//      Textura para los tornillos.
// #declare LSLE_DifferenceAccesorioPuerta  
//      Define objeto volumen para aplicar en puerta y ubicar el accesorio de puerta.
// #declare LSLE_DifferenceAccesorioPared
//      Define objeto volumen para aplicar en pared y ubicar el accesorio de pared.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare LSLE_DefaultTexturaMetalica                 = texture  { ... }
//      Textura principal a aplicar a las estructuras.             
// #declare LSLE_DefaultTexturaMetalicaSecundaria       = texture  { ... }
//      Textura metalica para zonas de menor calidad.
// #declare LSLE_DefaultTexturaCerrojo                  = texture  { ... }
//      Textura para el cerrojo y el cilindro interior del accesorio de puerta.
// #declare LSLE_DefaultTexturaNegra                    = texture  { ... }
//      Textura para el compartimiento interno del accesorio de pared.
// #declare LSLE_DefaultTexturaTornillo                 = texture  { ... }
//      Textura para los tornillos.
// #declare LSLE_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
//
// Para colocarlo simplemente
// #include "LSLE.inc"
// object        { LSLE_Llavin( -1 ) }
//
// Otro ejemplo con modificador
// #include "LSLE.inc"
// #declare LSLE_DefaultTexturaMetalica        = texture       {
//   average
//   texture_map        {
//     [ 0.5 LSLE_TexturaMetalica ]
//     [ 0.5 Rust                 ]
//   }
// }
// object        {
//   LSLE_Llavin( 1 )
// }
//
// Un ejemplo con la macro detallada
// #include "LSLE.inc"
// object               {
//   LSLE_LlavinFundamental( 0, 1, 0.0266, 0.010, 0.010, 0.0105, 0.019, 0.00407,
//       LSLE_DefaultTexturaMetalica, LSLE_DefaultTexturaMetalicaSecundaria,
//       LSLE_DefaultTexturaCerrojo ) 
// }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "lsle.inc"

#local FactorAcercamiento       = 9;

union                   {
  object                {
    LSLE_Llavin(-0.3)
  }
  object                {
    LSLE_Llavin(1)
    translate           -0.060*x
  }
  object                  {
    LSLE_AccesorioPuerta( 0, 0 )
    rotate              180*z
    rotate              -90*y
    translate           +0.055*x
  }
  object                  {
    LSLE_AccesorioPared( )
    rotate              180*z
    rotate              +90*y
    translate           +0.075*x
  }
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z         
}


