// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 19 marzo 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// SMIE SandwicheraMultiIngredienteElectrica
// El archivo dibuja una sandwichera para uso domestico.
//
// La macro default tiene tres parametros
// #macro SMIE_Sandwichera
//         ( FraccionApertura, AnguloPerilla, DesplazamientoYTapa )
//      FraccionApertura        : Entre 0.0 para cerrado a 1.0
//                      para totalmente abierto, unos 120 grados.
//      AnguloPerilla           : Giro en grados de la perilla.
//      DesplazamientoYTapa     : Permite levantar la tapa en Y.
//                      Utilice unidades Lisa para acomodar
//                      emparedados gruesos.
//
// Las dimensiones de la sandwichera son ( sin incluir DesplazamientoYTapa ):
//      Alto total              =    80.0*L
//      Alto max                =   260.0*L
//      Frente                  =   230.0*L
//      Profundidad             =   -96.0*L..+120.0*L
// Se dibuja parcialmente centrado sobre el origen del plano XZ.
// El frente sobresale en direccion Z-, con gravedad Y-.
//
// La siguiente macro permite mayor flexibilidad:
// #macro SMIE_SandwicheraMultiIngredienteElectrica
//                ( FraccionApertura, AnguloPerilla, DesplazamientoYTapa,
//                  LadoFundamental, Curvatura, AltoBase,
//                  SeparacionGiro, FraccionCaliente, AltoPata,
//                  TexturaCaliente, TexturaMetalica,
//                  TexturaPata, TexturaPerilla,
//                  TexturaAgarradera, TexturaResorte,
//                  TexturaPlaca )
//      FraccionApertura        : Entre 0.0 para cerrado a 1.0
//                      para totalmente abierto, unos 120 grados.
//      AnguloPerilla           : Giro en grados de la perilla.
//      DesplazamientoYTapa     : Permite levantar la tapa en Y.
//                      Utilice unidades Lisa, para acomodar
//                      emparedados gruesos.
//      LadoFundamental         : Referencia para la medida del lado
//                      principal del aparato.  Default es 182*L.
//      Curvatura               : Radio de curvatura del borde.
//                      Default es 20*L.
//      AltoBase                : Referencia para el alto inferior
//                      de la base de calentamiento.  Default es 21.5*L.
//      SeparacionGiro          : Separacion del resorte de giro de la
//                      estructura principal.  Default es 18*L.
//      FraccionCaliente        : Referencia fraccionaria para controlar
//                      la dimension de la plancha de calentamiento.
//                      Default es 0.1.
//      AltoPata                : Altura de las patitas.  Default 14.2*L.
//      TexturaCaliente         : Textura a aplicar a la plancha
//                      de calentamiento.  Defaut es SMIE_TexturaCaliente.
//      TexturaMetalica         : Textura a aplicar a la zona metalica.
//                      Default es SMIE_TexturaMetalica.
//      TexturaPata             : Textura a aplicar a las patas.
//                      Default es SMIE_TexturaPata.
//      TexturaPerilla          : Textura a aplicar a las perillas.
//                      Default es SMIE_TexturaPerilla.
//      TexturaAgarradera       : Textura a aplicar a las agarraderas.
//                      Default es SMIE_TexturaAgarradera.
//      TexturaResorte          : Textura a aplicar al resorte de giro.
//                      Default es SMIE_TexturaResorte.
//      TexturaPlaca            : Textura a aplicar a la placa de giro.
//                      Default es SMIE_TexturaPlaca.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare SMIE_DefaultTexturaCaliente
//     Textura a aplicar a la plancha de calentamiento.
// #declare SMIE_DefaultTexturaMetalica
//      Textura a aplicar a la zona metalica.
// #declare SMIE_DefaultTexturaPata
//      Textura a aplicar a las patas.
// #declare SMIE_DefaultTexturaPerilla
//      Textura a aplicar a las perillas.
// #declare SMIE_DefaultTexturaAgarradera
//      Textura a aplicar a las agarraderas.
// #declare SMIE_DefaultTexturaResorte
//      Textura a aplicar al resorte de giro.
// #declare SMIE_DefaultTexturaPlaca
//      Textura a aplicar a la placa de giro.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare SMIE_TexturaCaliente                = texture { ... }
//     Textura a aplicar a la plancha de calentamiento.
// #declare SMIE_TexturaMetalica                = texture { ... }
//      Textura a aplicar a la zona metalica.
// #declare SMIE_TexturaPata                    = texture { ... }
//      Textura a aplicar a las patas.
// #declare SMIE_TexturaPerilla                 = texture { ... }
//      Textura a aplicar a las perillas.
// #declare SMIE_TexturaAgarradera              = texture { ... }
//      Textura a aplicar a las agarraderas.
// #declare SMIE_TexturaResorte                 = texture { ... }
//      Textura a aplicar al resorte de giro.
// #declare SMIE_TexturaPlaca                   = texture { ... }
//      Textura a aplicar a la placa de giro.
// #declare SMIE_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
//
// Para colocarlo simplemente
// #include "SMIE.inc"
// object        { SMIE_Sandwichera( 0, 0, 0 ) }
//
// Otro ejemplo con modificador
// #include "SMIE.inc"
// #declare SMIE_TexturaMetalica        = texture       {
//   average
//   texture_map        {
//     [ 0.5 SMIE_DefaultTexturaMetalica ]
//     [ 0.5 Rust                        ]
//   }
// }
// object        {
//      SMIE_Sandwichera( 0, 0, 0 )
// }
//
// Un ejemplo con la macro de texturas
// #include "SMIE.inc"
// object               {
//   SMIE_SandwicheraMultiIngredienteElectrica( 0, 0, 0,
//         0.182, 0.02, 0.025, 0.018, 0.1, 0.0142,
//         SMIE_TexturaCaliente, SMIE_TexturaMetalica,
//         SMIE_TexturaPata, SMIE_TexturaPerilla,
//         SMIE_TexturaAgarradera, SMIE_TexturaResorte,
//         SMIE_TexturaPlaca )
// }
//

#include "shapes.inc"

#declare SMIE_DefaultTexturaMetalica    =
  texture                       {
    pigment { Silver }
    normal      {
      bumps
      scale     0.1
    }
    finish { metallic }
  }

#declare SMIE_DefaultTexturaPlaca       =
  texture                       {
    pigment { Silver*0.65 }
    normal              {
      onion
      scale             0.05
      turbulence        0.5
    }
    finish      { metallic }
  }

#declare SMIE_DefaultTexturaResorte     =
  texture                       {
    pigment { Silver*0.65 }
    normal      {
      granite
    }
    finish  { metallic }
  }

#declare SMIE_DefaultTexturaAgarradera  =
  texture                       {
    pigment     {
      Gray20
    }
    normal {
      bumps
      scale     0.1
    }
  }

#declare SMIE_DefaultTexturaCaliente    =
  texture                       {
    pigment                     {
      granite
      pigment_map               {
        [ 0.0 Gray15 ]
        [ 1.0 Gray30 ]
      }
    }
    scale               0.01
  }

#declare SMIE_DefaultTexturaPata        =
  texture                       {
    SMIE_DefaultTexturaCaliente
  }

#declare SMIE_Textura1                  =
  texture                       {
    pigment                     {
      radial
      frequency         20
      pigment_map               {
        [ 0.0 Gray25 ]
        [ 0.5 Gray25 ]
        [ 0.5 Gray40 ]
        [ 1.0 Gray40 ]
      }
    }
    normal                      {
      radial
      frequency         20
    }
  }

#declare SMIE_Textura2                  =
  texture                       {
    pigment                     {
      radial
      frequency         5
      pigment_map               {
        [ 0.0 Red*0.75    ]
        [ 1.0 Gray20 ]
      }
    }
  }

#declare SMIE_DefaultTexturaPerilla     =
  texture                       {
    cylindrical
    rotate              90*x
    scale               0.01
    texture_map                 {
      [ 0.0 SMIE_Textura1 ]
      [ 0.65 SMIE_Textura1 ]
      [ 0.65 SMIE_Textura2 ]
      [ 1.0 SMIE_Textura2 ]
    }
  }

#declare SMIE_TexturaPlaca              =
  texture                               {
    SMIE_DefaultTexturaPlaca
  }

#declare SMIE_TexturaResorte            =
  texture                               {
    SMIE_DefaultTexturaResorte
  }

#declare SMIE_TexturaAgarradera         =
  texture                       {
    SMIE_DefaultTexturaAgarradera
  }

#declare SMIE_TexturaPerilla            =
  texture                       {
    SMIE_DefaultTexturaPerilla
  }
  
#declare SMIE_TexturaCaliente           =
  texture                       {
    SMIE_DefaultTexturaCaliente
  }

#declare SMIE_TexturaMetalica           =
  texture                       {
    SMIE_DefaultTexturaMetalica
  }

#declare SMIE_TexturaPata               =
  texture                       {
    SMIE_DefaultTexturaPata
  }

#declare SMIE_L                 = 0.001;

#macro SMIE_XYRoundSquare( Lado, Radio, Prof )
  union                         {
    box                         {
      < -Lado/2+Radio   , -Lado/2       , -Prof/2       >,
      < +Lado/2-Radio   , +Lado/2       , +Prof/2       >
    }
    box                         {
      < -Lado/2         , -Lado/2+Radio , -Prof/2       >,
      < +Lado/2         , +Lado/2-Radio , +Prof/2       >
    }
    #local C                    = 0;
    #while ( C < 4 )
      cylinder                  {
        -Prof/2*z               , +Prof/2*z             , Radio
        translate               ( -Lado/2+Radio )*( x+y )
        rotate                  90*z*C
      }
      #local C                  = C+1;
    #end  // #while ( C < 4 )
  }
#end  // #macro SMIE_XYRoundSquare

#macro SMIE_XYRoundBordeSquare( Lado, Radio, Prof, Grueso )
  difference                    {
    SMIE_XYRoundSquare( Lado+Grueso/2, Radio,   Prof )
    SMIE_XYRoundSquare( Lado-Grueso/2, Radio, 2*Prof )
  }  // difference
#end  // #macro

#macro SMIE_SandwicheraMultiIngredienteElectrica
                ( FraccionApertura, AnguloPerilla, DesplazamientoYTapa,
                  LadoFundamental, Curvatura, AltoBase,
                  SeparacionGiro, FraccionCaliente, AltoPata,
                  TexturaCaliente, TexturaMetalica,
                  TexturaPata, TexturaPerilla,
                  TexturaAgarradera, TexturaResorte,
                  TexturaPlaca )
  union                         {
    #local ProfBase             = FraccionCaliente*AltoBase;
  #local ZonaCaliente           =
    union                       {
      SMIE_XYRoundSquare( LadoFundamental, Curvatura, ProfBase )
      SMIE_XYRoundBordeSquare( 0.95*LadoFundamental,
         Curvatura-0.025*LadoFundamental, 6*ProfBase, 0.020*LadoFundamental )
      SMIE_XYRoundBordeSquare( 0.90*LadoFundamental,
         Curvatura-0.050*LadoFundamental,
         5.0*ProfBase, 0.020*LadoFundamental )
      box                       {
        < -0.90*LadoFundamental/2       , -0.010*LadoFundamental        ,
          -2.5*ProfBase                 >,
        < +0.90*LadoFundamental/2       , +0.010*LadoFundamental        ,
          +2.5*ProfBase                 >
      }
      box                       {
        < -0.90*LadoFundamental/2       , -0.010*LadoFundamental        ,
          -2.5*ProfBase                 >,
        < +0.90*LadoFundamental/2       , +0.010*LadoFundamental        ,
          +2.5*ProfBase                 >
        rotate                  90*z
      }
      #local E                          = 0;
      #while ( E < 4 )
        #local C                          = 0;
        #while ( C < 7 )
          #local D                        = 0;
          #while ( D < 7 )
            difference                    {
              box                         {
                < -LadoFundamental/80, -LadoFundamental/80, -2.5*ProfBase >,
                < +LadoFundamental/80, +LadoFundamental/80, +2.5*ProfBase >
              }
              sphere                      {
                -2.5*ProfBase*z,
                LadoFundamental/100
              }
              sphere                      {
                +2.5*ProfBase*z,
                LadoFundamental/100
              }
              translate                   LadoFundamental/17*x*( C+0.75 )+
                                          LadoFundamental/17*y*( D+0.75 )
              rotate                      90*E*z
            }
            #local D                      = D+1;
          #end  // #while
          #local C                        = C+1;
        #end  // #while ( C < 7 )
        #local E                          = E+1;
      #end  // #while ( E < 4 )
      rotate            90*x
      texture                   {
        TexturaCaliente
      }  // texture
    }  // union
    // local ZonaCaliente
    
    object                      {
      ZonaCaliente
    }
    difference                  {
      superellipsoid              {
        <0.2, 0.2 >
        scale             < 0.995*LadoFundamental/2, AltoBase,
                                0.995*LadoFundamental/2 >
//      rotate            90*x
      }
      plane                     { -y, 0 }
      translate                 -ProfBase/2*y
      texture                   {
        TexturaMetalica
      }
    }
    cylinder                    {
      -LadoFundamental/4*z      , -1.005*LadoFundamental/2*z ,
      0.05*LadoFundamental
      translate -0.06*LadoFundamental*y
      texture                   {
        TexturaMetalica
      }
//      normal    { agate scale 0.001 }
    }
    union                       {
      cylinder                  {
        0                         , -0.005*LadoFundamental*z,
        1
      }
      cylinder                  {
        0                         , -0.050*LadoFundamental*z,
        0.5
      }
      cone                      {
        -0.005*LadoFundamental*z                       , 1,
        -0.030*LadoFundamental*z                        , 0
      }
      difference                {
        cylinder                {
          -0.05*x, +0.05*x
          0.050*LadoFundamental
          scale 1.2/LadoFundamental/0.050*y
        }
        plane                   {
          y, 0
        }
      }
      scale              <0.0475*LadoFundamental,0.0475*LadoFundamental,1>
      rotate            AnguloPerilla*z
      texture                   {
        TexturaPerilla
      }
      translate                 -1.005*LadoFundamental/2*z
                                -0.06*LadoFundamental*y
    }
    superellipsoid              {
      <0.3,0.3>
      scale             0.075*LadoFundamental*<1,1,1>
      translate         -AltoBase*y+0.35*LadoFundamental*z
      texture                   {
        TexturaAgarradera
      }
    }
    #local C                    = 0;
    #while ( C < 4 )
      difference                  {
        prism                       {
          conic_sweep
          0.5, 1, 5,
          <-0.5,-0.5>*0.1*LadoFundamental,
          <-0.5,+0.5>*0.1*LadoFundamental,
          <+0.5,+0.5>*0.1*LadoFundamental,
          <+0.5,-0.5>*0.1*LadoFundamental,
          <-0.5,-0.5>*0.1*LadoFundamental
        }
        difference                  {
        prism                       {
          conic_sweep
          0.5, 1, 5,
          <-0.5,-0.5>*0.1*LadoFundamental,
          <-0.5,+0.5>*0.1*LadoFundamental,
          <+0.5,+0.5>*0.1*LadoFundamental,
          <+0.5,-0.5>*0.1*LadoFundamental,
          <-0.5,-0.5>*0.1*LadoFundamental
          scale   <0.8,1.001,0.8>
        }
          plane                 {
            y, 0.700
          }
        }
        plane                     {
          x, 0
          rotate          -2*z
          rotate          -45*y
          translate       0.75*y
        }
        scale             -4*AltoPata*y
  //      scale             10
        translate -AltoBase*y+3*AltoPata*y-2.5*ProfBase*y
        translate         +0.35*(x+z)*LadoFundamental
        rotate          90*y*C
        texture { TexturaPata }
      }
      #local C                  = C+1;
    #end
    #local C                    = 0;
    #while ( C < 2 )
          prism                 {
            cubic_spline
            linear_sweep
            0, 1,
            7,
            <+0.50,-1.10>,
            <+0.00,-0.20>,
            <-0.80,+0.00>,
            <+0.40,+0.30>,
            <+0.50,-1.10>,
            <+0.00,-0.20>,
            <-0.80,+0.00>
            rotate              90*z
            scale               <0.01,-0.1,0.1>*LadoFundamental
            translate           +LadoFundamental/2*z
                                +SeparacionGiro*z
            translate           -0.26*LadoFundamental*x
            scale               (2*C-1)*x
            texture             {
              TexturaPlaca
            }
          }
      #local C                  = C+1;
    #end
    cylinder                    {
      -0.28*LadoFundamental*x, +0.28*LadoFundamental*x,
      0.010*LadoFundamental
      translate         +LadoFundamental*y*0.03
      translate         +LadoFundamental/2*z
                        +SeparacionGiro*z
      texture                   {
        TexturaPlaca
      }
    }
    union                       {
      object                    {
        ZonaCaliente
      }
      difference                  {
        superellipsoid              {
          <0.2, 0.2 >
          scale             < 0.995*LadoFundamental/2, AltoBase,
                                  0.995*LadoFundamental/2 >
  //      rotate            90*x
        }
        superellipsoid              {
          <0.2, 0.2 >
          scale             < 0.995*LadoFundamental/2, AltoBase,
                                  0.995*LadoFundamental/2 >*0.99
  //      rotate            90*x
        }
        cylinder                {
          0                     , LadoFundamental*y,
          0.030*LadoFundamental
          translate             -0.35*LadoFundamental*z
        }
        plane                     { y, 0 }
        translate                 ProfBase/2*y
        texture                   {
          TexturaMetalica
        }
      }
      difference                {
        object                  {
          SMIE_XYRoundSquare( LadoFundamental/3,
            LadoFundamental/20, LadoFundamental/80 )
        }
        plane                   {
          y, 0
        }
        plane                   {
          -z, 0
        }
        texture                 {
          TexturaAgarradera
        }
        translate               -LadoFundamental/2*z+LadoFundamental/80*y
      }
      prism                     {
        linear_sweep
        -0.5, +0.5, 7,
        <+0.00,+0.00>,
        <+1.50,+0.40>,
        <+1.30,-0.10>,
        <+0.35,-0.12>,
        <+0.50,-1.00>,
        <+0.30,-1.00>,
        <+0.00,+0.00>
        rotate                  90*z
        scale                   < +1/3.25 , +1/15, +1/15 >*LadoFundamental
        translate               -LadoFundamental*z/2
                                +LadoFundamental*y/30
        texture                 {
          TexturaAgarradera
        }
      }
      #local C                  = 0;
      #while ( C < 40 )
        torus                   {
          1             , 0.25
          rotate        110*z
          scale                 0.025*LadoFundamental
          translate             +0.5*( C/39-0.5 )*LadoFundamental*x
          translate             +0.5*LadoFundamental*z
                                +SeparacionGiro*z
          texture               {
            TexturaResorte
          }
        }
        #local C                = C+1;
      #end
      #local C                  = 0;
      #while ( C < 2 )
        union                   {
          prism                 {
            cubic_spline
            linear_sweep
            0, 1,
            7,
            <+1.00,-1.10>,
            <+0.00,-0.20>,
            <-1.00,+0.00>,
            <+0.40,+0.30>,
            <+1.00,-1.10>,
            <+0.00,-0.20>,
            <-1.00,+0.00>
            rotate              90*z
            scale               <0.01,0.1,0.1>*LadoFundamental
            translate           +LadoFundamental/2*z
                                +SeparacionGiro*z
            translate           -0.25*LadoFundamental*x
          }
          texture               {
            TexturaPlaca
          }
          scale                 ( 2*C-1 )*x
        }
        #local C                = C+1;
      #end
      translate                 -SeparacionGiro*z
      translate                 -0.5*LadoFundamental*z
      rotate                    +FraccionApertura*120*x
      translate                 +0.5*LadoFundamental*z
      translate                 +SeparacionGiro*z
      translate                 2.5*ProfBase*y
      translate                 DesplazamientoYTapa*y
    }
    #local C                    = 0;
    #while ( C < 2 )
      difference                {
        prism                   {
          linear_sweep
          -0.5, 0.5, 7,
          <0,0>,
          <0,-1>,
          <0.2,-0.95>,
          <0.3,-0.3>,
          <0.975,-0.2>,
          <1,-0.05>,
          <0,0>
          rotate                -90*x
          scale                 <0.125,0.075,0.5>*LadoFundamental
          translate             +0.475*LadoFundamental*x-0.01*LadoFundamental*y
        }
        box                     {
          <-0.1, -LadoFundamental, -LadoFundamental/8 >,
          < LadoFundamental/25, LadoFundamental, +LadoFundamental/8 >
          translate             +LadoFundamental/2*x
        }
        cylinder                {
          -LadoFundamental*y, +LadoFundamental*y,
          LadoFundamental/25
          translate             +LadoFundamental/2*x
                                -LadoFundamental/8*z
        }
        cylinder                {
          -LadoFundamental*y, +LadoFundamental*y,
          LadoFundamental/25
          translate             +LadoFundamental/2*x
                                +LadoFundamental/8*z
        }
        cylinder                {
          -y, y, 0.0020
          translate             +0.6000000*LadoFundamental*x
          scale                 <1,1,23>
        }
        texture                 {
          TexturaAgarradera
        }
        rotate                  180*y*C
      }
      #local C                  = C+1;
    #end  // #while ( C < 2 )
    translate           AltoBase*y+AltoPata*y+2.5*ProfBase
  }  // union
#end

#macro SMIE_Sandwichera
         ( FraccionApertura, AnguloPerilla, DesplazamientoYTapa )
  object                        {
    #local L                    = SMIE_L;
    #local LadoFundamental      = 182.0*L;
    #local Curvatura            =  20.0*L;
    #local AltoBase             =  21.5*L;
    #local SeparacionGiro       =  18.0*L;
    #local FraccionCaliente     =   0.1;
    #local AltoPata             =  14.2*L;
    SMIE_SandwicheraMultiIngredienteElectrica(
      FraccionApertura, AnguloPerilla, DesplazamientoYTapa,
      LadoFundamental, Curvatura, AltoBase,
      SeparacionGiro, FraccionCaliente, AltoPata,
      SMIE_TexturaCaliente, SMIE_TexturaMetalica,
      SMIE_TexturaPata, SMIE_TexturaPerilla,
      SMIE_TexturaAgarradera, SMIE_TexturaResorte,
      SMIE_TexturaPlaca
    )
  }  // union
#end  // #macro SMIE_Sandwichera

