// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 19 marzo 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// SMIE SandwicheraMultiIngredienteElectrica
// El archivo dibuja una sandwichera para uso domestico.
//
// La macro default tiene tres parametros
// #macro SMIE_Sandwichera
//         ( FraccionApertura, AnguloPerilla, DesplazamientoYTapa )
//      FraccionApertura        : Entre 0.0 para cerrado a 1.0
//                      para totalmente abierto, unos 120 grados.
//      AnguloPerilla           : Giro en grados de la perilla.
//      DesplazamientoYTapa     : Permite levantar la tapa en Y.
//                      Utilice unidades Lisa para acomodar
//                      emparedados gruesos.
//
// Las dimensiones de la sandwichera son ( sin incluir DesplazamientoYTapa ):
//      Alto total              =    80.0*L
//      Alto max                =   260.0*L
//      Frente                  =   230.0*L
//      Profundidad             =   -96.0*L..+120.0*L
// Se dibuja parcialmente centrado sobre el origen del plano XZ.
// El frente sobresale en direccion Z-, con gravedad Y-.
//
// La siguiente macro permite mayor flexibilidad:
// #macro SMIE_SandwicheraMultiIngredienteElectrica
//                ( FraccionApertura, AnguloPerilla, DesplazamientoYTapa,
//                  LadoFundamental, Curvatura, AltoBase,
//                  SeparacionGiro, FraccionCaliente, AltoPata,
//                  TexturaCaliente, TexturaMetalica,
//                  TexturaPata, TexturaPerilla,
//                  TexturaAgarradera, TexturaResorte,
//                  TexturaPlaca )
//      FraccionApertura        : Entre 0.0 para cerrado a 1.0
//                      para totalmente abierto, unos 120 grados.
//      AnguloPerilla           : Giro en grados de la perilla.
//      DesplazamientoYTapa     : Permite levantar la tapa en Y.
//                      Utilice unidades Lisa, para acomodar
//                      emparedados gruesos.
//      LadoFundamental         : Referencia para la medida del lado
//                      principal del aparato.  Default es 182*L.
//      Curvatura               : Radio de curvatura del borde.
//                      Default es 20*L.
//      AltoBase                : Referencia para el alto inferior
//                      de la base de calentamiento.  Default es 21.5*L.
//      SeparacionGiro          : Separacion del resorte de giro de la
//                      estructura principal.  Default es 18*L.
//      FraccionCaliente        : Referencia fraccionaria para controlar
//                      la dimension de la plancha de calentamiento.
//                      Default es 0.1.
//      AltoPata                : Altura de las patitas.  Default 14.2*L.
//      TexturaCaliente         : Textura a aplicar a la plancha
//                      de calentamiento.  Defaut es SMIE_TexturaCaliente.
//      TexturaMetalica         : Textura a aplicar a la zona metalica.
//                      Default es SMIE_TexturaMetalica.
//      TexturaPata             : Textura a aplicar a las patas.
//                      Default es SMIE_TexturaPata.
//      TexturaPerilla          : Textura a aplicar a las perillas.
//                      Default es SMIE_TexturaPerilla.
//      TexturaAgarradera       : Textura a aplicar a las agarraderas.
//                      Default es SMIE_TexturaAgarradera.
//      TexturaResorte          : Textura a aplicar al resorte de giro.
//                      Default es SMIE_TexturaResorte.
//      TexturaPlaca            : Textura a aplicar a la placa de giro.
//                      Default es SMIE_TexturaPlaca.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare SMIE_DefaultTexturaCaliente
//     Textura a aplicar a la plancha de calentamiento.
// #declare SMIE_DefaultTexturaMetalica
//      Textura a aplicar a la zona metalica.
// #declare SMIE_DefaultTexturaPata
//      Textura a aplicar a las patas.
// #declare SMIE_DefaultTexturaPerilla
//      Textura a aplicar a las perillas.
// #declare SMIE_DefaultTexturaAgarradera
//      Textura a aplicar a las agarraderas.
// #declare SMIE_DefaultTexturaResorte
//      Textura a aplicar al resorte de giro.
// #declare SMIE_DefaultTexturaPlaca
//      Textura a aplicar a la placa de giro.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare SMIE_TexturaCaliente                = texture { ... }
//     Textura a aplicar a la plancha de calentamiento.
// #declare SMIE_TexturaMetalica                = texture { ... }
//      Textura a aplicar a la zona metalica.
// #declare SMIE_TexturaPata                    = texture { ... }
//      Textura a aplicar a las patas.
// #declare SMIE_TexturaPerilla                 = texture { ... }
//      Textura a aplicar a las perillas.
// #declare SMIE_TexturaAgarradera              = texture { ... }
//      Textura a aplicar a las agarraderas.
// #declare SMIE_TexturaResorte                 = texture { ... }
//      Textura a aplicar al resorte de giro.
// #declare SMIE_TexturaPlaca                   = texture { ... }
//      Textura a aplicar a la placa de giro.
// #declare SMIE_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
//
// Para colocarlo simplemente
// #include "SMIE.inc"
// object        { SMIE_Sandwichera( 0, 0, 0 ) }
//
// Otro ejemplo con modificador
// #include "SMIE.inc"
// #declare SMIE_TexturaMetalica        = texture       {
//   average
//   texture_map        {
//     [ 0.5 SMIE_DefaultTexturaMetalica ]
//     [ 0.5 Rust                        ]
//   }
// }
// object        {
//      SMIE_Sandwichera( 0, 0, 0 )
// }
//
// Un ejemplo con la macro de texturas
// #include "SMIE.inc"
// object               {
//   SMIE_SandwicheraMultiIngredienteElectrica( 0, 0, 0,
//         0.182, 0.02, 0.025, 0.018, 0.1, 0.0142,
//         SMIE_TexturaCaliente, SMIE_TexturaMetalica,
//         SMIE_TexturaPata, SMIE_TexturaPerilla,
//         SMIE_TexturaAgarradera, SMIE_TexturaResorte,
//         SMIE_TexturaPlaca )
// }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "smie.inc"

#local FactorAcercamiento       = 6;

object                  {
  SMIE_Sandwichera( 1.00, -40, 0 )
  translate     -0.085*y
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
}




