// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 19 febrero 2014
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//        
// Este archivo dibuja una serpiente sencilla.
//
// #macro SRAV_Serpiente( MyArreglo, AvanceLengua )   
//      MyArreglo               : describe el movimiento (ver adelante)
//      AvanceLengua            : fraccion real entre 0.0 y 1.0 para
//              meter y sacar la lengua respectivamente.
//  
// #declare MyArreglo   = array [ GirosSolicitados ][ 4/5 ]
//      GirosSolicitados        : indica el total de giros a solicitar
//         El numero es libre, con un maximo de 55,
//         El giro tiene el siguiente formato
//        { IdentificadorGiro, RotarX, RotarY, RotarZ }
//         o bien este otro
//        { IdentificadorGiro, RotarX, RotarY, RotarZ, on/off }
//         la bandera off desactiva el giro, lo que podria ser util
//         al disenar.
//         Utiliza rotacion acumulada.
//         Cada tipo de giro solo debe encontarse una unica vez
//         en cualquier orden.
// IdentificadorGiro    : Numero o etiqueta clave que identifica el giro
// RotarX               : Indica la rotacion en grados respecto eje X*,
//        este es el eje X, luego de aplicar rotacion en
//        en otros puntos de control
// RotarY               : Indica rotacion acumulada respecto eje Y*,
//        este es el eje Y luego de aplicar RotarX
// RotarZ               : Indica rotacion acumulada respecto eje Z*,
//        este es el eje Z luego de aplicar RotarX y RotarY
// on/off               : variable optativa,
//        si off no se gira, util en diseno y animacion.
//
// La siguiente es la lista de IdentificadorGiro admisibles:
// SRAV_EjeCentral        = Ubicado al centro del tronco     
//      Zona delantera
// SRAV_EjeCentralD01     = Ubicado delante de SRAV_EjeCentral
// SRAV_EjeCentralD02     = Ubicado delante de SRAV_EjeCentralD01
// SRAV_EjeCentralD03     = Ubicado delante de SRAV_EjeCentralD02
// SRAV_EjeCentralD04     = Ubicado delante de SRAV_EjeCentralD03
// SRAV_EjeCentralD05     = Ubicado delante de SRAV_EjeCentralD04
// SRAV_EjeCentralD06     = Ubicado delante de SRAV_EjeCentralD05
// SRAV_EjeCentralD07     = Ubicado delante de SRAV_EjeCentralD06
// SRAV_EjeCentralD08     = Ubicado delante de SRAV_EjeCentralD07
// SRAV_EjeCentralD09     = Ubicado delante de SRAV_EjeCentralD08
// SRAV_EjeCentralD10     = Ubicado delante de SRAV_EjeCentralD09
// SRAV_EjeCentralD11     = Ubicado delante de SRAV_EjeCentralD10
// SRAV_EjeCentralD12     = Ubicado delante de SRAV_EjeCentralD11
// SRAV_EjeCentralD13     = Ubicado delante de SRAV_EjeCentralD12
// SRAV_EjeCentralD14     = Ubicado delante de SRAV_EjeCentralD13
// SRAV_EjeCentralD15     = Ubicado delante de SRAV_EjeCentralD14
// SRAV_EjeCentralD16     = Ubicado delante de SRAV_EjeCentralD15
// SRAV_EjeCentralD17     = Ubicado delante de SRAV_EjeCentralD16
// SRAV_EjeCentralD18     = Ubicado delante de SRAV_EjeCentralD17
// SRAV_EjeCentralD19     = Ubicado delante de SRAV_EjeCentralD18
// SRAV_EjeCentralD20     = Ubicado delante de SRAV_EjeCentralD19
// SRAV_EjeCentralD21     = Ubicado delante de SRAV_EjeCentralD20
// SRAV_EjeCentralD22     = Ubicado delante de SRAV_EjeCentralD21
// SRAV_EjeCentralD23     = Ubicado delante de SRAV_EjeCentralD22
// SRAV_EjeCentralD24     = Ubicado delante de SRAV_EjeCentralD23
// SRAV_EjeCentralD25     = Ubicado delante de SRAV_EjeCentralD24
// SRAV_EjeCentralD26     = Ubicado delante de SRAV_EjeCentralD25
// SRAV_EjeCentralD27     = Ubicado delante de SRAV_EjeCentralD26 
//      Zona posterior
// SRAV_EjeCentralP01     = Ubicado atras de SRAV_EjeCentral
// SRAV_EjeCentralP02     = Ubicado atras de SRAV_EjeCentralP01
// SRAV_EjeCentralP03     = Ubicado atras de SRAV_EjeCentralP02
// SRAV_EjeCentralP04     = Ubicado atras de SRAV_EjeCentralP03
// SRAV_EjeCentralP05     = Ubicado atras de SRAV_EjeCentralP04
// SRAV_EjeCentralP06     = Ubicado atras de SRAV_EjeCentralP05
// SRAV_EjeCentralP07     = Ubicado atras de SRAV_EjeCentralP06
// SRAV_EjeCentralP08     = Ubicado atras de SRAV_EjeCentralP07
// SRAV_EjeCentralP09     = Ubicado atras de SRAV_EjeCentralP08
// SRAV_EjeCentralP10     = Ubicado atras de SRAV_EjeCentralP09
// SRAV_EjeCentralP11     = Ubicado atras de SRAV_EjeCentralP10
// SRAV_EjeCentralP12     = Ubicado atras de SRAV_EjeCentralP11
// SRAV_EjeCentralP13     = Ubicado atras de SRAV_EjeCentralP12
// SRAV_EjeCentralP14     = Ubicado atras de SRAV_EjeCentralP13
// SRAV_EjeCentralP15     = Ubicado atras de SRAV_EjeCentralP14
// SRAV_EjeCentralP16     = Ubicado atras de SRAV_EjeCentralP15
// SRAV_EjeCentralP17     = Ubicado atras de SRAV_EjeCentralP16
// SRAV_EjeCentralP18     = Ubicado atras de SRAV_EjeCentralP17
// SRAV_EjeCentralP19     = Ubicado atras de SRAV_EjeCentralP18
// SRAV_EjeCentralP20     = Ubicado atras de SRAV_EjeCentralP19
// SRAV_EjeCentralP21     = Ubicado atras de SRAV_EjeCentralP20
// SRAV_EjeCentralP22     = Ubicado atras de SRAV_EjeCentralP21
// SRAV_EjeCentralP23     = Ubicado atras de SRAV_EjeCentralP22
// SRAV_EjeCentralP24     = Ubicado atras de SRAV_EjeCentralP23
// SRAV_EjeCentralP25     = Ubicado atras de SRAV_EjeCentralP24
// SRAV_EjeCentralP26     = Ubicado atras de SRAV_EjeCentralP25
// SRAV_EjeCentralP27     = Ubicado atras de SRAV_EjeCentralP26
//      
// La siguiente macro permite crear el mismo dibujo con mas control
// sobre las caracteristicas principales.
// #macro SRAV_SerpienteReptilAnimalVivo
//              ( MyArreglo, AvanceLengua, LargoPrincipal, 
//                RadioPrincipal, FactorT, LargoCabeza,
//                FactorCabeza, CorreccionZOjo, FinoCola, 
//                FactorGordo, TexturaPrincipal, TexturaCabeza,
//                TexturaCornea, TexturaEsclerotida, TexturaIris, 
//                TexturaBoca, TexturaLengua )
//      MyArreglo               : Describe el movimiento (ver arriba)
//      AvanceLengua            : Fraccion real entre 0.0 y 1.0 para
//              meter y sacar la lengua respectivamente.
//      LargoPrincipal          : Referencia para el largo de la serpiente. 
//              Default es 3000*L.
//      RadioPrincipal          : Referencia para el radio del animal.
//              Default es 60*L.
//      FactorT                 : Controla el valor threshold del blob.
//              Default es 0.9.
//      LargoCabeza             : Referencia para el largo de la cabeza. 
//              Default es 100*L.
//      FactorCabeza            : Para incrementa o reducir el grueso de la cabeza.
//              Default es 0.3.
//      CorreccionZOjo          : Corrige en Z la posicion del ojo.  Positivo hacia afuera.
//              Default es 15*L.
//      FinoCola                : Referencia como entero para el grado de finura de la cola.
//              Default es 8.
//      FactorGordo             : Referencia para engrosar al centro la serpiente.
//              Default es 0.05.
//      TexturaPrincipal        : Textura principal de la serpiente.
//              Default es SRAV_TexturaPrincipal.
//      TexturaCabeza           : Textura para aplicar a la cabeza.  Origen en cabeza.
//              Default es SRAV_TexturaCabeza.
//      TexturaCornea           : Textura para aplicar a la cornea.
//              Default es SRAV_TexturaCornea.
//      TexturaEsclerotida      : Textura para aplicar a la esclerotida.
//              Default es SRAV_TexturaEsclerotida.
//      TexturaIris             : Textura para aplicar al iris.
//              Default es SRAV_TexturaIris.                       
//      TexturaBoca             : Textura para aplicar a la boca.  Se aplica por diferencia,
//              poco perceptible.  Default es SRAV_TexturaBoca.
//      TexturaLengua           : Textura para aplicar a la lengua.  
//              Default es SRAV_TexturaLengua.
//  
// Crea el dibujo de una serpiente en estilo 3D
// con el centro del tronco en el origen y la
// cabeza orientada hacia X+.  Las siguientes son caracteristicas
// al suprimir todos los giros.
// LargoTotal en X              : -1400..+1620
// AltoTotal en Y               : -  45..+  60
// ProfundidadTotal en Z        : -  65..+  65    
//
// PREDEFINIDOS
// Las siguientes variables no deberian modificarse 
// SRAV_DefaultTexturaPrincipal        
//              Textura principal de la serpiente.
// SRAV_DefaultTexturaCabeza           
//              Textura para aplicar a la cabeza.  Origen en cabeza.
// SRAV_DefaultTexturaCornea           
//              Textura para aplicar a la cornea.
// SRAV_DefaultTexturaEsclerotida      
//              Textura para aplicar a la esclerotida.
// SRAV_DefaultTexturaIris             
//              Textura para aplicar al iris.
// SRAV_DefaultTexturaBoca             
//              Textura para aplicar a la boca. 
// SRAV_DefaultTexturaLengua           
//              Textura para aplicar a la lengua.  
//
// MODIFICADORES
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare LRAV_POV3_1         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare SRAV_TexturaPrincipal               = texture { ... }      
//      Textura principal de la serpiente.
// #declare SRAV_TexturaCabeza                  = texture { ... }     
//      Textura para aplicar a la cabeza.  Origen en cabeza.
// #declare SRAV_TexturaCornea                  = texture { ... }         
//      Textura para aplicar a la cornea.
// #declare SRAV_TexturaEsclerotida             = texture { ... }     
//      Textura para aplicar a la esclerotida.
// #declare SRAV_TexturaIris                    = texture { ... }         
//      Textura para aplicar al iris.
// #declare SRAV_TexturaBoca                    = texture { ... }           
//      Textura para aplicar a la boca.  Dificil de percibir, se aplica por diferencia. 
// #declare SRAV_TexturaLengua                  = texture { ... }        
//      Textura para aplicar a la lengua.  
//
// Para colocarlo sin giros
// #include "SRAV.inc"
// #declare MyArreglo   = [1][5] = {{SRAV_EjeCentral,0,0,0,off}}
// object { SRAV_Serpiente( MyArreglo, 0 ) }
//    
// Con la macro detallada.
// #include "SRAV.inc"
// #declare MyArreglo   = [1][5] = {{SRAV_EjeCentral,0,0,0,off}}
// object { SRAV_SerpienteReptilAnimalVivo( MyArreglo, 0,  
//              3.0, 0.06, 0.9, 0.1, 0.3, 0.015, 8, 0.05,        
//              SRAV_TexturaPrincipal, SRAV_TexturaCabeza,
//              SRAV_TexturaCornea, SRAV_TexturaEsclerotida, SRAV_TexturaIris, 
//              SRAV_TexturaBoca, SRAV_TexturaLengua ) }
//
// Otro ejemplo
// #include "SRAV.inc"
// #declare SRAV_TexturaCabeza             = texture       { pigment { Green } }
// #declare MyArreglo   = array [ 2 ][ 4 ]
//      { { SRAV_EjeCentral     , 0, 10, 0 },
//        { SRAV_EjeCentralD01  , 0,-10, 0 } }
// object       { SRAV_Serpiente( MyArreglo, 1.0 ) }
// 
#include "colors.inc"

#declare EjeMejorado            = true;
#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;  
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}   

#include "SRAV.inc"  

#declare MyArreglo      = array [55][5]
       {
         {SRAV_EjeCentral   , 0, -8, 0, on },
         {SRAV_EjeCentralD01, 0, -8, 0, on },
         {SRAV_EjeCentralD02, 0, -8, 0, on },
         {SRAV_EjeCentralD03, 0, -8, 0, on },
         {SRAV_EjeCentralD04, 0, -8, 0, on },
         {SRAV_EjeCentralD05, 0, -8, 0, on },
         {SRAV_EjeCentralD06, 0, -8, 0, on },
         {SRAV_EjeCentralD07, 0, 0, 0, on },
         {SRAV_EjeCentralD08, 0, 0, 0, on },
         {SRAV_EjeCentralD09, 0, 0, 0, on },
         {SRAV_EjeCentralD10, 0, 0, 0, on },
         {SRAV_EjeCentralD11, 0, 0, 0, on },
         {SRAV_EjeCentralD12, 0, 0, 0, on },
         {SRAV_EjeCentralD13, 0, 0, 0, on },
         {SRAV_EjeCentralD14, 0, 0, 0, on },
         {SRAV_EjeCentralD15, 0, 0, 0, on },
         {SRAV_EjeCentralD16, 0, 0, 0, on },
         {SRAV_EjeCentralD17, 0, 8, 3, on },
         {SRAV_EjeCentralD18, 0, 8, 3, on },
         {SRAV_EjeCentralD19, 0, 8, 3, on },
         {SRAV_EjeCentralD20, 0, 8, 3, on },
         {SRAV_EjeCentralD21, 0, 8, 3, on },
         {SRAV_EjeCentralD22, 0, 8, 3, on },
         {SRAV_EjeCentralD23, 0, 8, 3, on },
         {SRAV_EjeCentralD24, 0, 8,-3, on },
         {SRAV_EjeCentralD25, 0, 8,-3, on },
         {SRAV_EjeCentralD26, 0, 8,-3, on },
         {SRAV_EjeCentralD27, 0, 8,.3, on },
         {SRAV_EjeCentralP01, 0, 4, 0, on },
         {SRAV_EjeCentralP02, 0, 4, 0, on },
         {SRAV_EjeCentralP03, 0, 4, 0, on },
         {SRAV_EjeCentralP04, 0, 4, 0, on },
         {SRAV_EjeCentralP05, 0, 4, 0, on },
         {SRAV_EjeCentralP06, 0, 4, 0, on },
         {SRAV_EjeCentralP07, 0, 4, 0, on },
         {SRAV_EjeCentralP08, 0, 4, 0, on },
         {SRAV_EjeCentralP09, 0, 4, 0, on },
         {SRAV_EjeCentralP10, 0, 4, 0, on },
         {SRAV_EjeCentralP11, 0, 4, 0, on },
         {SRAV_EjeCentralP12, 0, 4, 0, on },
         {SRAV_EjeCentralP13, 0, 4, 0, on },
         {SRAV_EjeCentralP14, 0, 4, 0, on },
         {SRAV_EjeCentralP15, 0, 4, 0, on },
         {SRAV_EjeCentralP16, 0, 4, 0, on },
         {SRAV_EjeCentralP17, 0, 4, 0, on },
         {SRAV_EjeCentralP18, 0, 4, 0, on },
         {SRAV_EjeCentralP19, 0, 4, 0, on },
         {SRAV_EjeCentralP20, 0, 4, 0, on },
         {SRAV_EjeCentralP21, 0, 4, 0, on },
         {SRAV_EjeCentralP22, 0, 4, 0, on },
         {SRAV_EjeCentralP23, 0, 4, -10, on },
         {SRAV_EjeCentralP24, 0, 4, -10, on },
         {SRAV_EjeCentralP25, 0, 4, -10, on },
         {SRAV_EjeCentralP26, 0, 4, -10, on },
         {SRAV_EjeCentralP27, 0, 4, -10, on }
       }        

object                  {
  SRAV_Serpiente( MyArreglo, 1.0 )  
  rotate        80*y  
  rotate        -20*x
  translate     -0.4*z-0.6*x+0.1*y  
}

