// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 13 enero 2014
//                
// ADVERTENCIA:
// Por motivos de compatibilidad con POVRay 3.1.,
// se transcriben casi literalmente algunos procesos
// que se incluyen en versiones posteriores de POVRay de codigo libre
// La siguiente es la lista de dichos procesos.
// TCUV_AU1.inc           archivo original
// TCUV_Reorient_Trans    "transforms.inc"
//                              Reorient_Trans    autor John VanSickle
// TCUV_Axis_Rotate_Trans "transforms.inc"
//                              Axis_Rotate_Trans autor Rune S. Johansen
// TCUV_Shear_Trans       "transforms.inc"
//                              Shear_Trans       autor no indica...
// TCUV_Point_At_Trans    "transforms.inc"
//                              Point_At_Trans    autor no indica...
// TCUV_VPerp_To_Vector   "math.inc"
//                              VPerp_To_Vector   autor Tor Olav Kristensen
//
//*************************************************************************
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// TCUV TiendaCampanaUsoViajero
// Dibuja una tienda simple de campana para unas cuatro personas.
// Incluye macro para modificar caracteristicas basicas.
// La macro principal tiene dos parametros. 
//
// #macro TCUV_TiendaViajero( FraccionDerecha, FraccionIzquierda )                   
//      FraccionDerecha         : Fraccion de apertura lado derecho.  Use
//              0.0 para cerrado, 1.0 abierto.
//      FraccionIzquierda       : Fraccion de apertura lado izquierdo.  Use
//              0.0 para cerrado, 1.0 abierto.
//
// La Tienda se encuentra parcialmente centrada sobre el plano XY, aunque perfora
// el piso ligeramente.
//      Altura Maxima Y                 : 1530*L
//      Profundidad Y Estacas           : -225*L
//      Frente sin cuerdas X            : 2100*L
//      Frente con cuerdas X            : 3400*L   
//      Profundidad sin cuerdas Z       : 2100*L
//      Profundidad con cuerdas Z       : 2400*L    
// El piso de la tienda penetra ligeramente en el plano XY.  Gravedad Y-.
//
// La siguiente macro permite mayor control sobre las caractersticas.
// #macro TCUV_TiendaCampanaUsoViajero( FraccionDerecha, FraccionIzquierda, 
//   FrenteTienda, ProfundidadTienda, AltoTienda, SobrantePlano,
//   TexturaFrontal, TexturaLateral, TexturaPosterior, 
//   TexturaPiso, TexturaMetal, TexturaEstaca )   
//      FraccionDerecha         : Fraccion de apertura lado derecho.  Use
//              0.0 para cerrado, 1.0 abierto.
//      FraccionIzquierda       : Fraccion de apertura lado izquierdo.  Use
//              0.0 para cerrado, 1.0 abierto.
//      FrenteTienda            : Referencia para el frente X de la tienda. 
//              Default es 2000*L.
//      ProfundidadTienda       : Referencia para la profundidad Z de la tienda.
//              Default es 2000*L.
//      AltoTienda              : Referencia para el alto Y de la tienda.
//              Default es 1500*L.
//      SobrantePlano           : Referencia para el borde plano de la tienda.
//              Default es 50*L.
//      TexturaFrontal          : Textura a aplicar a la puerta.
//              Default es TCUV_TexturaFrontal.
//      TexturaLateral          : Textura a aplicar a los laterales.
//              Default es TCUV_TexturaLateral.
//      TexturaPosterior        : Textura a aplicar a la parte posterior.
//              Default es TCUV_TexturaPosterior.
//      TexturaPiso             : Textura a aplicar al piso.
//              Default es TCUV_TexturaPiso.
//      TexturaMetal            : Textura a aplicar a las barras de metal.
//              Default es TCUV_TexturaMetal.                            
//      TexturaEstaca           : Textura a aplicar a las estacas de tension.
//              Default es TCUV_TexturaEstaca.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// TCUV_DefaultTexturaFrontal          
//      Textura a aplicar a la puerta.
// TCUV_DefaultTexturaLateral          
//      Textura a aplicar a los laterales.
// TCUV_DefaultTexturaPosterior        
//      Textura a aplicar a la parte posterior.
// TCUV_DefaultTexturaPiso             
//      Textura a aplicar al piso.
// TCUV_DefaultTexturaMetal            
//      Textura a aplicar a las barras de metal.
// TCUV_DefaultTexturaEstaca           
//      Textura a aplicar a las estacas de tension.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare TCUV_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      Desaparece las cuerdas y las estacas no compatibles con POVRay 3.1.
// #declare TCUV_TexturaFrontal                         = texture { ... }      
//      Textura a aplicar a la puerta.
// #declare TCUV_TexturaLateral                         = texture { ... }        
//      Textura a aplicar a los laterales.
// #declare TCUV_TexturaPosterior                       = texture { ... }      
//      Textura a aplicar a la parte posterior.
// #declare TCUV_TexturaPiso                            = texture { ... }             
//      Textura a aplicar al piso.
// #declare TCUV_TexturaMetal                           = texture { ... }          
//      Textura a aplicar a las barras de metal.
// #declare TCUV_TexturaEstaca                          = texture { ... }           
//      Textura a aplicar a las estacas de tension.
//
// Para colocarlo simplemente
// #include "TCUV.inc"
// object        { TCUV_TiendaCampana( 0, 0 ) }
//
// Otro ejemplo con modificador
// #include "TCUV.inc"
// #declare TCUV_TexturaMetal       = texture       { PinkAlabaster }
// object        { TCUV_TiendaCampana( 0, 0 ) }
//
// Otro ejemplo con macro de texturas
// #include "TCUV.inc"
// #include "textures.inc"
// object                {
//   TCUV_TiendaCampanaUsoViajero( 0, 0, 2, 2, 1.5, 0.05, 
//      TCUV_TexturaFrontal, TCUV_TexturaLateral, TCUV_TexturaPosterior,
//      TCUV_TexturaPiso, TCUV_TexturaMetal, TCUV_TexturaEstaca )
// }
//
#include "TCUV_AU1.inc" 
#include "colors.inc" 
#include "metals.inc" 

#declare TCUV_L                                 = 0.001; 

#if ( version < 3.2 )
  #ifndef( TCUV_POV3_1 )
    #declare TCUV_POV3_1        = on;
  #end
#else
  #ifndef( TCUV_POV3_1 )
    #declare TCUV_POV3_1        = off;
  #end
#end
 
#if ( TCUV_POV3_1 )
#else 
  #include "TCUV_AU2.inc"  
#end

#declare TCUV_DefaultTexturaLateral                =
  texture               {   
    pigment             { 
      crackle
      #if ( !( TCUV_POV3_1 ) )
        form < 0.5, 0.2, 0.11 >
      #end  // #if
      turbulence        0.5
      scale             0.2
      pigment_map   {    
        [ 0.5 CadetBlue ]
        [ 0.5 ForestGreen     ]
      }       
    }
    normal              {   
      granite
      scale     10
    }                     
  }  
  
#ifndef ( TCUV_TexturaLateral )  
  #declare TCUV_TexturaLateral     = 
    texture { TCUV_DefaultTexturaLateral }
#end  // #ifndef ( TCUV_TexturaLateralTiendaViajero ) 
  
#declare TCUV_DefaultTexturaPosterior                =
  texture               {   
    TCUV_DefaultTexturaLateral
  }  
  
#ifndef ( TCUV_TexturaPosterior )  
  #declare TCUV_TexturaPosterior     = 
    texture { TCUV_DefaultTexturaPosterior }
#end  // #ifndef ( TCUV_TexturaPosterior ) 

#declare TCUV_DefaultTexturaFrontal                =
  texture               {   
    pigment     { DarkSlateGray }  
    normal      { waves turbulence 0.5 translate 2 scale 0.1 }
  }  
  
#ifndef ( TCUV_TexturaFrontal )  
  #declare TCUV_TexturaFrontal     = 
    texture { TCUV_DefaultTexturaFrontal }
#end  // #ifndef ( TCUV_TexturaFrontal ) 

#declare TCUV_DefaultTexturaPiso                =
  texture               { 
    pigment             {
      gradient x
      scale             0.05    
      turbulence        0.4  
      sine_wave
      pigment_map       { 
        [ 0   DarkGreen ]
        [ 1.0 Brown     ]
      }                     
    }                       
    normal              {
      gradient x
      scale             0.05    
      turbulence        0.4   
      sine_wave
    }
  }                      
  texture               { 
    pigment             {
      gradient y
      scale             0.05    
      turbulence        0.4   
      sine_wave
      pigment_map       { 
        [ 0   DarkGreen transmit 0.6 ]
        [ 1.0 Brown     transmit 0.6 ]
      }                     
    }                       
    normal              {
      gradient y
      scale             0.05    
      turbulence        0.4  
      sine_wave
    }
  }                      
  texture               { 
    pigment             { 
      boxed            
      pigment_map {    
        [ 0.01 rgbt 1.0 ]
        [ 0.01  DarkOliveGreen ]
      }
    }                         
    normal              {   
      dents
      scale             0.3
    }
  }
  
#ifndef ( TCUV_TexturaPiso )  
  #declare TCUV_TexturaPiso     = 
    texture { TCUV_DefaultTexturaPiso }
#end  // #ifndef ( TCUV_TexturaPiso ) 
 
#declare TCUV_DefaultTexturaMetal                =
  texture               {   
    T_Brass_1E
  }  
  
#ifndef ( TCUV_TexturaMetal )  
  #declare TCUV_TexturaMetal     = 
    texture { TCUV_DefaultTexturaMetal }
#end  // #ifndef ( TCUV_TexturaMetal ) 
  
#declare TCUV_DefaultTexturaEstaca                =
  texture               {   
    T_Brass_1E
  }  
  
#ifndef ( TCUV_TexturaEstaca )  
  #declare TCUV_TexturaEstaca     = 
    texture { TCUV_DefaultTexturaEstaca }
#end  // #ifndef ( TCUV_TexturaEstaca ) 
  
 
  
#declare TCUV_RedLateralTienda  = array [3][3][4]
  { { {
<-0.990, 0.000,-1.000>,<-1.000, 1.000, 0.000>,<on ,off,3>,<-1,-2.200,0.0015>
      },{
<-0.500, 0.500,-1.000>,<-1.000, 1.000, 0.000>,<on ,off,3>,<-1,-2.200,0.0015>
      },{
< 0.000, 1.000,-1.000>,<-1.000, 1.000, 0.000>,<off,off,1>,<-1,-2.200,0.0015>
      }
    },
    { {
<-1.000, 0.000, 0.000>,<-1.000, 1.000, 0.000>,<on ,off,3>,<-1,-2.200,0.0015>
      },{
<-0.400, 0.320, 0.100>,<-1.000, 1.000, 0.000>,<on ,off,3>,<-1,-2.200,0.0015>
      },{
< 0.000, 1.000, 0.000>,<-1.000, 1.000, 0.000>,<off,off,1>,<-1,-2.200,0.0015>
      }
    },
    { {
<-0.990, 0.000, 1.000>,<-1.000, 1.000, 0.000>,<off,off,3>,<-1,-2.200,0.0015>
      },{
<-0.500, 0.500, 1.000>,<-1.000, 1.000, 0.000>,<off,off,3>,<-1,-2.200,0.0015>
      },{
< 0.000, 1.000, 1.000>,<-1.000, 1.000, 0.000>,<off,off,1>,<-1,-2.200,0.0015>
      }
    }
  }
  
#declare TCUV_RedFrontalTienda  = array [3][3][4] 
  { { {
<-0.990, 0.000, 1.000>,< 0.000, 0.000, 1.000>,<on ,off,3>,<-1,-2.200,0.0015>
      },{
<-0.500, 0.000, 1.000>,< 0.000, 0.000, 1.000>,<on ,off,3>,<-1,-2.200,0.0015>
      },{
< 0.000, 0.000, 1.000>,< 0.000, 0.000, 1.000>,<off,off,1>,<-1,-2.200,0.0015>
      }
    },
    { {
<-0.750, 0.250, 1.000>,< 0.000, 0.000, 1.000>,<on ,off,3>,<-1,-2.200,0.0015>
      },{
<-0.300, 0.300, 0.900>,< 0.000, 0.000, 1.000>,<on ,off,3>,<-1,-2.200,0.0015>
      },{
< 0.000, 0.500, 1.000>,< 0.000, 0.000, 1.000>,<off,off,1>,<-1,-2.200,0.0015>
      }
    },
    { {
<-0.500, 0.500, 1.000>,< 0.000, 0.000, 1.000>,<off,off,3>,<-1,-2.200,0.0015>
      },{
<-0.250, 0.750, 1.000>,< 0.000, 0.000, 1.000>,<off,off,3>,<-1,-2.200,0.0015>
      },{
< 0.000, 1.000, 1.000>,< 0.000, 0.000, 1.000>,<off,off,1>,<-1,-2.200,0.0015>
      }
    }
  }
  
#declare TCUV_RedFrontalTiendaAbierta  = array [3][3][4] 
  { { {
<-0.990, 0.000, 1.000>,< 0.000, 0.000, 1.000>,<on ,off,3>,<-1,-2.200,0.0015>
      },{
<-0.950, 0.000, 0.700>,< 0.000, 0.000, 1.000>,<on ,off,3>,<-1,-2.200,0.0015>
      },{
<-0.900, 0.000, 1.000>,< 0.000, 0.000, 1.000>,<off,off,1>,<-1,-2.200,0.0015>
      }
    },
    { {
<-0.750, 0.250, 1.000>,< 0.000, 0.000, 1.000>,<on ,off,3>,<-1,-2.200,0.0015>
      },{
<-0.700, 0.200, 0.800>,< 0.000, 0.000, 1.000>,<on ,off,3>,<-1,-2.200,0.0015>
      },{
<-0.675, 0.200, 1.000>,< 0.000, 0.000, 1.000>,<off,off,1>,<-1,-2.200,0.0015>
      }
    },
    { {
<-0.500, 0.500, 1.000>,< 0.000, 0.000, 1.000>,<off ,off,3>,<-1,-2.200,0.0015>
      },{
<-0.250, 0.750, 1.000>,< 0.000, 0.000, 1.000>,<off,off,3>,<-1,-2.200,0.0015>
      },{
< 0.000, 1.000, 1.000>,< 0.000, 0.000, 1.000>,<off,off,1>,<-1,-2.200,0.0015>
      }
    }
  }
     
  

#macro TCUV_TiendaCampanaUsoViajero( FraccionDerecha, FraccionIzquierda, 
  FrenteTienda, ProfundidadTienda, AltoTienda, SobrantePlano,
  TexturaFrontal, TexturaLateral, TexturaPosterior, 
  TexturaPiso, TexturaMetal, TexturaEstaca )
  union                                 {    
    #local S                            = seed( 1000 );
    #local TelaLateral                  =
      union                             {   
        object                          {   
          TCUV_Red( TCUV_RedLateralTienda, "", off, -1 )
          scale             < FrenteTienda/2, AltoTienda, ProfundidadTienda/2 >
          texture                       { 
            TexturaLateral
          }
        }
      } 
    #local TelaPosterior                =
      union                             {   
        object                          {   
          TCUV_Red( TCUV_RedFrontalTienda, "", off, -1 )
          scale             < FrenteTienda/2, AltoTienda, ProfundidadTienda/2 >
          texture                       { 
            TexturaPosterior
          }
        }
      }
    #local TelaDerecha                  =
      union                             {
        #local FrontalDerecha  = array [3][3][4] 
        #local C                        = 0;
        #while ( C < 3 )                      
          #local D                      = 0;
          #while ( D < 3 )                    
            #local E                    = 0;
            #while ( E < 4 )                  
              #local FrontalDerecha[C][D][E]    = 
                 ( 1-FraccionDerecha )*TCUV_RedFrontalTienda[C][D][E]+ 
                 FraccionDerecha*TCUV_RedFrontalTiendaAbierta[C][D][E];
              #local E                  = E+1;
            #end
            #local D                    = D+1;
          #end
          #local C                      = C+1;
        #end  
        object                          {   
          TCUV_Red( FrontalDerecha, "", off, -1 )
          scale             < FrenteTienda/2, AltoTienda,-ProfundidadTienda/2 >
          texture                       { 
            TexturaFrontal
          }
        }
      }  
    #local TelaIzquierda                =
      union                             {
        #local FrontalIzquierda  = array [3][3][4] 
        #local C                        = 0;
        #while ( C < 3 )                      
          #local D                      = 0;
          #while ( D < 3 )                    
            #local E                    = 0;
            #while ( E < 4 ) 
              #if ( C= 0 )
                #local FrontalIzquierda[C][D][E]    = 
                   ( 1-FraccionIzquierda*FraccionIzquierda )*TCUV_RedFrontalTienda[C][D][E]+ 
                   FraccionIzquierda*FraccionIzquierda*TCUV_RedFrontalTiendaAbierta[C][D][E]; 
              #else               
                #local FrontalIzquierda[C][D][E]    = 
                   ( 1-FraccionIzquierda )*TCUV_RedFrontalTienda[C][D][E]+ 
                   FraccionIzquierda*TCUV_RedFrontalTiendaAbierta[C][D][E]; 
              #end     
              #local E                  = E+1;
            #end
            #local D                    = D+1;
          #end
          #local C                      = C+1;
        #end  
        object                          {   
          TCUV_Red( FrontalIzquierda, "", off, -1 )
          scale             < -FrenteTienda/2, AltoTienda,-ProfundidadTienda/2 >
          texture                       { 
            TexturaFrontal
          }
        }
      }
    #local TelaPiso                     =
      union                             {     
        difference                      {    
          superellipsoid                {  
            <0.1,0.05>
            rotate              90*x
            scale               < SobrantePlano+FrenteTienda/2, AltoTienda*0.001, SobrantePlano+ProfundidadTienda/2 >
          }
        }       
        texture                         {  
          TexturaPiso
          scale                 < FrenteTienda/2, AltoTienda/1.5, ProfundidadTienda/2 > 
        }
      }    
    #local CilindroSoporte              = 
      union                             {
        cylinder                            { 
          0, 0.99*AltoTienda*y, 0.005*ProfundidadTienda
        }
        cylinder                            { 
          0, 1.01*AltoTienda*y, 0.0025*ProfundidadTienda
        }
        texture                   {  
          TexturaMetal
        } 
      } 
     
      
    object                              { 
      TelaLateral
    }  
    object                              { 
      TelaLateral  
      scale                     <-1,1,1>
    }
    object                              {  
      TelaPosterior 
    }  
    object                              { 
      TelaPosterior  
      scale                     <-1,1,1>
    }   
    object                              {  
      TelaDerecha
    }
    object                              {  
      TelaIzquierda
    } 
    object                              {   
      TelaPiso
    }  
    cylinder                    {     
      -ProfundidadTienda/2*z, +ProfundidadTienda/2*z, 0.01*ProfundidadTienda
      translate         -FrenteTienda/2*x
      texture                           {  
        TexturaPiso
        scale                 < FrenteTienda/2, AltoTienda/1.5, ProfundidadTienda/2 > 
      }
    }              
    cylinder                    {     
      -ProfundidadTienda/2*z, +ProfundidadTienda/2*z, 0.01*ProfundidadTienda
      translate         +FrenteTienda/2*x
      texture                           {  
        TexturaPiso
        scale                 < FrenteTienda/2, AltoTienda/1.5, ProfundidadTienda/2 > 
      }
    }              
    cylinder                    {     
      -FrenteTienda/2*x, +FrenteTienda/2*x, 0.01*ProfundidadTienda
      translate         -ProfundidadTienda/2*z
      texture                           {  
        TexturaPiso
        scale                 < FrenteTienda/2, AltoTienda/1.5, ProfundidadTienda/2 > 
      }
    }              
    cylinder                    {     
      -FrenteTienda/2*x, +FrenteTienda/2*x, 0.01*ProfundidadTienda
      translate         +ProfundidadTienda/2*z
      texture                           {  
        TexturaPiso
        scale                 < FrenteTienda/2, AltoTienda/1.5, ProfundidadTienda/2 > 
     }
    }              
    union                       { 
      object                    {  
        CilindroSoporte
        translate         ( -ProfundidadTienda/2+0.01*ProfundidadTienda )*z
      }
      object                    {  
        CilindroSoporte
        translate         -( -ProfundidadTienda/2+0.01*ProfundidadTienda )*z
      }
    }            
              
    #local FS                   = 0.008;
    #if ( TCUV_POV3_1 )   
    #else 
      #local ArregloAmarre       = array [5]
         { <-5,0,0.5>*FS, <0,0,1>*FS, <1,0,0>*FS, <0,0,-1>*FS, <-5,0,-0.5>*FS } 
      #local ArregloAmarreNormal = array [5]
         { -y,-y,-x,y,y}  
      #local ArregloBallestrinque         = array [ 14 ]
        { <  0.0 ,-180  , -1.0  >*FS, <0,-90,-2>*FS, <  0   , -1.0 , -1.0  >*FS, 
          < -0.5 ,  0   , -1.0  >*FS, < -1.0 , +1.0 ,  0    >*FS, 
          < -1.0 ,  0   , +1.0  >*FS, < -1.0 , -1.0 ,  0    >*FS, 
          <  0   ,  0   , -2.0  >*FS, < +1.0 , +1.0 ,  0    >*FS, 
          < +1.0 ,  0   , +1.0  >*FS, < +1.0 , -1.0 ,  0    >*FS, 
          < +0.5 ,  0   , -1.0  >*FS, <  0   , +1.0 , -1.0  >*FS, 5*x*FS+6*y*FS+4.5*z*FS }    
      #local ArregloBallestrinqueNormal   = array [ 14 ]      
        { <  0   ,  0   ,  1    >, z, <  0   ,  0   ,  1    >,
          <  0.01,  0   ,  1    >, <  0   , -1   ,  0    >, 
          <  0   ,  0   , -1    >, <  0   ,  1   ,  0    >, 
          <  0   ,  0   ,  1    >, <  0   , -1   ,  0    >, 
          <  0   ,  0   , -1    >, <  0   ,  1   ,  0    >, 
          <  0.01,  0   ,  1    >, <  0   ,  0.01,  1    >, 
          <  0   ,  0   ,  1    > }
  
#local EstacaMetal         =
  union                         {   
    cylinder                    {  
      0, 1*y, 0.008
      translate               ( 0.05+0.02*sqrt( 2 ) )*y
    }
    #local C                    = 0;
    #while ( C < 3 )                  
      union                     { 
        cylinder                    { 
          -0.05*x, 0.05*x , 0.008
        } 
        difference              {   
          torus                 {   
            0.02, 0.008    
            rotate              90*x
          }
          plane                 {   
            x, 0
          } 
          plane                 {   
            x ,0
            rotate              -60*z
          }
          translate             0.05*x+0.02*y
        }
        translate               -( 0.05*sqrt( 3 )/3+0.02 )*y
        rotate                  C*120*z 
      }
      #local C                  = C+1;
    #end             
    translate               -2*( 0.05*sqrt( 3 )/3+0.02 )*y
    rotate                      180*x
    rotate                      90*y 
    scale                       0.25 
    texture                     {  
      TexturaEstaca
    } 
  }                                        
         
         
      #local AmarreBase          =  
        union                   {
          object                  {
            TCUV_Cuerda( TCUV_EstiloBallestrinque, 
                          ArregloAmarre, ArregloAmarreNormal, off ) 
          }  
          object                  {   
            EstacaMetal
            rotate              20
          }                    
          translate             +5*0.008*x           
          scale                 < FrenteTienda/2, AltoTienda/1.5, ProfundidadTienda/2 > 
        }     
      #local AmarreBalle        =   
        union                   {        
          object                  {  
            TCUV_Cuerda( TCUV_EstiloBallestrinque,
                          ArregloBallestrinque, ArregloBallestrinqueNormal, on )
            translate             -<  0.0 ,-180  , -1.0  >*FS              
            rotate                90*y 
            rotate                180*x 
            rotate                90*z                 
            #local AnguloBalle    = degrees( asin( 0.5*1.5/( 185*FS ) ) );  
            rotate                -AnguloBalle*z  
          }
          object                {
            EstacaMetal
            translate             < 180.0,-3  , 0 >*FS              
            rotate                -AnguloBalle*z  
          }                        
          scale                 < FrenteTienda/2, AltoTienda/1.5, ProfundidadTienda/2 >
        }
      union                     {
        #local C                = 0;
        #while ( C < 8 ) 
          object                  {  
            AmarreBase 
            rotate        -45*C*y 
            #switch ( C ) 
              #case ( 0 )
                translate       ( SobrantePlano+FrenteTienda/2 )*x
              #break
              #case ( 1 )
                translate       ( 0.6*SobrantePlano+FrenteTienda/2 )*x+
                                ( 0.6*SobrantePlano+ProfundidadTienda/2 )*z
              #break
              #case ( 2 )
                translate       ( SobrantePlano+ProfundidadTienda/2 )*z
              #break
              #case ( 3 )
                translate       -( 0.6*SobrantePlano+FrenteTienda/2 )*x+
                                ( 0.6*SobrantePlano+ProfundidadTienda/2 )*z
              #break
              #case ( 4 )
                translate       -( SobrantePlano+FrenteTienda/2 )*x
              #break
              #case ( 5 )
                translate       -( 0.6*SobrantePlano+FrenteTienda/2 )*x-
                                ( 0.6*SobrantePlano+ProfundidadTienda/2 )*z
              #break
              #case ( 6 )
                translate       -( SobrantePlano+ProfundidadTienda/2 )*z
              #break
              #case ( 7 )
                translate       ( 0.6*SobrantePlano+FrenteTienda/2 )*x-
                                ( 0.6*SobrantePlano+ProfundidadTienda/2 )*z
              #break
            #end          
          }   
          #local C              = C+1;        
        #end  
        #local C                = 0;
        #while ( C < 4 )
          object                {  
            AmarreBalle 
            rotate                5*y
            rotate                10*rand ( S )*y
            translate           0.25*FrenteTienda*x-0.5*ProfundidadTienda*z   
                                +0.5*AltoTienda*y
            #if ( mod( C, 2 ) = 0 ) 
              scale             <-1,1,1>
            #end
            #if ( div( C, 2 ) = 0 )    
              scale             <1,1,-1>
            #end                    
          } 
          #local C              = C+1;           
        #end  
      }   
    #end
    translate         +ProfundidadTienda*0.005*y
  }
#end  // #macro TCUV_TiendaCampanaUsoViajero() 

#macro TCUV_TiendaViajero( FraccionDerecha, FraccionIzquierda )                   
  union                         {   
    #local L                    = TCUV_L;
    #local FrenteTienda         = 2000*L;                                       
    #local ProfundidadTienda    = 2000*L;
    #local AltoTienda           = 1500*L;                        
    #local SobrantePlano        = 50*L; 
    TCUV_TiendaCampanaUsoViajero( FraccionDerecha, FraccionIzquierda,  
      FrenteTienda, ProfundidadTienda, AltoTienda, SobrantePlano,
      TCUV_TexturaFrontal,
      TCUV_TexturaLateral,
      TCUV_TexturaPosterior,
      TCUV_TexturaPiso, 
      TCUV_TexturaMetal,
      TCUV_TexturaEstaca )
  }  // union
#end  // #macro TCUV_TiendaViajero()