// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 13 enero 2014
//                
// ADVERTENCIA:
// Por motivos de compatibilidad con POVRay 3.1.,
// se transcriben casi literalmente algunos procesos
// que se incluyen en versiones posteriores de POVRay de codigo libre
// La siguiente es la lista de dichos procesos.
// TCUV_AU1.inc           archivo original
// TCUV_Reorient_Trans    "transforms.inc"
//                              Reorient_Trans    autor John VanSickle
// TCUV_Axis_Rotate_Trans "transforms.inc"
//                              Axis_Rotate_Trans autor Rune S. Johansen
// TCUV_Shear_Trans       "transforms.inc"
//                              Shear_Trans       autor no indica...
// TCUV_Point_At_Trans    "transforms.inc"
//                              Point_At_Trans    autor no indica...
// TCUV_VPerp_To_Vector   "math.inc"
//                              VPerp_To_Vector   autor Tor Olav Kristensen
//
//*************************************************************************
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// TCUV TiendaCampanaUsoViajero
// Dibuja una tienda simple de campana para unas cuatro personas.
// Incluye macro para modificar caracteristicas basicas.
// La macro principal tiene dos parametros. 
//
// #macro TCUV_TiendaViajero( FraccionDerecha, FraccionIzquierda )                   
//      FraccionDerecha         : Fraccion de apertura lado derecho.  Use
//              0.0 para cerrado, 1.0 abierto.
//      FraccionIzquierda       : Fraccion de apertura lado izquierdo.  Use
//              0.0 para cerrado, 1.0 abierto.
//
// La Tienda se encuentra parcialmente centrada sobre el plano XY, aunque perfora
// el piso ligeramente.
//      Altura Maxima Y                 : 1530*L
//      Profundidad Y Estacas           : -225*L
//      Frente sin cuerdas X            : 2100*L
//      Frente con cuerdas X            : 3400*L   
//      Profundidad sin cuerdas Z       : 2100*L
//      Profundidad con cuerdas Z       : 2400*L    
// El piso de la tienda penetra ligeramente en el plano XY.  Gravedad Y-.
//
// La siguiente macro permite mayor control sobre las caractersticas.
// #macro TCUV_TiendaCampanaUsoViajero( FraccionDerecha, FraccionIzquierda, 
//   FrenteTienda, ProfundidadTienda, AltoTienda, SobrantePlano,
//   TexturaFrontal, TexturaLateral, TexturaPosterior, 
//   TexturaPiso, TexturaMetal, TexturaEstaca )   
//      FraccionDerecha         : Fraccion de apertura lado derecho.  Use
//              0.0 para cerrado, 1.0 abierto.
//      FraccionIzquierda       : Fraccion de apertura lado izquierdo.  Use
//              0.0 para cerrado, 1.0 abierto.
//      FrenteTienda            : Referencia para el frente X de la tienda. 
//              Default es 2000*L.
//      ProfundidadTienda       : Referencia para la profundidad Z de la tienda.
//              Default es 2000*L.
//      AltoTienda              : Referencia para el alto Y de la tienda.
//              Default es 1500*L.
//      SobrantePlano           : Referencia para el borde plano de la tienda.
//              Default es 50*L.
//      TexturaFrontal          : Textura a aplicar a la puerta.
//              Default es TCUV_TexturaFrontal.
//      TexturaLateral          : Textura a aplicar a los laterales.
//              Default es TCUV_TexturaLateral.
//      TexturaPosterior        : Textura a aplicar a la parte posterior.
//              Default es TCUV_TexturaPosterior.
//      TexturaPiso             : Textura a aplicar al piso.
//              Default es TCUV_TexturaPiso.
//      TexturaMetal            : Textura a aplicar a las barras de metal.
//              Default es TCUV_TexturaMetal.                            
//      TexturaEstaca           : Textura a aplicar a las estacas de tension.
//              Default es TCUV_TexturaEstaca.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// TCUV_DefaultTexturaFrontal          
//      Textura a aplicar a la puerta.
// TCUV_DefaultTexturaLateral          
//      Textura a aplicar a los laterales.
// TCUV_DefaultTexturaPosterior        
//      Textura a aplicar a la parte posterior.
// TCUV_DefaultTexturaPiso             
//      Textura a aplicar al piso.
// TCUV_DefaultTexturaMetal            
//      Textura a aplicar a las barras de metal.
// TCUV_DefaultTexturaEstaca           
//      Textura a aplicar a las estacas de tension.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare TCUV_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      Desaparece las cuerdas y las estacas no compatibles con POVRay 3.1.
// #declare TCUV_TexturaFrontal                         = texture { ... }      
//      Textura a aplicar a la puerta.
// #declare TCUV_TexturaLateral                         = texture { ... }        
//      Textura a aplicar a los laterales.
// #declare TCUV_TexturaPosterior                       = texture { ... }      
//      Textura a aplicar a la parte posterior.
// #declare TCUV_TexturaPiso                            = texture { ... }             
//      Textura a aplicar al piso.
// #declare TCUV_TexturaMetal                           = texture { ... }          
//      Textura a aplicar a las barras de metal.
// #declare TCUV_TexturaEstaca                          = texture { ... }           
//      Textura a aplicar a las estacas de tension.
//
// Para colocarlo simplemente
// #include "TCUV.inc"
// object        { TCUV_TiendaCampana( 0, 0 ) }
//
// Otro ejemplo con modificador
// #include "TCUV.inc"
// #declare TCUV_TexturaMetal       = texture       { PinkAlabaster }
// object        { TCUV_TiendaCampana( 0, 0 ) }
//
// Otro ejemplo con macro de texturas
// #include "TCUV.inc"
// #include "textures.inc"
// object                {
//   TCUV_TiendaCampanaUsoViajero( 0, 0, 2, 2, 1.5, 0.05, 
//      TCUV_TexturaFrontal, TCUV_TexturaLateral, TCUV_TexturaPosterior,
//      TCUV_TexturaPiso, TCUV_TexturaMetal, TCUV_TexturaEstaca )
// }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}            

#include "TCUV.inc"   

object                  {  
  TCUV_TiendaViajero(0.5,0.75) 
  translate             -0.75*y+2*z  
}

