// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 30 septiembre 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//
// TDEP TiraderaDEPuerta
// El archivo dibuja tiraderas de puerta y/o gaveta simples.
// Las macros son muy poco flexibles, pero permiten cambiar la textura.
// Es compatible con POVRay 3.1.
// Para el diseno de los cinco objetos se utilizo inicialmente el programa
// Epspline.exe para Windows.  
//
// El paquete incluye cinco macros, con parametro de textura.  Se ofrecen
// texturas recomendadas.  
// La macro para la base de tiraderas.
// #macro TDEP_BaseTirador( TexturaAplicar ) 
//      TexturaAplicar          : Textura a aplicar al objeto.
//              Sugerencia : TDEP_TexturaBaseTirador.
//
// La macro para la tiradera circular con decorado abierto interior.                                         
// #macro TDEP_TiraderaCircularAbierta
//   ( TexturaCirculoExterno, TexturaDecorado, TexturaCilindro )
//      TexturaCirculoExterno   : Textura para el diametro mayor.
//              Sugerencia : TDEP_TexturaTiraderaCircularAbiertaA.
//      TexturaDecorado         : Textura para el decorado central.
//              Sugerencia : TDEP_TexturaTiraderaCircularAbiertaB.
//      TexturaCilindro         : Textura para el cilindro soporte.
//              Sugerencia : TDEP_TexturaTiraderaCircularAbiertaC.
// 
// La macro para la tiradera larga con estructura estilo lathe.                                                                 
// #macro TDEP_TiraderaLathe( TexturaAplicar )                
//      TexuraAplicar           : Textura para aplicar al objeto.
//              Sugerencia : TDEP_TexturaTiraderaLathe.
//   
// Para crear una tiradera circular corriente.
// #macro TDEP_TiraderaBasica( TexturaAplicar )
//      TexturaAplicar          : Textura de la estructura.
//              Sugerencia : TDEP_TexturaTiraderaBasica.
// 
// Para crear una tiradera alargada simple con poco relieve.
// #macro TDEP_TiraderaLargaBasica( TexturaAplicar )
//      TexturaAplicar          : Textura para aplicar a la estructura.
//              Sugerencia : TDEP_TexturaTiraderaLargaBasica.
//   
// Las dimensiones de los objetos son :
// BaseTiradera
//      Largo                   :  71.5*L
//      Frente                  :  21.5*L
//      Profundidad             :   0.7*L
// TiraderaCircularAbierta
//      DiametroMayor           :  33.6*L
//      Profundidad             :  15.5*L
//      ProfundidadAgarre       :  14.0*L
//      DiametroAgarre          :   5.0*L 
// Tiradera Lathe
//      Largo                   :  80.0*L
//      Ancho                   :   7.0*L
//      Profundidad             :  12.0*L
//      Profundidad Base        :   8.0*L
// Tiradera Basica
//      DiametroAgarre          :  33.0*L
//      AltoAgarre              :  14.5*L   
// Tiradera Larga Basica
//      Larga                   :  86.0*L
//      Ancho                   :  13.0*L
//      Profundidad             :  17.0*L
// Todos los objetos anteriores descansan sobre el plano XZ, centrados en el origen.
// Y sobresalen hacia Z-.  La dimensin larga, si existe, en el eje Y. 
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse.
// #declare TDEP_TexturaBaseTirador
//      Textura sugerida para la macro TDEP_BaseTirador.
// #declare TDEP_TexturaTiraderaCircularAbiertaA      
//      Textura sugerida para el primer parametro macro TDEP_TiraderaCircularAbierta.
// #declare TDEP_TexturaTiraderaCircularAbiertaB 
//      Textura sugerida para el segundo parametro macro TDEP_TiraderaCircularAbierta.
// #declare TDEP_TexturaTiraderaCircularAbiertaC                         
//      Textura sugerida para el tercer parametro macro TDEP_TiraderaCircularAbierta.
// #declare LSLE_TexturaTiraderaLathe
//      Textura sugerida para la macro TDEP_TiraderaLathe.
// #declare LSLE_TexturaTiraderaBasica
//      Textura sugerida para la macro TDEP_TiraderaBasica.
// #declare LSLE_TexturaTiraderaLargaBasica
//      Textura sugerida para la macro TDEP_TiraderaLargaBasica.
//   
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare TDEO_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
//
// Para colocarlo simplemente
//
// #include "TDEP.inc"
//  object                  {
//    TDEP_BaseTirador( TDEP_TexturaBaseTirador ) 
//  }
//
//  o bien... 
//  #include "TDEP.inc"
//  object                  {
//    TDEP_TiraderaCircularAbierta( 
//      TDEP_TexturaTiraderaCircularAbiertaA,
//      TDEP_TexturaTiraderaCircularAbiertaB,
//      TDEP_TexturaTiraderaCircularAbiertaC )
//  }
//
//  o bien... 
//  #include "TDEP.inc"
//  object                  {
//    TDEP_TiraderaLathe( TDEP_TexturaTiraderaLathe )  
//  }
//
//  o bien... 
//  #include "TDEP.inc"
//  object                  {
//    TDEP_TiraderaBasica( TDEP_TexturaTiraderaBasica )
//  }
//
//  o bien... 
//  #include "TDEP.inc"
//  object                          {
//    TDEP_TiraderaLargaBasica( TDEP_TexturaTiraderaLargaBasica )
//  }
//

#include "colors.inc"

#local OjoAbsoluto            = 256;
#local VecesCentroAbsoluto    = 10;     
#local L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}   
 

#include "TDEP.inc"

#local FactorAcercamiento       = 10;
  
union                           {  
  object                  {
    TDEP_BaseTirador( TDEP_TexturaBaseTirador ) 
    translate             -50*L*( x+0.5*y )
  } 
  object                  {
    TDEP_TiraderaCircularAbierta( 
      TDEP_TexturaTiraderaCircularAbiertaA,
      TDEP_TexturaTiraderaCircularAbiertaB,
      TDEP_TexturaTiraderaCircularAbiertaC )
    translate             -50*L*( x-0.8*y )
  }
  object                  {
    TDEP_TiraderaLathe( TDEP_TexturaTiraderaLathe )  
    translate             -50*L*(-x-0.5*y )
  }
  object                  {
    TDEP_TiraderaBasica( TDEP_TexturaTiraderaBasica )
    translate             -50*L*(-x+0.8*y )
  }
  object                          {
    TDEP_TiraderaLargaBasica( TDEP_TexturaTiraderaLargaBasica )
  }
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z         
}

