// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 9 Diciembre 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//                      
// ZGON ZanahoriaGeneticamenteOriginalNaturaleza
// El archivo dibuja una zanahoria corriente.
// Muy poco flexible, se incluye en diez variantes.
// La version original de las zanahorias, se desarrollo en Blob Sculptor 2.0b para DOS.
//      
// La siguiente macro dibuja las zanahorias con textura default:
// #macro ZGON_Zanahoria( Selector )
//      Selector                : Permite elegir entre diez estilos de zanahoria.
//              ZGON_Zanahoria1  = 1
//              ZGON_Zanahoria2  = 2
//              ZGON_Zanahoria3  = 3
//              ZGON_Zanahoria4  = 4
//              ZGON_Zanahoria5  = 5
//              ZGON_Zanahoria6  = 6
//              ZGON_Zanahoria7  = 7
//              ZGON_Zanahoria8  = 8
//              ZGON_Zanahoria9  = 9
//              ZGON_Zanahoria10 = 10
//   
// Las dimensiones de las zanahorias son algo irregulares :
//      Largo Y                 : 125*L muy variable
//      Radio                   :  10*L muy variable
//      Punto Maximo Y          :   5*L variable  
// El objeto se orienta en el Eje Y, gravedad Y-.
//              
// La siguiente macro permite modificar las texturas:
// #macro ZGON_ZanahoriaGeneticamenteOriginalNaturaleza
//              ( Selector, TexturaZanahoria, TexturaTallo )
//      Selector                : Permite elegir entre diez estilos de zanahoria.
//              ZGON_Zanahoria1  = 1
//              ZGON_Zanahoria2  = 2
//              ZGON_Zanahoria3  = 3
//              ZGON_Zanahoria4  = 4
//              ZGON_Zanahoria5  = 5
//              ZGON_Zanahoria6  = 6
//              ZGON_Zanahoria7  = 7
//              ZGON_Zanahoria8  = 8
//              ZGON_Zanahoria9  = 9
//              ZGON_Zanahoria10 = 10
//      TexturaZanahoria        : Textura principal de la zanahoria.
//      TexturaTallo            : Textura a aplicar al tallito.
//                                                     
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse.
// #declare ZGON_DefaultTexturaZanahoria         
//      Textura principal de la zanahoria.
// #declare ZGON_DefaultTexturaTallo       
//      Textura del tallito.
//   
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare ZGON_TexturaZanahoria                       = texture { ... }
//      Textura principal de la zanahoria.
// #declare ZGON_TexturaTallo                           = texture { ... }     
//      Textura del tallito.
// #declare ZGON_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
//
// Para colocarlo simplemente
//
// #include "ZGON.inc"
// object                  {
//   ZGON_Zanahoria( ZGON_Zanahoria1 ) 
// }
//
// o bien la misma figura anterior con macro detallada 
// #include "ZGON.inc"
// object                  {  
//   ZGON_ZanahoriaGeneticamenteOriginalNaturaleza
//              ( ZGON_Zanahoria1, PinkAlabaster, PinkAlabaster ) 
// }
//   
// o bien los modificadores
// #include "EBPH.inc"
// #declare ZGON_TexturaZanahoria = PinkAlabster
// object               { 
//   ZGON_Zanahoria( ZGON_Zanahoria1 )
// } 
//
#include "colors.inc"
           
#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}           

#include "ZGON.inc"
#local FactorAcercamiento               = 4;

union                   {
  object                  {
    ZGON_Zanahoria(ZGON_Zanahoria1) 
    translate           -0.10*x+0.10*y         
  }
  object                  {
    ZGON_Zanahoria(ZGON_Zanahoria2) 
    translate           -0.00*x+0.10*y         
  }
  object                  {
    ZGON_Zanahoria(ZGON_Zanahoria3) 
    translate           +0.10*x+0.10*y         
  }
  object                  {
    ZGON_Zanahoria(ZGON_Zanahoria4) 
    translate           -0.15*x         
  }
  object                  {
    ZGON_Zanahoria(ZGON_Zanahoria5) 
    translate           -0.05*x         
  }
  object                  {
    ZGON_Zanahoria(ZGON_Zanahoria6) 
    translate           +0.05*x         
  }
  object                  {
    ZGON_Zanahoria(ZGON_Zanahoria7) 
    translate           +0.15*x         
  }
  object                  {
    ZGON_Zanahoria(ZGON_Zanahoria8) 
    translate           -0.10*x-0.10*y         
  }
  object                  {
    ZGON_Zanahoria(ZGON_Zanahoria9) 
    translate           -0.00*x-0.10*y         
  }
  object                  {
    ZGON_Zanahoria(ZGON_Zanahoria10) 
    translate           +0.10*x-0.10*y         
  }
  translate             +0.05*y         
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z         

}



